clear
set mem 100m

global ezdata = "/rdcprojects/mc1/mc00535/data/ezdata/"

* Merge city vars
use "$ezdata/blocklevel_admdata.dta", clear
keep if keep_1990geography==1
drop if assigned_tract==.
collapse progid_cons progid_power progname program1995 program1999 program2001 application_tract assigned_tract black_city_* crime_total_city_* manufacture_city_* pctgov_city_* population_city_*, by(tract1990 city) fast
replace application_tract = 1 if application_tract>0.5 & application_tract <.
replace application_tract = 0 if application_tract <=0.5
reshape long black_city_ crime_total_city_ manufacture_city_ pctgov_city_ population_city_, i(tract1990 progid_cons progid_power progname program1995 program1999 program2001 application_tract assigned_tract city) j(year)
ren black_city_ black_city
ren crime_total_city_ crime_total_city
ren manufacture_city_ manufacture_city
ren pctgov_city_ pctgov_city
ren population_city_ population_city
ren tract1990 tractid90
drop if year==1970
duplicates tag tractid90 year, gen(tag)
drop if city=="East St. Louis city" & tag==1
drop tag
order tractid90 year 
sort tractid90 year 
save "$ezdata/admin4merge.dta", replace

