clear mata
clear
set mem 400m
use "/rdcprojects/mc1/mc00535/data/ezdata/city_level_data.dta", clear
 keep if year==3
 keep tractid city true_city ncity 
 sort tractid 
 tempfile city
 save `city', replace

 use "/rdcprojects/mc1/mc00535/data/CTRF/CTRF.dta", clear
 sort tractid
 joinby tractid using `city', unmatched(both)
 tab _m
 drop _m


 collapse (mean) pop90 (max) pct90pop, by(tractid90 ncity)
 drop pop90
 drop if ncity=="" 
 
 duplicates tag tractid90 , gen(tag)
 tab tag
 egen max = max(pct90pop) if tag>0, by(tractid90)

 gen keep = 0
 replace keep = 1 if tag==0
 replace keep = 1 if tag>0 & max==pct90pop


 keep if keep ==1
 drop keep tag
 duplicates tag tractid90 , gen(tag)
 tab tag
 
 gen city = reverse(substr(reverse(ncity),1,4))
 gen city_dum = 1 if city=="city" | city=="City"
 replace city_dum = 0 if city_dum==.

 drop max
 egen max = max(city_dum), by(tractid90)

 gen keep = 0
 replace keep = 1 if tag==0
 replace keep = 1 if max==city_dum
 replace keep = 1 if max==0
 keep if keep==1

 drop keep tag
 duplicates tag tractid90 , gen(tag)
 tab tag

 sort tractid90 
 by tractid90 : gen keep = 1 if _n==1
 keep if keep==1

drop keep tag
duplicates tag tractid90 , gen(tag)
tab tag

drop max tag city city_dum pct90pop 

sort tractid90

save "/rdcprojects/mc1/mc00535/data/ezdata/cities.dta", replace
