# This file submits the codes that process the decennial data

# These programs create extracts from the raw state-level Decennial SAS files.
# For each state-year, variables are extracted from a person file, a household file, and a geography file.
# The results are then saved and written to a single stata dataset per state-year. 
nohup sas /rdcprojects/mc1/mc00535/programs_organize/2.data/2.Decennial/1a.Create_Decennial_Extract1980.sas
nohup sas /rdcprojects/mc1/mc00535/programs_organize/2.data/2.Decennial/1b.Create_Decennial_Extract1990.sas
nohup sas /rdcprojects/mc1/mc00535/programs_organize/2.data/2.Decennial/1c.Create_Decennial_Extract2000.sas

# These programs take the result of the raw state-year extracts and perform recodes.
# Administrative variables are merged on by place of residence and by place of work at the end of the program
# These programs output one file per state-year
nohup stata-se -b do /rdcprojects/mc1/mc00535/programs_organize/2.data/2.Decennial/2a.Recode_Decennial_Extract1980.do
nohup stata-se -b do /rdcprojects/mc1/mc00535/programs_organize/2.data/2.Decennial/2b.Recode_Decennial_Extract1990.do
nohup stata-se -b do /rdcprojects/mc1/mc00535/programs_organize/2.data/2.Decennial/2c.Recode_Decennial_Extract2000.do

# This program estimates the probability that an employed person has a valid non-allocated place of work and creates corresponding IPWs.
nohup stata-se -b do /rdcprojects/mc1/mc00535/programs_organize/2.data/2.Decennial/3.Create_POW_Missingness_Weights.do

# For each state-year-(POW/POR), merge on pow-missingness IPWs and resave
nohup stata-se -b do /rdcprojects/mc1/mc00535/programs_organize/2.data/2.Decennial/4.Add_POW_Missingness_Weights_to_Statefiles.do POR 1980 &
nohup stata-se -b do /rdcprojects/mc1/mc00535/programs_organize/2.data/2.Decennial/4.Add_POW_Missingness_Weights_to_Statefiles.do POR 1990 &
nohup stata-se -b do /rdcprojects/mc1/mc00535/programs_organize/2.data/2.Decennial/4.Add_POW_Missingness_Weights_to_Statefiles.do POR 2000

nohup stata-se -b do /rdcprojects/mc1/mc00535/programs_organize/2.data/2.Decennial/4.Add_POW_Missingness_Weights_to_Statefiles.do POW 1980 &
nohup stata-se -b do /rdcprojects/mc1/mc00535/programs_organize/2.data/2.Decennial/4.Add_POW_Missingness_Weights_to_Statefiles.do POW 1990 &
nohup stata-se -b do /rdcprojects/mc1/mc00535/programs_organize/2.data/2.Decennial/4.Add_POW_Missingness_Weights_to_Statefiles.do POW 2000





