libname DEC1980 "/decennial/1980cen/1980S/microdata";
libname DEC1990 "/decennial/1990cen/1990S/microdata";
libname DEC2000 "/decennial/2000cen/microdata";
libname CBRF "/rdcprojects/mc1/mc00535/data/CBRF";
libname OUTDATA "/rdcprojects/mc1/mc00535/data/decennial/01-Raw_Extracts";


**** Include savastata macro for exporting to stata;
%include "/public/programs/sas/savastata.mac";

**** Write state abbreviations (for states with sample_main=1, assigned_tract in {0,1})
**** to a vector of local macros that can be looped over;

%let state1 = al;
%let state2 = ak;
%let state3 = az;
%let state4 = ar;
%let state5 = ca;
%let state6 = co;
%let state7 = ct;
%let state8 = de;
%let state9 = dc;
%let state10 = fl;
%let state11 = ga;
%let state12 = hi;
%let state13 = id;
%let state14 = il;
%let state15 = in;
%let state16 = ia;
%let state17 = ks;
%let state18 = ky;
%let state19 = la;
%let state20 = me;
%let state21 = md;
%let state22 = ma;
%let state23 = mi;
%let state24 = mn;
%let state25 = ms;
%let state26 = mo;
%let state27 = mt;
%let state28 = ne;
%let state29 = nv;
%let state30 = nh;
%let state31 = nj;
%let state32 = nm;
%let state33 = ny;
%let state34 = nc;
%let state35 = nd;
%let state36 = oh;
%let state37 = ok;
%let state38 = or;
%let state39 = pa;
%let state40 = ri;
%let state41 = sc;
%let state42 = sd;
%let state43 = tn;
%let state44 = tx;
%let state45 = ut;
%let state46 = vt;
%let state47 = va;
%let state48 = wa;
%let state49 = wv;
%let state50 = wi;
%let state51 = wy;


%let statenum1 = 01;
%let statenum2 = 02;
%let statenum3 = 04;
%let statenum4 = 05;
%let statenum5 = 06;
%let statenum6 = 08;
%let statenum7 = 09;
%let statenum8 = 10;
%let statenum9 = 11;
%let statenum10 = 12;
%let statenum11 = 13;
%let statenum12 = 17;
%let statenum13 = 18;
%let statenum14 = 19;
%let statenum15 = 20;
%let statenum16 = 21;
%let statenum17 = 22;
%let statenum18 = 24;
%let statenum19 = 25;
%let statenum20 = 26;
%let statenum21 = 27;
%let statenum22 = 28;
%let statenum23 = 29;
%let statenum24 = 31;
%let statenum25 = 32;
%let statenum26 = 33;
%let statenum27 = 34;
%let statenum28 = 35;
%let statenum29 = 36;
%let statenum30 = 37;
%let statenum31 = 39;
%let statenum32 = 40;
%let statenum33 = 41;
%let statenum34 = 42;
%let statenum35 = 44;
%let statenum36 = 45;
%let statenum37 = 47;
%let statenum38 = 48;
%let statenum39 = 49;
%let statenum40 = 51;
%let statenum41 = 53;
%let statenum42 = 54;
%let statenum43 = 55;


**** Define lists of variables to keep;
%let keepvarsP = 
  bcseq hseq QSFN PERN POV PWT QAGE QANCESCODE1 QANCESCODE2 QATTEND QCITIZEN QCOMMUTE QCTIME
  QHIGH QINCTOT QIND QLANGCODE QMIGCO QMIG QMIGST QREL
  QMS QOCC QCOW QPOBST QPOWCO QPOWST QPOWTRACT QPOWBKN RACEW RACEB RACEAIAN RACEASIAN RACENHPI RACESOR 
  QSEX SPANLONG QWKLWK QWKLYRHR
  ESR QWKLYRWK QINCWG QINCPA QINCSS QINCSSI QINCRET QINCOTH gq00
  HHT SMOVEIN
                          FAGE FANCESTRY FATTEND FCITIZEN FCOMMUTE FCTIME
  FHIGH FINCTOT FIND FLANGCODE FMIGCO FMIG FMIGST
  FMS FOCC FCOW FPOB FPOWCO FPOWST FPOWTRACT FRACE FSEX FSPAN FWKLYRHR
  FESR FWKLYRWK FINCWG FINCPA FMOVEIN ;
%let keepvarsH = hseq bcseq HWT SRENT SROOM SVALUE SYRBLT STENURE FINC HINC
                 SBEDRM SCPLUMB SCKITCH NOC SISVAC
                                FRENT FROOM FVALUE FYRBLT FTENURE FINC HINC
                 FBEDRM FCPLUMB FCKITCH FSISVAC;
%let keepvarsG = bcseq state county tract block blockid00;


%macro loops;
%do st = 1 %to 51 ;

data work.&&state&st  (keep = hseq &keepvarsP);
set DEC2000.sedf&&state&st..03 DEC2000.sedf&&state&st..05 (in=ingq);

gq00 = ingq;

label bcseq = 'Sequential Block ID'
      hseq = 'Sequential Household ID'
      PERN = 'Persons Total Earnings'
      POV = 'Person Poverty Status'
      PWT = 'Persons Weight'
      QAGE = 'Age'
      QANCESCODE1 = 'First Ancestry Code'
      QANCESCODE2 = 'Second Ancestry Code'
      QATTEND = 'School Enrollment (Attended School Since February 1, 2000)'
      QCITIZEN = 'Citizenship Status'
      QCOMMUTE = 'Means of Transportation to Work'
      QCTIME = 'Travel Time to Work (Minutes)'
      QHIGH = 'Educational Attainment'
      QINCINT = 'Interest Income in 1999'
      QINCOTH = 'Other Income in 1999'
      QINCPA = 'Public Assistance Income in 1999'
      QINCRET = 'Retirement Income in 1999'
      QINCSE = 'Self-employment Income in 1999'
      QINCSS = 'Social Security Income in 1999'
      QINCWG = 'Wages/Salary Income in 1999'
      QIND = 'Industry Code'
      QLANGCODE = 'Language Spoken'
      QMIGCO = 'Migration County Code'
      QMIG = 'Mobility Status'
      QMIGST = 'Migration State or Foreign Country Code'
      QMS = 'Marital Status'
      QOCC = 'Occupation Code'
      QPOBST = 'Place of Birth Code'
      QPOWCO = 'Place of Work County Code'
      QPOWST = 'Place of Work State Code'
      QPOWTRACT = 'Place of Work Tract Code'
      QPOWBKN = 'Place of Work Block Code'
      QRACE1 = 'First Race Code'
      QSEX = 'Sex'
      QSPAN = 'Hispanic Origin Code'
      QWKLWK = 'Do Any Work Last Week?'
      QWKLYRHR = 'Usual Hours Worked Last Year'
      gq00 = 'Group Quarters Flag' ;

run;


proc sort data = work.&&state&st;
by hseq;
run;


data work.&&state&st (keep = &keepvarsP &keepvarsH);
merge work.&&state&st (in=inp) DEC2000.sedf&&state&st..02 (in = inh);
by hseq;


household_record = 0;
if (inp = 1) or (inh=1) then household_record = 1;
if household_record = 1;

label hseq = 'Sequential Household ID'
      HWT = 'Housing Weight'
      SRENT = 'Q: What is the monthly rent?'
      SROOM = 'Q: How many rooms do you have in this…?'
      SVALUE = 'Q: What is the value of this property?'
      SYRBLT = 'Q: About when was this building first built?'
      STENURE = 'Tenure'
      FINC = 'Total Family Income'
      HINC = 'Total Household Income';

run;


proc sort data = work.&&state&st;
by bcseq;
run;

data work.&&state&st (keep = &keepvarsP &keepvarsH &keepvarsG insample inpowsample in5pctoutside);
merge work.&&state&st (in=inp) DEC2000.sedf&&state&st..01 (in = ing);
by bcseq;

household_record = 0;
if (inp = 1) then household_record = 1;
if household_record = 1;

blockid00 = "               ";
blockid00 = state||county||tract||block;

***** Keep only if respondent resides or works in a 
***** county appearing on block level admin data file;
insample = 0;
if state||county="01015" then insample = 1;
if state||county="01073" then insample = 1;
if state||county="01097" then insample = 1;
if state||county="02090" then insample = 1;
if state||county="04013" then insample = 1;
if state||county="04019" then insample = 1;
if state||county="05069" then insample = 1;
if state||county="05119" then insample = 1;
if state||county="06001" then insample = 1;
if state||county="06019" then insample = 1;
if state||county="06037" then insample = 1;
if state||county="06059" then insample = 1;
if state||county="06067" then insample = 1;
if state||county="06073" then insample = 1;
if state||county="06075" then insample = 1;
if state||county="08001" then insample = 1;
if state||county="08031" then insample = 1;
if state||county="08123" then insample = 1;
if state||county="09001" then insample = 1;
if state||county="09003" then insample = 1;
if state||county="09009" then insample = 1;
if state||county="10003" then insample = 1;
if state||county="11001" then insample = 1;
if state||county="12011" then insample = 1;
if state||county="12031" then insample = 1;
if state||county="12057" then insample = 1;
if state||county="12086" then insample = 1;
if state||county="13051" then insample = 1;
if state||county="13089" then insample = 1;
if state||county="13095" then insample = 1;
if state||county="13121" then insample = 1;
if state||county="17031" then insample = 1;
if state||county="17143" then insample = 1;
if state||county="17163" then insample = 1;
if state||county="17167" then insample = 1;
if state||county="18089" then insample = 1;
if state||county="18097" then insample = 1;
if state||county="19153" then insample = 1;
if state||county="19193" then insample = 1;
if state||county="20209" then insample = 1;
if state||county="21111" then insample = 1;
if state||county="22017" then insample = 1;
if state||county="22019" then insample = 1;
if state||county="22051" then insample = 1;
if state||county="22071" then insample = 1;
if state||county="22073" then insample = 1;
if state||county="24510" then insample = 1;
if state||county="25009" then insample = 1;
if state||county="25013" then insample = 1;
if state||county="25017" then insample = 1;
if state||county="25025" then insample = 1;
if state||county="26021" then insample = 1;
if state||county="26049" then insample = 1;
if state||county="26121" then insample = 1;
if state||county="26163" then insample = 1;
if state||county="27053" then insample = 1;
if state||county="27123" then insample = 1;
if state||county="28049" then insample = 1;
if state||county="29095" then insample = 1;
if state||county="29189" then insample = 1;
if state||county="29510" then insample = 1;
if state||county="31055" then insample = 1;
if state||county="32003" then insample = 1;
if state||county="33011" then insample = 1;
if state||county="34007" then insample = 1;
if state||county="34011" then insample = 1;
if state||county="34013" then insample = 1;
if state||county="34017" then insample = 1;
if state||county="34039" then insample = 1;
if state||county="35001" then insample = 1;
if state||county="35013" then insample = 1;
if state||county="36005" then insample = 1;
if state||county="36029" then insample = 1;
if state||county="36055" then insample = 1;
if state||county="36061" then insample = 1;
if state||county="36063" then insample = 1;
if state||county="36067" then insample = 1;
if state||county="36071" then insample = 1;
if state||county="36093" then insample = 1;
if state||county="36119" then insample = 1;
if state||county="37119" then insample = 1;
if state||county="39017" then insample = 1;
if state||county="39035" then insample = 1;
if state||county="39049" then insample = 1;
if state||county="39061" then insample = 1;
if state||county="39081" then insample = 1;
if state||county="39087" then insample = 1;
if state||county="39099" then insample = 1;
if state||county="39153" then insample = 1;
if state||county="40109" then insample = 1;
if state||county="41051" then insample = 1;
if state||county="42003" then insample = 1;
if state||county="42043" then insample = 1;
if state||county="42045" then insample = 1;
if state||county="42101" then insample = 1;
if state||county="44007" then insample = 1;
if state||county="45019" then insample = 1;
if state||county="45053" then insample = 1;
if state||county="45079" then insample = 1;
if state||county="45085" then insample = 1;
if state||county="47037" then insample = 1;
if state||county="47065" then insample = 1;
if state||county="47093" then insample = 1;
if state||county="47157" then insample = 1;
if state||county="48029" then insample = 1;
if state||county="48113" then insample = 1;
if state||county="48141" then insample = 1;
if state||county="48201" then insample = 1;
if state||county="48245" then insample = 1;
if state||county="48309" then insample = 1;
if state||county="48355" then insample = 1;
if state||county="48361" then insample = 1;
if state||county="48439" then insample = 1;
if state||county="48453" then insample = 1;
if state||county="49057" then insample = 1;
if state||county="51710" then insample = 1;
if state||county="51740" then insample = 1;
if state||county="51760" then insample = 1;
if state||county="53033" then insample = 1;
if state||county="53053" then insample = 1;
if state||county="53077" then insample = 1;
if state||county="54009" then insample = 1;
if state||county="54011" then insample = 1;
if state||county="54039" then insample = 1;
if state||county="55079" then insample = 1;

inpowsample = 0;
if substr(qpowst,2,2)||qpowco="01015" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="01073" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="01097" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="02090" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="04013" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="04019" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="05069" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="05119" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="06001" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="06019" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="06037" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="06059" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="06067" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="06073" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="06075" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="08001" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="08031" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="08123" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="09001" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="09003" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="09009" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="10003" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="11001" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="12011" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="12031" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="12057" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="12086" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="13051" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="13089" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="13095" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="13121" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="17031" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="17143" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="17163" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="17167" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="18089" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="18097" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="19153" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="19193" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="20209" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="21111" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="22017" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="22019" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="22051" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="22071" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="22073" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="24510" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="25009" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="25013" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="25017" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="25025" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="26021" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="26049" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="26121" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="26163" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="27053" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="27123" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="28049" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="29095" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="29189" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="29510" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="31055" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="32003" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="33011" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="34007" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="34011" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="34013" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="34017" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="34039" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="35001" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="35013" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="36005" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="36029" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="36055" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="36061" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="36063" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="36067" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="36071" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="36093" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="36119" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="37119" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="39017" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="39035" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="39049" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="39061" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="39081" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="39087" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="39099" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="39153" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="40109" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="41051" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="42003" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="42043" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="42045" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="42101" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="44007" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="45019" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="45053" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="45079" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="45085" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="47037" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="47065" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="47093" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="47157" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="48029" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="48113" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="48141" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="48201" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="48245" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="48309" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="48355" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="48361" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="48439" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="48453" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="49057" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="51710" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="51740" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="51760" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="53033" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="53053" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="53077" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="54009" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="54011" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="54039" then inpowsample = 1;
if substr(qpowst,2,2)||qpowco="55079" then inpowsample = 1;

**** Create a uniformly distributed random number to use when selecting a 5% sample of non-sample-county residents;
randomdraw=ranuni(12345);

in5pctoutside=0;
if (randomdraw<.05) and (insample=0) then in5pctoutside=1;
if (insample=1) or (inpowsample=1) or (in5pctoutside=1);

run;

%end;


data work.allstates;
set
%do st = 1 %to 51;
&&state&st
%end;
;
run;


%do st = 1 %to 43;
data work.export;
set work.allstates;
if insample=1 & state="&&statenum&st";
run;
%savastata ("/rdcprojects/mc1/mc00535/data/decennial/01-Raw_Extracts/dec2000extract&&statenum&st...dta", -replace);

data work.export;
set work.allstates;
if inpowsample=1 & substr(qpowst,2,2)="&&statenum&st";
run;
%savastata ("/rdcprojects/mc1/mc00535/data/decennial/01-Raw_Extracts/powdec2000extract&&statenum&st...dta", -replace);
%end;


data work.export;
set work.allstates;
if in5pctoutside=1;
run;
%savastata("/rdcprojects/mc1/mc00535/data/decennial/01-Raw_Extracts/dec2000extract_5pctnonsample.dta", -replace);



proc datasets library = work;
%do st = 1 %to 51;
&&state&st
%end;
allstates export;
run;

%mend;


%loops;

