libname DEC1990 "/decennial/1990cen/1990S/microdata";
libname CBRF "/rdcprojects/mc1/mc00535/data/CBRF";
libname OUTDATA "/rdcprojects/mc1/mc00535/data/decennial/01-Raw_Extracts";

**** Include savastata macro for exporting to stata;
%include "/rdcprojects/mc1/mc00535/programs_organize/1.library/savastata.mac";

**** Write state abbreviations (for states with sample_main=1, assigned_tract in {0,1})
**** to a vector of local macros that can be looped over;

%let state1 = al;
%let state2 = ak;
%let state3 = az;
%let state4 = ar;
%let state5 = ca;
%let state6 = co;
%let state7 = ct;
%let state8 = de;
%let state9 = dc;
%let state10 = fl;
%let state11 = ga;
%let state12 = hi;
%let state13 = id;
%let state14 = il;
%let state15 = in;
%let state16 = ia;
%let state17 = ks;
%let state18 = ky;
%let state19 = la;
%let state20 = me;
%let state21 = md;
%let state22 = ma;
%let state23 = mi;
%let state24 = mn;
%let state25 = ms;
%let state26 = mo;
%let state27 = mt;
%let state28 = ne;
%let state29 = nv;
%let state30 = nh;
%let state31 = nj;
%let state32 = nm;
%let state33 = ny;
%let state34 = nc;
%let state35 = nd;
%let state36 = oh;
%let state37 = ok;
%let state38 = or;
%let state39 = pa;
%let state40 = ri;
%let state41 = sc;
%let state42 = sd;
%let state43 = tn;
%let state44 = tx;
%let state45 = ut;
%let state46 = vt;
%let state47 = va;
%let state48 = wa;
%let state49 = wv;
%let state50 = wi;
%let state51 = wy;

%let statenum1 = 01;
%let statenum2 = 02;
%let statenum3 = 04;
%let statenum4 = 05;
%let statenum5 = 06;
%let statenum6 = 08;
%let statenum7 = 09;
%let statenum8 = 10;
%let statenum9 = 11;
%let statenum10 = 12;
%let statenum11 = 13;
%let statenum12 = 17;
%let statenum13 = 18;
%let statenum14 = 19;
%let statenum15 = 20;
%let statenum16 = 21;
%let statenum17 = 22;
%let statenum18 = 24;
%let statenum19 = 25;
%let statenum20 = 26;
%let statenum21 = 27;
%let statenum22 = 28;
%let statenum23 = 29;
%let statenum24 = 31;
%let statenum25 = 32;
%let statenum26 = 33;
%let statenum27 = 34;
%let statenum28 = 35;
%let statenum29 = 36;
%let statenum30 = 37;
%let statenum31 = 39;
%let statenum32 = 40;
%let statenum33 = 41;
%let statenum34 = 42;
%let statenum35 = 44;
%let statenum36 = 45;
%let statenum37 = 47;
%let statenum38 = 48;
%let statenum39 = 49;
%let statenum40 = 51;
%let statenum41 = 53;
%let statenum42 = 54;
%let statenum43 = 55;


**** Define lists of variables to keep;
%macro loops;
%do st = 1 %to 51 ;
data work.&&state&st (keep = STF COU TRCT BLK blockid90 LANDA insample);

blockid90 = "               ";
if length(trct)=4 then blockid90 = STF||COU||substr(TRCT,1,4)||"00"||BLK ;
if length(trct)=6 then blockid90 = STF||COU||TRCT||BLK ;

***** Keep only if respondent resides or works in a 
***** county appearing on block level admin data file;
insample = 0;
if stf||cou="01015" then insample = 1;
if stf||cou="01073" then insample = 1;
if stf||cou="01097" then insample = 1;
if stf||cou="02090" then insample = 1;
if stf||cou="04013" then insample = 1;
if stf||cou="04019" then insample = 1;
if stf||cou="05069" then insample = 1;
if stf||cou="05119" then insample = 1;
if stf||cou="06001" then insample = 1;
if stf||cou="06019" then insample = 1;
if stf||cou="06037" then insample = 1;
if stf||cou="06059" then insample = 1;
if stf||cou="06067" then insample = 1;
if stf||cou="06073" then insample = 1;
if stf||cou="06075" then insample = 1;
if stf||cou="08001" then insample = 1;
if stf||cou="08031" then insample = 1;
if stf||cou="08123" then insample = 1;
if stf||cou="09001" then insample = 1;
if stf||cou="09003" then insample = 1;
if stf||cou="09009" then insample = 1;
if stf||cou="10003" then insample = 1;
if stf||cou="11001" then insample = 1;
if stf||cou="12011" then insample = 1;
if stf||cou="12031" then insample = 1;
if stf||cou="12057" then insample = 1;
if stf||cou="12025" then insample = 1;
if stf||cou="13051" then insample = 1;
if stf||cou="13089" then insample = 1;
if stf||cou="13095" then insample = 1;
if stf||cou="13121" then insample = 1;
if stf||cou="17031" then insample = 1;
if stf||cou="17143" then insample = 1;
if stf||cou="17163" then insample = 1;
if stf||cou="17167" then insample = 1;
if stf||cou="18089" then insample = 1;
if stf||cou="18097" then insample = 1;
if stf||cou="19153" then insample = 1;
if stf||cou="19193" then insample = 1;
if stf||cou="20209" then insample = 1;
if stf||cou="21111" then insample = 1;
if stf||cou="22017" then insample = 1;
if stf||cou="22019" then insample = 1;
if stf||cou="22051" then insample = 1;
if stf||cou="22071" then insample = 1;
if stf||cou="22073" then insample = 1;
if stf||cou="24510" then insample = 1;
if stf||cou="25009" then insample = 1;
if stf||cou="25013" then insample = 1;
if stf||cou="25017" then insample = 1;
if stf||cou="25025" then insample = 1;
if stf||cou="26021" then insample = 1;
if stf||cou="26049" then insample = 1;
if stf||cou="26121" then insample = 1;
if stf||cou="26163" then insample = 1;
if stf||cou="27053" then insample = 1;
if stf||cou="27123" then insample = 1;
if stf||cou="28049" then insample = 1;
if stf||cou="29095" then insample = 1;
if stf||cou="29189" then insample = 1;
if stf||cou="29510" then insample = 1;
if stf||cou="31055" then insample = 1;
if stf||cou="32003" then insample = 1;
if stf||cou="33011" then insample = 1;
if stf||cou="34007" then insample = 1;
if stf||cou="34011" then insample = 1;
if stf||cou="34013" then insample = 1;
if stf||cou="34017" then insample = 1;
if stf||cou="34039" then insample = 1;
if stf||cou="35001" then insample = 1;
if stf||cou="35013" then insample = 1;
if stf||cou="36005" then insample = 1;
if stf||cou="36029" then insample = 1;
if stf||cou="36055" then insample = 1;
if stf||cou="36061" then insample = 1;
if stf||cou="36063" then insample = 1;
if stf||cou="36067" then insample = 1;
if stf||cou="36071" then insample = 1;
if stf||cou="36093" then insample = 1;
if stf||cou="36119" then insample = 1;
if stf||cou="37119" then insample = 1;
if stf||cou="39017" then insample = 1;
if stf||cou="39035" then insample = 1;
if stf||cou="39049" then insample = 1;
if stf||cou="39061" then insample = 1;
if stf||cou="39081" then insample = 1;
if stf||cou="39087" then insample = 1;
if stf||cou="39099" then insample = 1;
if stf||cou="39153" then insample = 1;
if stf||cou="40109" then insample = 1;
if stf||cou="41051" then insample = 1;
if stf||cou="42003" then insample = 1;
if stf||cou="42043" then insample = 1;
if stf||cou="42045" then insample = 1;
if stf||cou="42101" then insample = 1;
if stf||cou="44007" then insample = 1;
if stf||cou="45019" then insample = 1;
if stf||cou="45053" then insample = 1;
if stf||cou="45079" then insample = 1;
if stf||cou="45085" then insample = 1;
if stf||cou="47037" then insample = 1;
if stf||cou="47065" then insample = 1;
if stf||cou="47093" then insample = 1;
if stf||cou="47157" then insample = 1;
if stf||cou="48029" then insample = 1;
if stf||cou="48113" then insample = 1;
if stf||cou="48141" then insample = 1;
if stf||cou="48201" then insample = 1;
if stf||cou="48245" then insample = 1;
if stf||cou="48309" then insample = 1;
if stf||cou="48355" then insample = 1;
if stf||cou="48361" then insample = 1;
if stf||cou="48439" then insample = 1;
if stf||cou="48453" then insample = 1;
if stf||cou="49057" then insample = 1;
if stf||cou="51710" then insample = 1;
if stf||cou="51740" then insample = 1;
if stf||cou="51760" then insample = 1;
if stf||cou="53033" then insample = 1;
if stf||cou="53053" then insample = 1;
if stf||cou="53077" then insample = 1;
if stf||cou="54009" then insample = 1;
if stf||cou="54011" then insample = 1;
if stf||cou="54039" then insample = 1;
if stf||cou="55079" then insample = 1;

if (insample=1);
if (LANDA>0);

run;

%end;

data work.allstates;
set
%do st = 1 %to 51;
&&state&st
%end;
;
run;

data work.export;
set work.allstates;
run;
%savastata("/rdcprojects/mc1/mc00535/data/decennial/01-Raw_Extracts/dec1990_area.dta", -replace);

proc datasets library = work;
%do st = 1 %to 51;
&&state&st
%end;
allstates export;
run;

%mend;
%loops;



