clear
set more off
set mem 2790m

adopath ++ "/public/ado"

local statenum1 = "01"
local statenum2 = "02"
local statenum3 = "04"
local statenum4 = "05"
local statenum5 = "06"
local statenum6 = "08"
local statenum7 = "09"
local statenum8 = "10"
local statenum9 = "11"
local statenum10 = "12"
local statenum11 = "13"
local statenum12 = "17"
local statenum13 = "18"
local statenum14 = "19"
local statenum15 = "20"
local statenum16 = "21"
local statenum17 = "22"
local statenum18 = "24"
local statenum19 = "25"
local statenum20 = "26"
local statenum21 = "27"
local statenum22 = "28"
local statenum23 = "29"
local statenum24 = "31"
local statenum25 = "32"
local statenum26 = "33"
local statenum27 = "34"
local statenum28 = "35"
local statenum29 = "36"
local statenum30 = "37"
local statenum31 = "39"
local statenum32 = "40"
local statenum33 = "41"
local statenum34 = "42"
local statenum35 = "44"
local statenum36 = "45"
local statenum37 = "47"
local statenum38 = "48"
local statenum39 = "49"
local statenum40 = "51"
local statenum41 = "53"
local statenum42 = "54"
local statenum43 = "55"

local cendatadir = "/rdcprojects/mc1/mc00535/data/decennial/01-Raw_Extracts/"
local outdata = "/rdcprojects/mc1/mc00535/data/decennial/02-Recoded_State_Files/dec1980recoded"
local powoutdata = "/rdcprojects/mc1/mc00535/data/decennial/02-Recoded_State_Files/powdec1980recoded"

use "/rdcprojects/mc1/mc00535/data/CTRF/CTRF_90to80_ManyToMany.dta"
tempfile ctrf9080
save `ctrf9080'
clear

use "/rdcprojects/mc1/mc00535/data/CTRF/CTRF_90to80_ManyToMany.dta"
tempfile powctrf9080
foreach var in pct80pop tractid80 tractid90 {
ren `var' pow`var'
}
save `powctrf9080'
clear

use "/rdcprojects/mc1/mc00535/data/ezdata/blocklevel_admdata.dta"
keep if keep_1990geography==1
ren tract1990 tractid90
collapse progid_cons progid_power progname program1995 program1999 program2001 application_tract assigned_tract black_city_1970 black_city_1980 black_city_1990 black_city_2000 crime_total_city_1970 crime_total_city_1980 crime_total_city_1990 crime_total_city_2000 manufacture_city_1970 manufacture_city_1980 manufacture_city_1990 manufacture_city_2000 pctgov_city_1970 pctgov_city_1980 pctgov_city_1990 pctgov_city_2000 population_city_1970 population_city_1980 population_city_1990 population_city_2000, by(tractid90 city)
tempfile admin
save `admin'
clear

use "/rdcprojects/mc1/mc00535/data/ezdata/blocklevel_admdata.dta"
keep if keep_1990geography==1
ren tract1990 tractid90
collapse progid_cons progid_power progname program1995 program1999 program2001 application_tract assigned_tract black_city_1970 black_city_1980 black_city_1990 black_city_2000 crime_total_city_1970 crime_total_city_1980 crime_total_city_1990 crime_total_city_2000 manufacture_city_1970 manufacture_city_1980 manufacture_city_1990 manufacture_city_2000 pctgov_city_1970 pctgov_city_1980 pctgov_city_1990 pctgov_city_2000 population_city_1970 population_city_1980 population_city_1990 population_city_2000, by(tractid90 city)

foreach var in tractid90 progid_cons progid_power progname program1995 program1999 program2001 application_tract assigned_tract city black_city_1970 black_city_1980 black_city_1990 black_city_2000 crime_total_city_1970 crime_total_city_1980 crime_total_city_1990 crime_total_city_2000 manufacture_city_1970 manufacture_city_1980 manufacture_city_1990 manufacture_city_2000 pctgov_city_1970 pctgov_city_1980 pctgov_city_1990 pctgov_city_2000 population_city_1970 population_city_1980 population_city_1990 population_city_2000 {
ren `var' pow`var'
}
tempfile powadmin
save `powadmin'
clear

forval type = 0/2 {
forval ii = 1/43 {
if `type'<2 | `ii'==1 {

if `type'==0 {
use "`cendatadir'/dec1980extract`statenum`ii''.dta"
}
if `type'==1 {
use "`cendatadir'/powdec1980extract`statenum`ii''.dta"
}
if `type'==2 {
use "`cendatadir'/dec1980extract_5pctnonsample.dta"
}

**** Create place of work variables
gen powcounty80 = substr(pwst,2,2)+pwc if real(pwst)<=56
replace powcounty80 = "" if powcounty80=="00000"
label variable powcounty80 "Place of Work 1980 state+county"

gen powtractid80 = substr(pwst,2,2)+pwc+pwt if real(pwst)<=56
replace powtractid80 = "" if powtractid80=="00000000000"
replace powtractid80 = "" if pwt=="990000"
replace powtractid80 = "" if pwt=="999999"
label variable powtractid80 "Place of Work 1980 state+county+tract"
drop pwst pwc pwt

**** Drop individuals from POW file if POW tract is missing
****   (These individuals are on the raw extract because POW state is nonmissing)
drop if `type'==1 & powtractid80==""

**** In 1980, Alaska has no valid powtracts.  In cases like that, create a single blank 
****    obs to keep the program from crashing 
qui tab powcounty80
if r(N)==0 {
set obs 1
}

**** Create a vairable to use as a visual divider in the variable list
gen __________ = .

**** Rename and label variables that will not be recoded
*ren age age
label define agelab 115 "115 and above"
label values age agelab

drop gid

ren hhid hid

************ Create a numeric vacancy status variable
gen vacancy = real(vs)
replace vacancy = 6 if vacancy==5
label define vacancy_lab 0 "NA (Occupied housing unit or seasonal, migratory or GQ)" 1 "For rent" 2 "For sale only" 3 "Rented or sold, not occupied" 4 "Held for occasional usa" 5 "Migratory Workers" 6 "Other vacant"
label values vacancy vacancy_lab
label variable vacancy "Vacancy Status"
drop vs

**** Create a numeric race variable
gen racn = real(rac)
label define raclab 0 "White" 1 "Black" 2 "Japanese" 3 "Chinese" 4 "Filipino" 5 "Korean" 6 "Vietnamese" 7 "American Indian" 8 "Asian Indian" 9 "Hawaiian" 10 "Guamanian" 11 "Samoan" 12 "Eskimo" 13 "Aleut" 14 "Other Race", modify
label values racn raclab
label variable racn "Detailed Race"
drop rac

**** Create a numeric flag for hispanic origin
gen hisp = inlist(so,"1","2","3","4")==1 if so!=""
label define hisp_lab 0 "non-hispanic" 1 "hispanic"
label values hisp hisp_lab
label variable hisp "Hispanic Origin Flag"
drop so

**** Create a householder flag
gen householder=rel=="00"
label variable householder "=1 if person is householder"

**** Create a numeric race/ethnicity variable
gen raceeth = 4
replace raceeth = 1 if racn==0 & hisp!=1
replace raceeth = 2 if racn==1
replace raceeth = 3 if inrange(racn,2,6)==1
replace raceeth = 3 if inrange(racn,8,12)==1
label define raceeth_lab 1 "white, non-hispanic" 2 "black" 3 "asian/pi" 4 "other"
label values raceeth raceeth_lab
label variable raceeth "Race/Ethnicity"
drop racn

**** Create a numeric employment status recode variable
ren esr esrc
gen esr = real(esrc)
label define esrlab 0 "NA (Under 16 years old)" 1 "In civilian labor force, employed, at work" 2 "employed, but not at work" 3 "unemployed" 4 "In armed forces, at work" 5 "In armed forces, not at work" 6 "Not in labor force"
label values esr esrlab
label variable esr "Employment Status Recode"
drop esrc

**** Create a numeric education category variable 
**** Code 1980 categories to finest common coarsening of 1990 and 2000 categories
label define educcat_lab 0 "not in universe, age<3" 1 "no schooling completed" 2 "nursery school to 4th grade" 3 "5th grade to 8th grade" 4 "9th grade" 5 "10th grade" 6 "11th grade" 7 "12th grade, no diploma" 8 "high school graduate" 9 "some college" 10 "bachelor's degree+"
gen educcat = .
replace educcat = 0 if age <3
replace educcat = 1 if real(hgr)==0 & age>3
replace educcat = 2 if inrange(real(hgr),1,6)==1
replace educcat = 3 if inrange(real(hgr),7,10)==1
replace educcat = 4 if real(hgr)==11
replace educcat = 5 if real(hgr)==12
replace educcat = 6 if real(hgr)==13
replace educcat = 7 if real(hgr)==14 & real(fhg)!=2
replace educcat = 8 if real(hgr)==14 & real(fhg)==2
replace educcat = 9 if inrange(real(hgr),15,17)==1
replace educcat = 9 if real(hgr)==18 & real(fhg)!=2
replace educcat = 10 if real(hgr)==18 & real(fhg)==2
replace educcat = 10 if real(hgr)>=19

label variable educcat "Educational Attainment"
label values educcat educcat_lab
drop hgr fhg

**** Create a numeric "currently in school" identifier
gen inschool = real(sch)+1
replace inschool = 0 if age<3
replace inschool = 3 if inschool==4
label define inschool_lab 0 "age<3" 1 "no" 2 "yes, public school or college" 3 "yes, private school or college"
label values inschool inschool_lab
label variable inschool "Currently Attending School?"
drop sch

**** Create a numeric weekly rent variable
gen rent80cat = real(rnt)
replace rent80cat = 0 if rent80cat == 27
label define rent80cat_lab  0 "NA (Not in the rent universe)" 1 "Less than $50" 2 "$50 to $59" 3 "$60 to $69" 4 "$70 to $79" 5 "$80 to $89" 6 "$90 to $99" 7 "$100 to $109" 8 "$110 to $119" 9 "$120 to $129" 10 "$130 to $139" 11 "$140 to $149" 12 "$150 to $159" 13 "$160 to $169" 14 "$170 to $179" 15 "$180 to $189" 16 "$190 to $199" 17 "$200 to $224" 18 "$225 to $249" 19 "$250 to $274" 20 "$275 to $299" 21 "$300 to $349" 22 "$350 to $399" 23 "$400 to $499" 24 "$500 or more" 25 "No cash rent (NCR)"
label values rent80cat rent80cat_lab
label variable rent80cat "Rent Category, 1980 categories"
drop rnt

**** Create a numeric "group quarters type" variable
ren gqt gqtc
gen gqt = real(gqtc)
label variable gqt "Group Quarters Type"
drop gqtc

**** Create a numeric tenure variable
**** Note that there are two "owned" categories in 1990/2000 but only one in 1980
gen tenure80 = real(ten)
replace tenure80 = . if tenure==0
label define tenure80_lab 0 "NA (GQ or Vacant)" 1 "owned or being bought" 2 "rented for cash rent" 3 "no cash rent"
label values tenure80 tenure80_lab
label variable tenure80 "Tenure"
drop ten

**** Create a numeric variable describing the number of bedrooms
gen bedrooms = real(brm)
label define bedroomslab 0 "NA (GQ)" 1 "No bedrooms" 2 "1 bedroom" 3 "2 bedrooms" 4 "3 bedrooms" 5 "4 bedrooms" 6 "5 or more bedrooms"
label values bedrooms bedroomslab
label variable bedrooms "Bedrooms"
drop brm

**** Create a numeric variable describing the presence of plumbing facilities
gen plumbing = real(pfac)
label define plumbinglab 0 "NA (GQ)" 1 "Yes, for this household only" 2 "Yes, but shared with another household" 3 "No, some but not all plumbing facilties" 4 "No plumbing facilities in household"
label values plumbing plumbinglab
label variable plumbing "Plumbing"
drop pfac

**** Create a numeric variable describing the presence of kitchen facilities
gen kitchen = real(kit)
label define kitchenlab 0 "NA (GQ)" 1 "Yes" 2 "No"
label values kitchen kitchenlab
label variable kitchen "Kitchen"
drop kit

**** Create a numeric variable describing the number of rooms
gen rooms = real(rm)
replace rooms = . if rooms==0
label define rooms_lab 0 "NA" 1 "1 room" 2 "2 rooms" 3 "3 rooms" 4 "4 rooms" 5 "5 rooms" 6 "6 rooms" 7 "7 rooms" 8 "8 rooms" 9 "9 or more rooms"
label values rooms rooms_lab
label variable rooms "Rooms"
drop rm

**** Create a numerical variable describing when housing unit was built
gen buildingage80 = real(ysb)
label define buildingage80_lab 0 "NA (GQ)" 1 "0-1" 2 "2-5" 3 "6-10" 4 "11-20" 5 "21-30" 6 "31-40" 7 "41-50" 8 "51+"
label values buildingage80 buildingage80_lab
label variable buildingage80 "Age of Structure, 1980 categories"
drop ysb

**** Create a numerical variable describing the value of the housing unit
gen value80= real(val)
label variable value "1980 Value of Residence - no val labels"
drop val

**** Create a numeric weekly hours worked variable
ren ww wklyrwk
label define wklyrwk_lab 0 "NA/No work"
label values wklyrwk wklyrwk_lab
label variable wklyrwk "Weeks worked last year"

**** Create a numeric weekly hours worked variable
ren uhw wklyrhr
label define wklyrhr_lab 99 "99 or more hours"
label values wklyrhr wklyrhr_lab
label variable wklyrhr "Usual Hours Worked Per Week"

**** Create a numeric sex variable
ren sex qsex
gen sex = real(qsex)+1
label define sexlab 1 "male" 2 "female"
label values sex sexlab
label var sex "Sex"
drop qsex

**** Create a numeric citizenship identifier
gen citizen80 = real(cit)
label define citizen80_lab 0 "Born in the US or outlying area" 1 "Yes, a naturalized citizen" 2 "No, not a citizen" 3 "Born abroad of American parents"
label values citizen80 citizen80_lab
label variable citizen80 "Citizenship Status, 1980 categories"
drop cit

**** Create a numeric marital staus variable
gen marstatus  = real(mar)+1
label define marstatus_lab 1 "married" 2 "widowed" 3 "divorced" 4 "separated" 5 "never married"
label variable marstatus "Marital Status"
label values marstatus marstatus_lab
drop mar

**** Create a numerical commute time variable and an indicator for instances
**** when the variable is censored
ren ttw commutetime
label define commutetime_lab 99 "99 minutes or more"
label values commutetime commutetime_lab
label variable commutetime "Travel Time to Work (Minutes)"

gen commutetime_cen = commutetime==99
label variable commutetime_cen "Censored Commute Time Identifier"

**** Consolidate geographic variables
replace tractid80 = "" if substr(tractid80,6,6)=="999999"
gen county80 = stfg+coug
label variable county80 "1980 FIPS state+county"
label variable tractid80 "1980 stf+cou+trct+blk"
drop stfg coug trg trsg

**** Create a numerical variable describing method of commute to work
gen howcommute80 = real(mtw)
label define howcommute80_lab 0 "NA (Under 16 years old ot not at work)" 1 "Car" 2 "Truck" 3 "Van" 4 "Bus or streetcar" 5 "Railroad" 6 "Subway or elevated" 7 "Taxicab" 8 "Motorcycle" 9 "Bicycle" 10 "Walked only" 11 "Worked at home" 12 "Other"
label values howcommute80 howcommute80_lab
label variable howcommute80 "Means of Transportation to Work, 1980 categories"
drop mtw

**** Create a total income (person) variable
gen pinc = incf+inci+incn+inco+incp+incs+incw
label variable pinc "Persons Total Income"

**** Create a household income variable
egen hinc = sum(pinc), by(hid)
label variable hinc "Household Total Income"

**** Create a family income variable
egen finc = sum(pinc), by(hid sfn)
label variable finc "Family Total Income"

**** Create a numeric number of children variable
egen noc = sum( (age<18) ), by(hid)
label variable noc "Number of Children in Household"

**** Create a numeric number of children in family variable
egen noc_fam = sum( (age<18) ), by(hid sfn)
label variable noc_fam "Number of Children in Family"

**** Create a person count by family
egen persons = sum(1), by(hid)
label variable persons "Household Size"

**** Create a person count by family
egen persons_fam = sum(1), by(hid sfn)
label variable persons_fam "Family Size"

**** Create a flag for householder 65 or older in family
egen householder_ge65 = sum( (rel=="00")*(age>=65) ), by(hid sfn)
replace householder_ge65 = 1 if persons==1 & age>=65

**** Create a poverty indicator
gen pov=.
replace pov = finc/4284 if finc!=. & householder_ge65==0 & persons_fam==1
replace pov = finc/3950 if finc!=. & householder_ge65==1 & persons_fam==1

replace pov = finc/5514 if finc!=. & householder_ge65==0 & persons_fam==2 & noc_fam==0
replace pov = finc/5676 if finc!=. & householder_ge65==0 & persons_fam==2 & noc_fam>=1
replace pov = finc/4978 if finc!=. & householder_ge65==1 & persons_fam==2 & noc_fam==0
replace pov = finc/5655 if finc!=. & householder_ge65==1 & persons_fam==2 & noc_fam>=1

replace pov = finc/6442 if finc!=. & persons_fam==3 & noc_fam==0
replace pov = finc/6628 if finc!=. & persons_fam==3 & noc_fam==1
replace pov = finc/6635 if finc!=. & persons_fam==3 & noc_fam>=2

replace pov = finc/8494 if finc!=. & persons_fam==4 & noc_fam==0
replace pov = finc/8633 if finc!=. & persons_fam==4 & noc_fam==1
replace pov = finc/8351 if finc!=. & persons_fam==4 & noc_fam==2
replace pov = finc/8380 if finc!=. & persons_fam==4 & noc_fam>=3

replace pov = finc/10243 if finc!=. & persons_fam==5 & noc_fam==0
replace pov = finc/10392 if finc!=. & persons_fam==5 & noc_fam==1
replace pov = finc/10074 if finc!=. & persons_fam==5 & noc_fam==2
replace pov = finc/9828 if finc!=. & persons_fam==5 & noc_fam==3
replace pov = finc/9677 if finc!=. & persons_fam==5 & noc_fam>=4

replace pov = finc/11782 if finc!=. & persons_fam==6 & noc_fam==0
replace pov = finc/11828 if finc!=. & persons_fam==6 & noc_fam==1
replace pov = finc/11585 if finc!=. & persons_fam==6 & noc_fam==2
replace pov = finc/11351 if finc!=. & persons_fam==6 & noc_fam==3
replace pov = finc/11004 if finc!=. & persons_fam==6 & noc_fam==4
replace pov = finc/10798 if finc!=. & persons_fam==6 & noc_fam>=5

replace pov = finc/13556 if finc!=. & persons_fam==7 & noc_fam==0
replace pov = finc/13641 if finc!=. & persons_fam==7 & noc_fam==1
replace pov = finc/13349 if finc!=. & persons_fam==7 & noc_fam==2
replace pov = finc/13146 if finc!=. & persons_fam==7 & noc_fam==3
replace pov = finc/12767 if finc!=. & persons_fam==7 & noc_fam==4
replace pov = finc/12325 if finc!=. & persons_fam==7 & noc_fam==5
replace pov = finc/11840 if finc!=. & persons_fam==7 & noc_fam>=6

replace pov = finc/15162 if finc!=. & persons_fam==8 & noc_fam==0
replace pov = finc/15296 if finc!=. & persons_fam==8 & noc_fam==1
replace pov = finc/15020 if finc!=. & persons_fam==8 & noc_fam==2
replace pov = finc/14779 if finc!=. & persons_fam==8 & noc_fam==3
replace pov = finc/14437 if finc!=. & persons_fam==8 & noc_fam==4
replace pov = finc/14002 if finc!=. & persons_fam==8 & noc_fam==5
replace pov = finc/13550 if finc!=. & persons_fam==8 & noc_fam==6
replace pov = finc/13435 if finc!=. & persons_fam==8 & noc_fam>=7

replace pov = finc/18238 if finc!=. & persons_fam>=9 & noc_fam==0
replace pov = finc/18327 if finc!=. & persons_fam>=9 & noc_fam==1
replace pov = finc/18083 if finc!=. & persons_fam>=9 & noc_fam==2
replace pov = finc/17878 if finc!=. & persons_fam>=9 & noc_fam==3
replace pov = finc/17543 if finc!=. & persons_fam>=9 & noc_fam==4
replace pov = finc/17080 if finc!=. & persons_fam>=9 & noc_fam==5
replace pov = finc/16662 if finc!=. & persons_fam>=9 & noc_fam==6
replace pov = finc/16559 if finc!=. & persons_fam>=9 & noc_fam==7
replace pov = finc/15921 if finc!=. & persons_fam>=9 & noc_fam>=8

replace pov = max(0, min(round(100*pov),501) )
label variable pov "Poverty Status"
label define pov_lab 0 "not applicable" 501 "500% or more"
label values pov pov_lab
drop householder_ge65

**** Flag households with a female head
egen hh_head_present = sum(rel=="00"), by(hid)
egen heads_spouse_present = sum(rel=="01"), by(hid)
replace heads_spouse_present=1 if heads_spouse_present>1
egen female_head = sum( (sex==2) * (rel=="00") ), by(hid)
replace female_head = . if hh_head_present==0
replace female_head = 1 if persons==1 & sex==2
replace female_head = 0 if female_head==1 & heads_spouse_present==1
label variable female_head "Female Householder"
drop hh_head_present heads_spouse_present

**** flag individuals with censored income vars
label define pinc_cen_lab 0 "no censored income vars" 1 "top-coded income var(s)" 2 "bottom-coded income var(s)" 3 "top- and bottom-coded income vars"

gen pinc_cen = 0
replace pinc_cen = 1 if incf==999500
replace pinc_cen = 1 if inci==999500
replace pinc_cen = 1 if incn==999500
replace pinc_cen = 1 if inco==99995
replace pinc_cen = 1 if incp==9995
replace pinc_cen = 1 if incs==9995
replace pinc_cen = 1 if incw==999500
replace pinc_cen = 2 if incf==-9995 & pinc_cen==0
replace pinc_cen = 2 if inci==-9995 & pinc_cen==0
replace pinc_cen = 2 if incn==-9995 & pinc_cen==0
replace pinc_cen = 3 if incf==-9995 & pinc_cen==1
replace pinc_cen = 3 if inci==-9995 & pinc_cen==1
replace pinc_cen = 3 if incn==-9995 & pinc_cen==1
label values pinc_cen pinc_cen_lab
label variable pinc_cen "Censored Income Identifier"

label variable pinc "Persons Total Income"

label variable incw "Wage/Salary Income"

label variable incp "Public Assistance Income"

**** Identify censored earnings values
label define pern_cen_lab 0 "not censored" 1 "top-coded earnings" 2 "bottom-coded earnings"

gen pern_cen = 0
replace pern_cen = 1 if pern==2999997
replace pern_cen = 2 if pern==-19998
label values pern_cen pern_cen_lab
label variable pern_cen "Censored Earnings Identifier"
drop incf inci incn inco incs

**** Create a numeric migration variable
gen mig80 = real(res)
drop res
label variable mig80 "Mobility Status - 1980 coding"
label define mig80label 0 "under 5 years old/not coded" 1 "same house" 2 "not same house"
label values mig80 mig80label

**** Create a migration county variable for those who lived at a
**** different US house 5 years previous
gen migcounty = substr(ress,2,2)+substr(resc,2,3) if real(ress)<=56
replace migcounty = "" if migcounty=="00000"
label variable migcounty "US County of Previous Residence for US Movers"

**** Create a migration country variable for those who lived in a
**** different country 5 years previous
gen migcountry = ress if real(ress)>56
label variable migcountry "Country of Previous Residence for non-US Movers"
drop ress resc

**** Recode allocation flags
gen agef =  real(agea)
label variable agef "Allocation Flag - age"

gen raceethf1 = real(raca)
label variable raceethf1 "Allocation Flag - race component of raceeth"

gen raceethf2 = real(soa)
label variable raceethf2 "Allocation Flag - hisp component of raceeth"

gen sexf = real(sexa)
label variable sexf "Allocation Flag - sex"

gen citizen80f = real(cita)
label variable citizen80f "Allocation Flag - citizen"

gen educcatf1 = real(hgra)
label variable educcatf1 "Allocation Flag - hgr component of educcat"

gen educcatf2 = real(fhg)
label variable educcatf2 "Allocation Flag - fhg component of educcat"

gen inschoolf = real(scha)
label variable inschoolf "Allocation Flag - inschool"

gen marstatusf  = real(mara)
label variable marstatusf "Allocation Flag - marstatus"

gen wklyrhrf = real(uhwa)
label variable wklyrhrf "Allocation Flag - wklyrhr"

gen wklyrwkf = real(wwa)
label variable wklyrwkf "Allocation Flag - wklyrwk"

gen incwf = real(incwa)

gen incpf = real(incpa)
gen indf = real(inda)
label variable indf "Allocation Flag - ind"

gen occf = real(occa)
label variable occf "Allocation Flag - occ"

gen commutetimef = real(ttwa)
label variable commutetimef "Allocation Flag - commutetime"

gen howcommute80f = real(mtwa)
label variable howcommute80f "Allocation Flag - howcommute"

gen powcounty80f = 0
label variable powcounty80f "Allocation Flag - powcounty80"

gen powtractid80f = 0
label variable powtractid80f "Allocation Flag - powtractid80"

gen mig80f = real(resa)
label variable mig80f "Allocation Flag - mig"

gen mig80lf = real(resla)
label variable mig80lf "Allocation Flag - level of mig allocation"

gen pobf = real(poba)
label variable pobf "Allocation Flag - pob"

gen tenure80f = real(tena)
label variable tenure80f "Allocation Flag - tenure"

gen buildingage80f = real(ysba)
label variable buildingage80f "Allocation Flag - buildingage"

gen roomsf = real(rma)
label variable roomsf "Allocation Flag - rooms"

gen rent80f = real(rnta)
label variable rent80f "Allocation Flag - rent"

gen esrf = real(esra)
label variable esrf "Allocation Flag - esr"

gen value80f = real(vala)
label variable value80f "Allocation Flag - value"

gen vacancyf = real(vsa)
label variable vacancyf "Allocation Flag - vacancy"

drop sexa raca agea mara soa scha hgra fhga poba cita lsoa resa resla esra hlwa ttwa mtwa inda occa wwa uhwa incwa incpa pfaca rma tena vala rnta ysba kita brma vsa

memory

**** Reorder the variables
order hid pwgt hwgt county80 tractid80 age raceeth hisp sex citizen80 educcat inschool marstatus esr wklyrhr wklyrwk ind occ commutetime commutetime_cen howcommute80 powcounty80 powtractid80 pinc pinc_cen incw incp pov noc pern pern_cen mig80 migcounty migcountry pob gqt tenure80 buildingage80 rooms bedrooms plumbing kitchen rent80cat vacancy value80 __________ agef raceethf1 raceethf2 sexf citizen80f educcatf1 educcatf2 inschoolf marstatusf esrf wklyrhrf wklyrwkf indf occf commutetimef howcommute80f powcounty80f powtractid80f incwf incpf mig80f mig80lf pobf tenure80f buildingage80f roomsf rent80f vacancyf value80f

drop __________

gen double pid = _n + `ii'/100

**** merge on 1990 tract definitions (residence and pow)
joinby tractid80 using `ctrf9080', unmatched(master)
tab _merge
drop _merge

joinby powtractid80 using `powctrf9080', unmatched(master)
tab _merge
drop _merge

replace pct80pop = pct80pop * powpct80pop if powpct80pop != .
replace pct80pop = powpct80pop if pct80pop == .
replace pct80pop = 0 if pct80pop<0 | pct80pop==.
drop powpct80pop

**** merge on administrative data
joinby tractid90 using `admin', unmatched(master)
tab _merge
drop _merge

joinby powtractid90 using `powadmin', unmatched(master)
tab _merge
drop _merge

compress

**** Create an adjusted person and household weight appropriately allocating the sampling weight across
****     multiple 1990 tracts when CTRF8090 mapping is not one to one
gen pwgt2=pwgt
replace pwgt2 = pwgt2*pct80pop if pct80pop !=.
label variable pwgt2 "Person weight / (merge blockidcount from admin file)"
gen hwgt2=hwgt
replace hwgt2 = hwgt2*pct80pop if pct80pop !=.
label variable hwgt2 "Person weight / (merge blockidcount from admin file)"

**** Create variables defining the sample 
gen sample_winlose = assigned_tract!=.
gen sample_winlose_pow = powassigned_tract!=.
gen sample_placebo = inlist(county80,"06037","13121","17031","24510","26163","36047")==1 | inlist(county80,"34007","36005","36061","39035","42101","36081")==1
gen sample_placebo_pow = inlist(powcounty80,"06037","13121","17031","24510","26163","36047")==1 | inlist(powcounty80,"34007","36005","36061","39035","42101","36081")==1

compress

if `type'==0 {
save `outdata'`statenum`ii'', replace
}
if `type'==1 {
save `powoutdata'`statenum`ii'', replace
}
if `type'==2 {
save `outdata'_5pctnonsample, replace
}

clear

}
}
}

