clear
set more off
set mem 4g

adopath ++ "/public/ado"

local statenum1 = "01"
local statenum2 = "02"
local statenum3 = "04"
local statenum4 = "05"
local statenum5 = "06"
local statenum6 = "08"
local statenum7 = "09"
local statenum8 = "10"
local statenum9 = "11"
local statenum10 = "12"
local statenum11 = "13"
local statenum12 = "17"
local statenum13 = "18"
local statenum14 = "19"
local statenum15 = "20"
local statenum16 = "21"
local statenum17 = "22"
local statenum18 = "24"
local statenum19 = "25"
local statenum20 = "26"
local statenum21 = "27"
local statenum22 = "28"
local statenum23 = "29"
local statenum24 = "31"
local statenum25 = "32"
local statenum26 = "33"
local statenum27 = "34"
local statenum28 = "35"
local statenum29 = "36"
local statenum30 = "37"
local statenum31 = "39"
local statenum32 = "40"
local statenum33 = "41"
local statenum34 = "42"
local statenum35 = "44"
local statenum36 = "45"
local statenum37 = "47"
local statenum38 = "48"
local statenum39 = "49"
local statenum40 = "51"
local statenum41 = "53"
local statenum42 = "54"
local statenum43 = "55"


local cendatadir = "/rdcprojects/mc1/mc00535/data/decennial/01-Raw_Extracts/"
local outdata = "/rdcprojects/mc1/mc00535/data/decennial/02-Recoded_State_Files/dec2000recoded"
local powoutdata = "/rdcprojects/mc1/mc00535/data/decennial/02-Recoded_State_Files/powdec2000recoded"


use "/rdcprojects/mc1/mc00535/data/ezdata/blocklevel_admdata.dta"
keep if keep_1990geography==1
ren tract1990 tractid90
collapse progid_cons progid_power progname program1995 program1999 program2001 application_tract assigned_tract black_city_1970 black_city_1980 black_city_1990 black_city_2000 crime_total_city_1970 crime_total_city_1980 crime_total_city_1990 crime_total_city_2000 manufacture_city_1970 manufacture_city_1980 manufacture_city_1990 manufacture_city_2000 pctgov_city_1970 pctgov_city_1980 pctgov_city_1990 pctgov_city_2000 population_city_1970 population_city_1980 population_city_1990 population_city_2000, by(tractid90 city)
tempfile admin
save `admin'
clear

use "/rdcprojects/mc1/mc00535/data/ezdata/blocklevel_admdata.dta"
keep if keep_1990geography==1
ren tract1990 tractid90
collapse progid_cons progid_power progname program1995 program1999 program2001 application_tract assigned_tract black_city_1970 black_city_1980 black_city_1990 black_city_2000 crime_total_city_1970 crime_total_city_1980 crime_total_city_1990 crime_total_city_2000 manufacture_city_1970 manufacture_city_1980 manufacture_city_1990 manufacture_city_2000 pctgov_city_1970 pctgov_city_1980 pctgov_city_1990 pctgov_city_2000 population_city_1970 population_city_1980 population_city_1990 population_city_2000, by(tractid90 city)

foreach var in tractid90 progid_cons progid_power progname program1995 program1999 program2001 application_tract assigned_tract city black_city_1970 black_city_1980 black_city_1990 black_city_2000 crime_total_city_1970 crime_total_city_1980 crime_total_city_1990 crime_total_city_2000 manufacture_city_1970 manufacture_city_1980 manufacture_city_1990 manufacture_city_2000 pctgov_city_1970 pctgov_city_1980 pctgov_city_1990 pctgov_city_2000 population_city_1970 population_city_1980 population_city_1990 population_city_2000 {
ren `var' pow`var'
}
tempfile powadmin
save `powadmin'
clear

use "/rdcprojects/mc1/mc00535/data/CBRF/CBRF.dta"
tempfile cbrf
save `cbrf'
clear

use "/rdcprojects/mc1/mc00535/data/CBRF/CBRF.dta"
ren blockid90 powblockid90
ren blockid00 powblockid00
tempfile powcbrf
save `powcbrf'
clear


forval type = 0/2 {
forval ii = 1/43 {
if `type'<2 | `ii'==1 {

if `type'==0 {
use "`cendatadir'/dec2000extract`statenum`ii''.dta"
}
if `type'==1 {
use "`cendatadir'/powdec2000extract`statenum`ii''.dta"
}
if `type'==2 {
use "`cendatadir'/dec2000extract_5pctnonsample.dta"
}

**** Create a single place of work county variable
gen powcounty00 = substr(qpowst,2,2)+qpowco
replace powcounty00 = "" if powcounty00=="00000"
gen powblockid00 = substr(qpowst,2,2)+qpowco+qpowtract+qpowbkn
replace powblockid00 = "" if qpowtract+qpowbkn=="9999999999"
replace powblockid00 = "" if qpowtract+qpowbkn=="0000000000"
label variable powcounty00 "Place of Work 2000 state+county"
label variable powblockid00 "Place of Work 2000 state+county+tract+block"
drop qpowst qpowco qpowtract qpowbkn

**** Drop individuals from POW file if POW block is missing
****   (These individuals are on the raw extract because POW state is nonmissing)
drop if `type'==1 & powblockid00==""

gen double pid = _n+(`ii'/100)

**** Create a vairable to use as a visual divider in the variable list
gen __________ = .

**** Rename and label variables that will not be recoded
ren qage age
label define agelab 115 "115 and above"
label values age agelab

ren bcseq gid

ren hwt hwgt

gen hid = string(hseq)
drop hseq

ren qsfn sfn

ren qpobst pob

ren pwt pwgt

ren qctime commutetime

ren qind ind

ren qocc occ

ren qcow cow

ren qwklyrhr wklyrhr

ren qwklyrwk wklyrwk

ren qincwg incw

ren qincpa incp

ren qincss incss

ren qincssi incssi

ren qincret incret

ren qincoth incoth

ren qinctot pinc
label variable pinc "Persons Total Income"

label variable noc "Number of Children (own and adopted)"

**** Create a householder flag
gen householder=qrel=="01"
label variable householder "=1 if person is householder"
drop qrel

**** Create a female householder flag
gen female_head = inlist(hht,"3","6","7") if hht != "0"
label variable female_head "Female Householder"

**** Create a numeric year moved in variable with 2000 categories
gen ymi00 = real(smovein)
label define ymi00_lab 1 "1999 or 2000" 2 "1995 to 1998" 3 "1990 to 1994" 4 "1980 to 1989" 5 "1970 to 1979" 6 "1969 or earlier"
label values ymi00 ymi00_lab
label variable ymi00 "Year Moved in (2000 categories)"
drop smovein

************ Create a numeric vacancy status variable
gen vacancy = real(sisvac)
label define vacancy_lab 0 "NA (Occupied housing unit or seasonal, migratory or GQ)" 1 "For rent" 2 "For sale only" 3 "Rented or sold, not occupied" 4 "Held for occasional usa" 5 "Migratory Workers" 6 "Other vacant"
label values vacancy vacancy_lab
label variable vacancy "Vacancy Status"
drop sisvac

**** Create a numeric employment status recode variable
ren esr esrc
gen esr = real(esrc)
label define esrlab 0 "NA (Under 16 years old)" 1 "In civilian labor force, employed, at work" 2 "employed, but not at work" 3 "unemployed" 4 "In armed forces, at work" 5 "In armed forces, not at work" 6 "Not in labor force"
label values esr esrlab
label variable esr "Employment Status Recode"
drop esrc

**** rename and label the bedroom variable
ren sbedrm bedrooms
replace bedrooms = bedrooms+1
label define bedroomslab 0 "NA (GQ)" 1 "No bedrooms" 2 "1 bedroom" 3 "2 bedrooms" 4 "3 bedrooms" 5 "4 bedrooms" 6 "5 or more bedrooms"
label values bedrooms bedroomslab
label variable bedrooms "Bedrooms"

**** Create a numeric plumbing variable
gen plumbing00 = real(scplumb)
label define plumbing00 1 "Yes" 2 "No"
label values plumbing00 plumbing00lab
label variable plumbing00 "Plumbing, 2000 categories"
drop scplumb

**** Create a numeric plumbing variable
gen kitchen = real(sckitch)
label define kitchenlab 0 "NA (GQ)" 1 "Yes" 2 "No"
label values kitchen kitchenlab
label variable kitchen "Kitchen"
drop sckitch

**** Create a consistent (1990 and 2000) categorical rent variable
label define rentcat_lab 0 "NA/no cash rent" 1 "less than $80" 2 "$80 to $99" 3 "$100 to $124" 4 "$125 to $149" 5 "$150 to $174" 6 "$175 to $199" 7 "$200 to $224" 8 "$225 to $249" 9 "$250 to $274" 10 "$275 to $299" 11 "$300 to $324" 12 "$325 to $349" 13 "$350 to $374" 14 "$375 to $399" 15 "$400 to $424" 16 "$425 to $449" 17 "$450 to $474" 18 "$475 to $499" 19 "$500 to $524" 20 "$525 to $549" 21 "$550 to $599" 22 "$600 to $649" 23 "$650 to $699" 24 "$700 to $749" 25 "$750 to $999" 26 "$1000 or more"
gen rentcat = 0 if srent == .
replace rentcat = 1 if inrange(srent,0,80)==1
replace rentcat = 2 if inrange(srent,80,99)==1
replace rentcat = 3 if inrange(srent,100,124)==1
replace rentcat = 4 if inrange(srent,125,149)==1
replace rentcat = 5 if inrange(srent,150,174)==1
replace rentcat = 6 if inrange(srent,175,199)==1
replace rentcat = 7 if inrange(srent,200,224)==1
replace rentcat = 8 if inrange(srent,225,249)==1
replace rentcat = 9 if inrange(srent,250,274)==1
replace rentcat = 10 if inrange(srent,275,299)==1
replace rentcat = 11 if inrange(srent,300,324)==1
replace rentcat = 12 if inrange(srent,325,349)==1
replace rentcat = 13 if inrange(srent,350,374)==1
replace rentcat = 14 if inrange(srent,375,399)==1
replace rentcat = 15 if inrange(srent,400,424)==1
replace rentcat = 16 if inrange(srent,425,449)==1
replace rentcat = 17 if inrange(srent,450,474)==1
replace rentcat = 18 if inrange(srent,475,499)==1
replace rentcat = 19 if inrange(srent,500,524)==1
replace rentcat = 20 if inrange(srent,525,549)==1
replace rentcat = 21 if inrange(srent,550,599)==1
replace rentcat = 22 if inrange(srent,600,649)==1
replace rentcat = 23 if inrange(srent,650,699)==1
replace rentcat = 24 if inrange(srent,700,749)==1
replace rentcat = 25 if inrange(srent,750,999)==1
replace rentcat = 26 if srent>=1000 & srent!=.
label values rentcat rentcat_lab
label variable rentcat "Rent Category"
drop srent

****Label the rent variable
ren sroom rooms
label define rooms_lab 1 "1 room" 2 "2 rooms" 3 "3 rooms" 4 "4 rooms" 5 "5 rooms" 6 "6 rooms" 7 "7 rooms" 8 "8 rooms" 9 "9 or more rooms"
label values rooms rooms_lab

**** Flag instances where personal income is censored
label define pinc_cen_lab 0 "no censored income vars" 1 "top-coded income var(s)" 2 "bottom-coded income var(s)" 3 "top- and bottom-coded income vars"

gen pinc_cen = 0
replace pinc_cen = 1 if pinc_cen==5299992
replace pinc_cen = 2 if pinc==-19998
label values pinc_cen pinc_cen_lab
label variable pinc_cen "Censored Income Identifier"

**** Create a numeric sex variable
gen sex = real(qsex)
label define sexlab 1 "male" 2 "female"
label values sex sexlab
label var sex "Sex"
drop qsex

**** Create a numeric race/ethnicity variable
gen raceeth = .
replace raceeth = 2 if real(raceb)==1
replace raceeth = 3 if (real(raceasian)==1|real(racenhpi)==1) & raceeth==.
replace raceeth = 1 if real(racew)==1 & real(spanlong)==1 & raceeth==.
replace raceeth = 1 if real(racew)==1 & real(spanlong)==. & raceeth==.
replace raceeth = 4 if raceeth==.
label define raceeth_lab 1 "white, non-hispanic" 2 "black" 3 "asian/pi" 4 "other"
label values raceeth raceeth_lab
label variable raceeth "Race/Ethnicity"
drop racew raceb raceaian raceasian racenhpi racesor

**** Create a hispanic flag
gen hisp = 1-(real(spanlong)==1) if spanlong!=""
drop spanlong

**** Create a numeric citizenship identifier
gen citizen = real(qcitizen)
label define citizen_lab 1 "Yes, born in the United States" 2 "US citizen, born in US territory" 3 "US citizen, born abroad to Am. parents" 4 "US citizen, naturalized" 5 "not a US citizen"
label values citizen citizen_lab
label variable citizen "Citizenship Status"
drop qcitizen

**** Create a numeric education category variable 
**** Code 1990 categories to finest common coarsening of 1990 and 2000 categories
label define educcat_lab 0 "not in universe, age<3" 1 "no schooling completed" 2 "nursery school to 4th grade" 3 "5th grade to 8th grade" 4 "9th grade" 5 "10th grade" 6 "11th grade" 7 "12th grade, no diploma" 8 "high school graduate" 9 "some college" 10 "bachelor's degree" 11 "above bachelor's degree"

gen educcat = .
replace educcat = 0 if real(qhigh)==0
replace educcat = 1 if real(qhigh)==1
replace educcat = 2 if real(qhigh)==2
replace educcat = 3 if real(qhigh)==3
replace educcat = 3 if real(qhigh)==4
replace educcat = 4 if real(qhigh)==5
replace educcat = 5 if real(qhigh)==6
replace educcat = 6 if real(qhigh)==7
replace educcat = 7 if real(qhigh)==8
replace educcat = 8 if real(qhigh)==9
replace educcat = 9 if real(qhigh)==10
replace educcat = 9 if real(qhigh)==11
replace educcat = 9 if real(qhigh)==12
replace educcat = 10 if real(qhigh)==13
replace educcat = 11 if real(qhigh)==14
replace educcat = 11 if real(qhigh)==15
replace educcat = 11 if real(qhigh)==16

label variable educcat "Educational Attainment"
label values educcat educcat_lab
drop qhigh

**** Create a numeric "currently in school" identifier
gen inschool = real(qattend)
label define inschool_lab 0 "age<3" 1 "no" 2 "yes, public school or college" 3 "yes, private school or college"
label values inschool inschool_lab
label variable inschool "Currently Attending School?"
drop qattend

**** Create a numeric marital staus variable
gen marstatus  = real(qms)
label define marstatus_lab 1 "married" 2 "widowed" 3 "divorced" 4 "separated" 5 "never married"
label variable marstatus "Marital Status"
label values marstatus marstatus_lab
drop qms

**** Consolidate geographic variables
gen county00 = state+county
label variable county00 "2000 FIPS state+county"
label variable blockid00 "2000 state+county+tract+block"
drop state county tract block

**** Create a numeric indicator of working the previous week
gen wklwk = real(qwklwk)
replace wklwk = 0 if wklwk==.
label define wklwk_lab 0 "NA/not in univers" 1 "worked" 2 "did not work"
label values wklwk wklwk_lab
label variable wklwk "Any Work Last Week?"
drop qwklwk

**** Identify censored earnings values
label define pern_cen_lab 0 "not censored" 1 "top-coded earnings" 2 "bottom-coded earnings"

gen pern_cen = 0
replace pern_cen = 1 if pern==1999998
replace pern_cen = 2 if pern==-9999
label values pern_cen pern_cen_lab
label variable pern_cen "Censored Earnings Identifier"

**** Create a numeric tenure variable
gen tenure = real(stenure)
label define tenure_lab 0 "NA (GQ or Vacant)" 1 "owned - with mortgage" 2 "owned - free and clear" 3 "rented for cash rent" 4 "no cash rent"
label values tenure tenure_lab
label variable tenure "Tenure"
drop stenure

**** Create a numerical variable describing when housing unit was built
gen buildingage = real(syrblt)
replace buildingage = 8 if buildingage>8
label define buildingage_lab 0 "NA (GQ)" 1 "0-1" 2 "2-5" 3 "6-10" 4 "11-20" 5 "21-30" 6 "31-40" 7 "41-50" 8 "51+"
label values buildingage buildingage_lab
label variable buildingage "Age of Structure"
drop syrblt

**** Create a numerical variable describing the value of the housing unit
gen value=real(svalue)
replace value=22 if inlist(value,23,24)==1
label define value_lab 01 "less than $10,000" 02 "$10,000 to $14,999" 03 "$15,000 to $19,999" 04 "$20,000 to $24,999" 05 "$25,000 to $29,999" 06 "$30,000 to $34,999" 07 "$35,000 to $39,999" 08 "$40,000 to $49,999" 09 "$50,000 to $59,999" 10 "$60,000 to $69,999" 11 "$70,000 to $79,999" 12 "$80,000 to $89,999" 13 "$90,000 to $99,999" 14 "$100,000 to $124,999" 15 "$125,000 to $149,999" 16 "$150,000 to $174,999" 17 "$175,000 to $199,999" 18 "$200,000 to $249,999" 19 "$250,000 to $299,999" 20 "$300,000 to $399,999" 21 "$400,000 to $499,999" 22 "$500,000 or more"
label values value value_lab
label variable value "Value of Current Residence"
drop svalue

**** Create a numerical variable describing method of commute to work
gen howcommute = real(qcommute)
label define howcommute_lab 0 "Not in universe" 1 "car, truck, or van" 2 "bus or trolley bus" 3 "streetcar or trolley car" 4 "subway or elevated" 5 "railroad" 6 "ferryboat" 7 "taxicab" 8 "motorcycle" 9 "bicycle" 10 "walked" 11 "worked at home" 12 "other method"
label values howcommute howcommute_lab
label variable howcommute "Means of Transportation to Work"
drop qcommute

**** Create a numeric migration variable
gen mig = real(qmig)
replace mig = 2 if mig==3
drop qmig
label variable mig "Mobility Status"
label define miglabel 0 "under 5 years old" 1 "same house" 2 "not same house, non-US" 3 "not same house, US"
label values mig miglabel

**** Create a migration county variable for those who lived at a
**** different US house 5 years previous
gen migcounty = substr(qmigst,2,2)+qmigco if mig==2
label variable migcounty "US County of Previous Residence for US Movers"

**** Create a migration country variable for those who lived in a different
**** country 5 years previous
gen migcountry = qmigst if mig==2
label variable migcountry "Country of Previous Residence for non-US Movers"
drop qmigst qmigco

**** Recode allocation flags
gen agef =  real(fage)
label variable agef "Allocation Flag - age"

gen raceethf1 = real(frace)
label variable raceethf1 "Allocation Flag - race component of raceeth"

gen raceethf2 = real(fspan)
label variable raceethf2 "Allocation Flag - hisp component of raceeth"

gen sexf = real(fsex)
label variable sexf "Allocation Flag - sex"

gen citizenf = real(fcitizen)
label variable citizenf "Allocation Flag - citizen"

gen educcatf = real(fhigh)
label variable educcatf "Allocation Flag - educcat"

gen inschoolf = real(fattend)
label variable inschoolf "Allocation Flag - inschool"

gen marstatusf  = real(fms)
label variable marstatusf "Allocation Flag - marstatus"

gen wklyrhrf = real(fwklyrhr)
label variable wklyrhrf "Allocation Flag - wklyrhr"

gen indf = real(find)
label variable indf "Allocation Flag - ind"

gen occf = real(focc)
label variable occf "Allocation Flag - occ"

gen cowf = real(fcow)
label variable occf "Allocation Flag - cow"

gen commutetimef = real(fctime)
label variable commutetimef "Allocation Flag - commutetime"

gen howcommutef = real(fcommute)
label variable howcommutef "Allocation Flag - howcommute"

gen powf1 = real(fpowst)
label variable powf1 "Allocation Flag - powstate"

gen powf3 = real(fpowco)
label variable powf3 "Allocation Flag - pow county"

gen powf5 = real(fpowtract)
label variable powf5 "Allocation Flag - pow tract"

gen pincf = real(finctot)
label variable pincf "Allocation Flag - pinc"

gen migf3 = real(fmigst)
label variable migf3 "Allocation Flag - mig county"

gen migf4 = real(fmigco)
label variable migf4 "Allocation Flag - 2 - migcounty"

gen migf1 = real(fmig)
label variable migf1 "Allocation Flag - mig*"

gen pobf = real(fpob)
label variable pobf "Allocation Flag - pob"

gen tenuref = real(ftenure)
label variable tenuref "Allocation Flag - tenure"

gen buildingagef = real(fyrblt)
label variable buildingagef "Allocation Flag - buildingage"

gen roomsf = real(froom)
label variable roomsf "Allocation Flag - rooms"

gen rentf = real(frent)
label variable rentf "Allocation Flag - rent"

gen valuef = real(fvalue)
label variable valuef "Allocation Flag - value"

gen wklyrwkf = real(fwklyrwk)
label variable wklyrwkf "Allocation Flag - wklyrwk"

gen incwf = real(fincwg)
label variable incwf "Allocation Flag - incw"

gen incpf = real(fincpa)
label variable incpf "Allocation Flag - incp"

gen bedroomsf = real(fbedrm)
label variable bedroomsf "Allocation Flag - bedrooms"

gen plumbing00f = real(fcplumb)
label variable plumbing00f "Allocation Flag - plumbing00"

gen esrf = real(fesr)
label variable esrf "Allocation Flag - esr"

gen kitchenf = real(fckitch)
label variable kitchenf "Allocation Flag - kitchen"

gen vacancyf = real(fsisvac)
label variable vacancyf "Allocation Flag - vacancy"

gen ymif = real(fmovein)
label variable ymif "Allocation Flag - ymiYY"

drop fsex fage fspan frace fms fattend fhigh fancestry flangcode fpob fcitizen fmig fmigst fmigco fpowst fpowco fpowtract fcommute fctime find focc fcow fwklyrhr finctot ftenure fyrblt froom frent fvalue fwklyrwk fesr fincwg fincpa fbedrm fcplumb fckitch fsisvac fmovein

**** Reorder the variables
order gid hid sfn pwgt hwgt county00 blockid00 gq00 age raceeth hisp sex citizen educcat inschool marstatus esr wklwk wklyrhr wklyrwk ind occ cow commutetime howcommute powcounty00 powblockid00 pinc pinc_cen pern pern_cen incw incp hinc finc pov mig migcounty migcountry pob tenure noc buildingage rooms bedrooms plumbing00 kitchen rentcat value __________ agef raceethf1 raceethf2 sexf citizenf educcatf inschoolf marstatusf esrf wklyrhrf indf occf cowf commutetimef howcommutef powf1 powf3 powf5 pincf migf1 migf3 migf4 pobf tenuref buildingagef roomsf rentf ymif valuef

**** Using CBRF, add 1990 geographies (residence and pow)
joinby blockid00 using `cbrf', unmatched(master)
tab _merge
drop _merge

joinby powblockid00 using `powcbrf', unmatched(master)
tab _merge
drop _merge

**** Merge on admin data by 1990 tract
gen tractid90=substr(blockid90,1,11)
gen powtractid90=substr(powblockid90,1,11)

joinby tractid90 using `admin', unmatched(master)
tab _merge
drop _merge

joinby powtractid90 using `powadmin', unmatched(master)
tab _merge
drop _merge

**** Create an adjusted person and household weight appropriately allocating the sampling weight across
****     multiple 1990 blocks when CBRF mapping is not one to one
egen pid_duplicates=sum(1), by(pid)
gen pwgt2=pwgt
replace pwgt2 = pwgt2/pid_duplicates if pid_duplicates !=.
label variable pwgt2 "Person weight / (merge blockidcount from admin file)"
gen hwgt2=hwgt
replace hwgt2 = hwgt2/pid_duplicates if pid_duplicates !=.
label variable hwgt2 "Person weight / (merge blockidcount from admin file)"

**** Create variables defining the sample 
gen sample_winlose = assigned_tract!=.
gen sample_winlose_pow = powassigned_tract!=.
gen sample_placebo = inlist(county00,"06037","13121","17031","24510","26163","36047")==1 | inlist(county00,"34007","36005","36061","39035","42101","36081")==1
gen sample_placebo_pow = inlist(powcounty00,"06037","13121","17031","24510","26163","36047")==1 | inlist(powcounty00,"34007","36005","36061","39035","42101","36081")==1

compress

if `type'==0 {
save `outdata'`statenum`ii'', replace
}
if `type'==1 {
save `powoutdata'`statenum`ii'', replace
}
if `type'==2 {
replace tractid90=substr(blockid00,1,2)+"000000000" if tractid90==""
replace powtractid90=substr(powblockid00,1,2)+"000000000" if powtractid90==""
save `outdata'_5pctnonsample, replace
}
clear

}
}
}

