libname DEC1990 "/decennial/1990cen/1990S/microdata";
libname OUTDATA "/rdcprojects/mc1/mc00535/data/Tract1990_Centroids";


**** Include savastata macro for exporting to stata;
%include "/public/programs/sas/savastata.mac";


**** Write state abbreviations (for states with sample_main=1, assigned_tract in {0,1})
**** to a vector of local macros that can be looped over;

%let state1 = al;
%let state2 = ak;
%let state3 = az;
%let state4 = ar;
%let state5 = ca;
%let state6 = co;
%let state7 = ct;
%let state8 = de;
%let state9 = dc;
%let state10 = fl;
%let state11 = ga;
%let state12 = hi;
%let state13 = id;
%let state14 = il;
%let state15 = in;
%let state16 = ia;
%let state17 = ks;
%let state18 = ky;
%let state19 = la;
%let state20 = me;
%let state21 = md;
%let state22 = ma;
%let state23 = mi;
%let state24 = mn;
%let state25 = ms;
%let state26 = mo;
%let state27 = mt;
%let state28 = ne;
%let state29 = nv;
%let state30 = nh;
%let state31 = nj;
%let state32 = nm;
%let state33 = ny;
%let state34 = nc;
%let state35 = nd;
%let state36 = oh;
%let state37 = ok;
%let state38 = or;
%let state39 = pa;
%let state40 = ri;
%let state41 = sc;
%let state42 = sd;
%let state43 = tn;
%let state44 = tx;
%let state45 = ut;
%let state46 = vt;
%let state47 = va;
%let state48 = wa;
%let state49 = wv;
%let state50 = wi;
%let state51 = wy;


**** Define lists of variables to keep;
%let keepvarsG = blockid90 LAT LONG LANDA;

%macro loops;

data work.Tract1990_XY (keep = &keepvarsG);
set
%do st = 1 %to 51 ;
  DEC1990.t13&&state&st..1990sg
%end;
;


blockid90 = "               ";
if length(trct)=4 then blockid90 = STF||COU||substr(TRCT,1,4)||"00"||BLK ;
if length(trct)=6 then blockid90 = STF||COU||TRCT||BLK ;

run;

%savastata("/rdcprojects/mc1/mc00535/data/Tract1990_Centroids/Block1990_XY.dta", -replace);

%mend;

%loops;
