clear
set mem 1g
set more off


local datadir = "/rdcprojects/mc1/mc00535/data/Tract1990_Centroids/"


use "`datadir'/Block1990_XY"
gen tractid90 = substr(blockid90,1,11)
ren lat lat_c
ren LONG long_c
gen double Y = real(lat_c)
gen double X = real(long_c)
collapse X Y, by(tractid90)
save "`datadir'/Tract1990_XY", replace
clear


use "`datadir'/Block1990_XY"
gen tractid90 = substr(blockid90,1,11)
ren landa landa_c
gen double landa = real(landa_c)
collapse (sum) landa, by(tractid90)
label variable landa "area of tract (sq km/1000)"
save "`datadir'/Tract1990_Areas", replace
clear


