***DESCRIPTION
*This program combines MU-SSL,SU-SSL and LBD files for the years 1987-2001.Keeps the selected variables and counties in the list. Creates a newtract varible based on the information on SSEL;




 ******************************************YEAR:1998 ************************************************;
 *MACROS;
%let yr=1998;
libname BR '/economic/ssl/microdata/';
data ssl&yr.su;
set BR.ssl&yr.su;
run;

************************************************************;
************************************************************;
*(1) Single-Unit File;
************************************************************;
************************************************************;
%let yr=1998;
data ssl&yr.su(keep=  employment employmentsu payrollsu srecnum   pst salereceiptsu newtract mstreet
mplce mst mzip same_as
newtractsu actsu cfnsu lfosu sicsu zipsu blkgeosu blksfxsu cdgeosu ctygeosu indsu indsubsu lfo1su npisu pdivsu plcesu plgeosu ppnsu
sic56su stgeosu streetsu tocsu tractsu acfsu einsu 
AC943E AC943P acap ACEMP ACEMPF ACF ACSR1 ACSR1F ACSR2 ACSR2F ACSR3 ACSR3F
ACSR4 ACSR4F ACT ANNPR BLKGEO BLKSFX CDGEO CFN CTYGEO EIN EMPCD IND INDSUB
LFO LFO1   NPI PDIV PLCE PLGEO PPLCE PPN PSTREET PZIP
RECNUM SIC SIC56 SSABR
SSACL SSAEMP STGEO STREET TOC TRACT ZIP );	
 set BR.ssl&yr.su;
 *************Creating new tract variable;

length NEWTRACT $ 11;
If tract^=' ' & STGEO^=' ' & CTYGEO^=' ' then NEWTRACT=STGEO||CTYGEO||TRACT;
else newtract=" ";



Employment=ACEMP;
Employmentsu=ACEMP;
**************Exclude submasters;
if PDIV^='M';
*Exclude inactive units;
acap = ACQP1+ACQP2+ACQP3+ACQP4;
if acap>0| AC943P>0;

payrollsu =acap;
 srecnum=recnum;
salereceiptsu=acsr1;
*Identify the source of the common variables;
newtractsu=newtract;
actsu=act; cfnsu=cfn; lfosu=lfo ; sicsu=sic ;zipsu=zip; blkgeosu=blkgeo; blksfxsu=blksfx;
cdgeosu=cdgeo; ctygeosu=ctygeo; indsu=ind; indsubsu=indsub; lfo1su=lfo1;
 npisu=npi; pdivsu=pdiv; plcesu=plce; plgeosu=plgeo; ppnsu=ppn;
sic56su=sic56; stgeosu=stgeo; streetsu=street; tocsu=toc; tractsu=tract; acfsu=acf;
einsu=ein;
run;


*******
%let yr=1998;
libname BR '/economic/ssl/microdata/';
data ssl&yr.mu;
set BR.ssl&yr.mu;
run;


 *(2) Multi-Unit File;
************************************************************;
************************************************************;
%let yr=1998;
data ssl&yr.mu(keep=employment employmentmu payrollmu mrecnum  newtract  salereceiptmu  
 newtractmu actmu cfnmu lfomu sicmu zipmu blkgeomu blksfxmu cdgeomu ctygeomu indmu indsubmu lfo1mu npimu 
pdivmu plcemu plgeomu ppnmu
sic56mu stgeomu streetmu tocmu tractmu acfmu einmu 
ACF ACT
BLKGEO BLKSFX CDGEO
CFN CTYGEO CYTE EIN GAT IND INDSUB LFO LFO1 NPI PDIV
PLCE PLGEO PPN RAP RAPF RECNUM REMP REMPF RSR RSRF
SIC	SIC56	STGEO	STREET	TOC TRACT ZIP);	
 set BR.ssl&yr.mu;
 *************Creating new tract variable;

length NEWTRACT $ 11;
If tract^=' ' & STGEO^=' ' & CTYGEO^=' ' then NEWTRACT=STGEO||CTYGEO||TRACT;
else newtract=" ";

**************Exclude ghosts;
if ACT^='G';
**************Exclude inactive units;
if rap>0| (rap=0 & (RAPF^='Z' & ACT^='D'));

EMPLOYMENT=REMP;
EMPLOYMENTmu=REMP;
PAYROLLmu=RAP;
salereceiptmu=RSR;	
mrecnum=recnum;
*Identify the source of the common variables;
newtractmu=newtract;
actmu=act; cfnmu=cfn; lfomu=lfo ; sicmu=sic ;zipmu=zip; blkgeomu=blkgeo; blksfxmu=blksfx;
cdgeomu=cdgeo; ctygeomu=ctygeo; indmu=ind; indsubmu=indsub; lfo1mu=lfo1;
 npimu=npi; pdivmu=pdiv; plcemu=plce; plgeomu=plgeo; ppnmu=ppn;
sic56mu=sic56; stgeomu=stgeo; streetmu=street; tocmu=toc; tractmu=tract; acfmu=acf;
einmu=ein;
run;
************************************************************;
************************************************************ ;



*LBD File;
************************************************************;
************************************************************;
%let yr=1998;
libname lbd '/economic/lbd/microdata';
data lbd&yr.c;
set lbd.lbd&yr.c;
*Drop missing recnum and MU observations;
recnumx=put(recnum,8.);
mux=put(mu,1.);
if recnumx^=' ';
if MUx^=' ';
*Exclude submasters in LBD coming from SU file;
if MU=0 & PDIV='M' then delete;

/*
*Exclude inactive units;
if PAY>0;
*/

*Exclude ghosts in LBD coming from MU file;
if ACT='G' & MU=1 then delete;
run;

**************Creating srecnum mrecnum variables in lbd file and keeping the selected variables;
%let yr=1998;
data work.lbd&yr.c_rec(keep= mrecnum srecnum  payrolllbd employmentlbd
actlbd cfnlbd lfolbd siclbd ziplbd
ACT	BESTNAICs	BESTSIC	CFN	COUNTY	EMP	FIRMID	FIRSTYEAr	
FLAGA	FLAGB	
LASTYEAR LBDNUM	LFO	MU	PAY	RECNUM	SIC STATE YR ZIP);
set work.lbd&yr.c;

if MU=1 then MRECNUM=RECNUM;
if MU=0 then SRECNUM=RECNUM;

payrolllbd=pay;	
employmentlbd=emp;
actlbd=act;
 cfnlbd=cfn;
 lfolbd=lfo;
 siclbd=sic ;
ziplbd=zip; 
run;

**************Checking mu  in LBD;
%let yr=1998;
proc means data=lbd&yr.c_rec;
var mu;
where mu=1;
run;

%let yr=1998;
proc means data=lbd&yr.c_rec;
var mu;
where mu=0;
run;


**************Checking mrecnum and srecnum variables in SU-SSL and MU-SSL ;
%let yr=1998;
Proc means data=ssl&yr.mu;
var mrecnum;
run;
%let yr=1998;
Proc means data=ssl&yr.su;
var srecnum;
run;

************************************************************;
************************************************************;
*Merging SSL and LBD;
************************************************************;
************************************************************;
*************1)Combine SU SSL and LBD by srecnum;
%let yr=1998;
proc sort data=work.lbd&yr.c_rec out=lbd98_s;
by SRECNUM;
run;

proc sort data=work.ssl&yr.su out=sussl98nt;
by SRECNUM;
run;

data work.su_ssllbd1998;
merge lbd98_s(in=one) sussl98nt(in=two);
fromlbd98_s=one;
fromsussl98nt=two;
by SRECNUM;
run;

data work.su_ssllbd1998;
set work.su_ssllbd1998;
srecnumx=put(srecnum,8.);
recnumx=put(recnum,8.);
mux=put(mu,1.);
if recnumx^=' ';
if MUx^=' ';
if srecnumx^=' ';
RUN;

*************2)Combine MU SSL and LBD by Mrecnum;
%let yr=1998;
proc sort data=work.lbd&yr.c_rec out=lbd98_M;
by MRECNUM;
run;

proc sort data=work.ssl&yr.mu out=mussl98nt;
by MRECNUM;
run;

data work.mu_ssllbd1998;
merge lbd98_M(in=one) mussl98nt(in=two);
fromlbd98_m=one;
frommussl98nt =two;
by MRECNUM;
run;

data work.mu_ssllbd1998;
set work.mu_ssllbd1998;
mrecnumx=put(mrecnum,8.);
recnumx=put(recnum,8.);
mux=put(mu,1.);
if recnumx^=' ';
if MUx^=' ';
if mrecnumx^=' ';
RUN;


**************3-A)Combine SU-SSLLBD &MUSSL-LBD FILES;
%let yr=1998;
data ssllbd&yr.;
set work.su_ssllbd1998(in=a)
work.mu_ssllbd1998 (in=b);
if a then SU2=1;else SU2=0;
if b then MU2=1;else MU2=0;
year=&yr.;
run;


%let yr=1998;
data ssllbd&yr;
length newfips $5;
set work.ssllbd&yr;
ctygeox=put(ctygeo,3.);
stgeox=put(stgeo,2.);
If ctygeox^=' ' & stgeox^=' ' then newfips=stgeox||ctygeox;
else newfips=" ";
run;


data ssllbd&yr;
set work.ssllbd&yr;
**Keeping the counties listed;
where newfips="01015"
or newfips="01073"
or newfips="01097"
or newfips="02090"
or newfips="04013"
or newfips="04019"
or newfips="05069"
or newfips="05119"
or newfips="06001"
or newfips="06019"
or newfips="06037"
or newfips="06059"
or newfips="06067"
or newfips="06073"
or newfips="06075"
or newfips="08001"
or newfips="08031"
or newfips="08123"
or newfips="09001"
or newfips="09003"
or newfips="09009"
or newfips="10003"
or newfips="11001"
or newfips="12011"
or newfips="12031"
or newfips="12057"
or newfips="12086"
or newfips="13051"
or newfips="13089"
or newfips="13095"
or newfips="13121"
or newfips="17031"
or newfips="17143"
or newfips="17163"
or newfips="17167"
or newfips="18089"
or newfips="18097"
or newfips="19153"
or newfips="19193"
or newfips="20209"
or newfips="21111"
or newfips="22017"
or newfips="22019"
or newfips="22051"
or newfips="22071"
or newfips="22073"
or newfips="24510"
or newfips="25009"
or newfips="25013"
or newfips="25017"
or newfips="25025"
or newfips="26021"
or newfips="26049"
or newfips="26121"
or newfips="26163"
or newfips="27053"
or newfips="27123"
or newfips="28049"
or newfips="29047"
or newfips="29095"
or newfips="29165"
or newfips="29189"
or newfips="29510"
or newfips="31055"
or newfips="32003"
or newfips="33011"
or newfips="34007"
or newfips="34011"
or newfips="34013"
or newfips="34017"
or newfips="34039"
or newfips="35001"
or newfips="35013"
or newfips="36005"
or newfips="36029"
or newfips="36047"
or newfips="36055"
or newfips="36061"
or newfips="36063"
or newfips="36067"
or newfips="36071"
or newfips="36081"
or newfips="36085"
or newfips="36093"
or newfips="36119"
or newfips="37119"
or newfips="39017"
or newfips="39035"
or newfips="39045"
or newfips="39049"
or newfips="39061"
or newfips="39081"
or newfips="39087"
or newfips="39099"
or newfips="39153"
or newfips="40017"
or newfips="40027"
or newfips="40109"
or newfips="41051"
or newfips="42003"
or newfips="42043"
or newfips="42045"
or newfips="42101"
or newfips="44007"
or newfips="45019"
or newfips="45079"
or newfips="45085"
or newfips="47037"
or newfips="47065"
or newfips="47093"
or newfips="47157"
or newfips="48029"
or newfips="48085"
or newfips="48113"
or newfips="48121"
or newfips="48141"
or newfips="48157"
or newfips="48201"
or newfips="48245"
or newfips="48309"
or newfips="48355"
or newfips="48361"
or newfips="48439"
or newfips="48453"
or newfips="48491"
or newfips="49057"
or newfips="51710"
or newfips="51740"
or newfips="51760"
or newfips="53033"
or newfips="53053"
or newfips="53077"
or newfips="54009"
or newfips="54011"
or newfips="54039"
or newfips="54099"
or newfips="55079"

or newfips="01117"
or newfips="04027"
or newfips="08005"
or newfips="08059"
or newfips="08035"
or newfips="11031"
or newfips="12025"
or newfips="13063"
or newfips="13135"
or newfips="13177"
or newfips="17005"
or newfips="17043"
or newfips="17097"
or newfips="18057"
or newfips="24005"
or newfips="26125"
or newfips="27003"
or newfips="27163"
or newfips="28121"
or newfips="31153"
or newfips="32009"
or newfips="35043"
or newfips="36105"
or newfips="36001"
or newfips="36079"
or newfips="37179"
or newfips="39085"
or newfips="39041"
or newfips="39025"
or newfips="39155"
or newfips="41005"
or newfips="44003"
or newfips="45063"
or newfips="47187"
or newfips="48251"
or newfips="48367"
or newfips="51810"
or newfips="51041"
or newfips="51087"
or newfips="55133";
run;


**************3-B)Eliminating EINs that appear in both the SU(not submaster)
and MU files,keeping MU information suggested by Miranda(2002);
%let yr=1998;
proc sort data=work.ssllbd&yr OUT=work.ssllbd&yr;by EIN;
proc means data=work.ssllbd&yr noprint;
by EIN;
output out=work.dups(drop=_TYPE_ _FREQ_)
n(EMPLOYMENT)=EIN_COUNT;
run;

data ssllbd&yr;
merge work.ssllbd&yr (in=a) work.dups(in=b);
by EIN;
*We are concerned about EINs that are in the SU(not submaster) and MU;
if EIN_COUNT>1 & SU2=1 & PDIV^='M' then delete;
run;


*save the merged ssllbd data;
data "/rdcprojects/mc00535/data/ssllbd/ssllbd&yr "(compress=yes);
set ssllbd&yr;
drop fromlbd98_s fromlbd98_m frommussl98nt fromsussl98nt  SU2 MU2 srecnum mrecnum EIN_COUNT;
run;

proc datasets lib=work;
delete
dups lbd1998c lbd1998c_rec lbd98_m lbd98_s
mussl98nt sussl98nt mu_ssllbd1998 su_ssllbd1998
ssl1998mu ssl1998su ssllbd1998;
run;




 ******************************************YEAR:1999 ************************************************;
 *MACROS;
%let yr=1999;
libname BR '/economic/ssl/microdata/';
data ssl&yr.su;
set BR.ssl&yr.su;
run;

************************************************************;
************************************************************;
*(1) Single-Unit File;
************************************************************;
************************************************************;
%let yr=1999;
data ssl&yr.su(keep=  employment employmentsu payrollsu srecnum   pst salereceiptsu newtract mstreet
mplce mst mzip same_as
newtractsu actsu cfnsu lfosu sicsu zipsu blkgeosu blksfxsu cdgeosu ctygeosu indsu indsubsu lfo1su npisu pdivsu plcesu plgeosu ppnsu
sic56su stgeosu streetsu tocsu tractsu acfsu einsu
AC943E AC943P acap ACEMP ACEMPF ACF ACSR1 ACSR1F ACSR2 ACSR2F ACSR3 ACSR3F
ACSR4 ACSR4F ACT ANNPR BLKGEO BLKSFX CDGEO CFN CTYGEO EIN EMPCD IND INDSUB
LFO LFO1   NPI PDIV PLCE PLGEO PPLCE PPN PSTREET PZIP
RECNUM SIC SIC56 SSABR
SSACL SSAEMP STGEO STREET TOC TRACT ZIP );	
 set BR.ssl&yr.su;
 *************Creating new tract variable;

length NEWTRACT $ 11;
If tract^=' ' & STGEO^=' ' & CTYGEO^=' ' then NEWTRACT=STGEO||CTYGEO||TRACT;
else newtract=" ";



Employment=ACEMP;
Employmentsu=ACEMP;
**************Exclude submasters;
if PDIV^='M';
*Exclude inactive units;
acap = ACQP1+ACQP2+ACQP3+ACQP4;
if acap>0| AC943P>0;

payrollsu =acap;
 srecnum=recnum;
salereceiptsu=acsr1;
*Identify the source of the common variables;
newtractsu=newtract;
actsu=act; cfnsu=cfn; lfosu=lfo ; sicsu=sic ;zipsu=zip; blkgeosu=blkgeo; blksfxsu=blksfx;
cdgeosu=cdgeo; ctygeosu=ctygeo; indsu=ind; indsubsu=indsub; lfo1su=lfo1;
 npisu=npi; pdivsu=pdiv; plcesu=plce; plgeosu=plgeo; ppnsu=ppn;
sic56su=sic56; stgeosu=stgeo; streetsu=street; tocsu=toc; tractsu=tract; acfsu=acf;
einsu=ein;
run;


*******
%let yr=1999;
libname BR '/economic/ssl/microdata/';
data ssl&yr.mu;
set BR.ssl&yr.mu;
run;


 *(2) Multi-Unit File;
************************************************************;
************************************************************;
%let yr=1999;
data ssl&yr.mu(keep=employment employmentmu payrollmu mrecnum  newtract  salereceiptmu  
 newtractmu actmu cfnmu lfomu sicmu zipmu blkgeomu blksfxmu cdgeomu ctygeomu indmu indsubmu lfo1mu npimu 
pdivmu plcemu plgeomu ppnmu
sic56mu stgeomu streetmu tocmu tractmu acfmu einmu 
ACF ACT
BLKGEO BLKSFX CDGEO
CFN CTYGEO CYTE EIN GAT IND INDSUB LFO LFO1 NPI PDIV
PLCE PLGEO PPN RAP RAPF RECNUM REMP REMPF RSR RSRF
SIC	SIC56	STGEO	STREET	TOC TRACT ZIP);	
 set BR.ssl&yr.mu;
 *************Creating new tract variable;

length NEWTRACT $ 11;
If tract^=' ' & STGEO^=' ' & CTYGEO^=' ' then NEWTRACT=STGEO||CTYGEO||TRACT;
else newtract=" ";

**************Exclude ghosts;
if ACT^='G';
**************Exclude inactive units;
if rap>0| (rap=0 & (RAPF^='Z' & ACT^='D'));

EMPLOYMENT=REMP;
EMPLOYMENTmu=REMP;
PAYROLLmu=RAP;
salereceiptmu=RSR;	
mrecnum=recnum;
*Identify the source of the common variables;
newtractmu=newtract;
actmu=act; cfnmu=cfn; lfomu=lfo ; sicmu=sic ;zipmu=zip; blkgeomu=blkgeo; blksfxmu=blksfx;
cdgeomu=cdgeo; ctygeomu=ctygeo; indmu=ind; indsubmu=indsub; lfo1mu=lfo1;
 npimu=npi; pdivmu=pdiv; plcemu=plce; plgeomu=plgeo; ppnmu=ppn;
sic56mu=sic56; stgeomu=stgeo; streetmu=street; tocmu=toc; tractmu=tract; acfmu=acf;
einmu=ein;
run;
************************************************************;
************************************************************ ;



*LBD File;
************************************************************;
************************************************************;
%let yr=1999;
libname lbd '/economic/lbd/microdata';
data lbd&yr.c;
set lbd.lbd&yr.c;
*Drop missing recnum and MU observations;
recnumx=put(recnum,8.);
mux=put(mu,1.);
if recnumx^=' ';
if MUx^=' ';
*Exclude submasters in LBD coming from SU file;
if MU=0 & PDIV='M' then delete;

/*
*Exclude inactive units;
if PAY>0;
*/

*Exclude ghosts in LBD coming from MU file;
if ACT='G' & MU=1 then delete;
run;

**************Creating srecnum mrecnum variables in lbd file and keeping the selected variables;
%let yr=1999;
data work.lbd&yr.c_rec(keep= mrecnum srecnum  payrolllbd employmentlbd
actlbd cfnlbd lfolbd siclbd ziplbd 
ACT	BESTNAICs	BESTSIC	CFN	COUNTY	EMP	FIRMID	FIRSTYEAr	
FLAGA	FLAGB	
LASTYEAR LBDNUM	LFO	MU	PAY	RECNUM	SIC STATE YR ZIP);
set work.lbd&yr.c;

if MU=1 then MRECNUM=RECNUM;
if MU=0 then SRECNUM=RECNUM;

payrolllbd=pay;	
employmentlbd=emp;
actlbd=act;
 cfnlbd=cfn;
 lfolbd=lfo;
 siclbd=sic ;
ziplbd=zip; 
run;

**************Checking mu  in LBD;
%let yr=1999;
proc means data=lbd&yr.c_rec;
var mu;
where mu=1;
run;

%let yr=1999;
proc means data=lbd&yr.c_rec;
var mu;
where mu=0;
run;


**************Checking mrecnum and srecnum variables in SU-SSL and MU-SSL ;
%let yr=1999;
Proc means data=ssl&yr.mu;
var mrecnum;
run;
%let yr=1999;
Proc means data=ssl&yr.su;
var srecnum;
run;

************************************************************;
************************************************************;
*Merging SSL and LBD;
************************************************************;
************************************************************;
*************1)Combine SU SSL and LBD by srecnum;
%let yr=1999;
proc sort data=work.lbd&yr.c_rec out=lbd99_s;
by SRECNUM;
run;

proc sort data=work.ssl&yr.su out=sussl99nt;
by SRECNUM;
run;

data work.su_ssllbd1999;
merge lbd99_s(in=one) sussl99nt(in=two);
fromlbd99_s=one;
fromsussl99nt=two;
by SRECNUM;
run;

data work.su_ssllbd1999;
set work.su_ssllbd1999;
srecnumx=put(srecnum,8.);
recnumx=put(recnum,8.);
mux=put(mu,1.);
if recnumx^=' ';
if MUx^=' ';
if srecnumx^=' ';
RUN;

*************2)Combine MU SSL and LBD by Mrecnum;
%let yr=1999;
proc sort data=work.lbd&yr.c_rec out=lbd99_M;
by MRECNUM;
run;

proc sort data=work.ssl&yr.mu out=mussl99nt;
by MRECNUM;
run;

data work.mu_ssllbd1999;
merge lbd99_M(in=one) mussl99nt(in=two);
fromlbd99_m=one;
frommussl99nt =two;
by MRECNUM;
run;

data work.mu_ssllbd1999;
set work.mu_ssllbd1999;
mrecnumx=put(mrecnum,8.);
recnumx=put(recnum,8.);
mux=put(mu,1.);
if recnumx^=' ';
if MUx^=' ';
if mrecnumx^=' ';
RUN;


**************3-A)Combine SU-SSLLBD &MUSSL-LBD FILES;
%let yr=1999;
data ssllbd&yr.;
set work.su_ssllbd1999(in=a)
work.mu_ssllbd1999 (in=b);
if a then SU2=1;else SU2=0;
if b then MU2=1;else MU2=0;
year=&yr.;
run;


**Create a newfips variable;
%let yr=1999;
data ssllbd&yr;
length newfips $5;
set work.ssllbd&yr;
ctygeox=put(ctygeo,3.);
stgeox=put(stgeo,2.);
If ctygeox^=' ' & stgeox^=' ' then newfips=stgeox||ctygeox;
else newfips=" ";
run;


data ssllbd&yr;
set work.ssllbd&yr;
**Keeping the counties listed;
where newfips="01015"
or newfips="01073"
or newfips="01097"
or newfips="02090"
or newfips="04013"
or newfips="04019"
or newfips="05069"
or newfips="05119"
or newfips="06001"
or newfips="06019"
or newfips="06037"
or newfips="06059"
or newfips="06067"
or newfips="06073"
or newfips="06075"
or newfips="08001"
or newfips="08031"
or newfips="08123"
or newfips="09001"
or newfips="09003"
or newfips="09009"
or newfips="10003"
or newfips="11001"
or newfips="12011"
or newfips="12031"
or newfips="12057"
or newfips="12086"
or newfips="13051"
or newfips="13089"
or newfips="13095"
or newfips="13121"
or newfips="17031"
or newfips="17143"
or newfips="17163"
or newfips="17167"
or newfips="18089"
or newfips="18097"
or newfips="19153"
or newfips="19193"
or newfips="20209"
or newfips="21111"
or newfips="22017"
or newfips="22019"
or newfips="22051"
or newfips="22071"
or newfips="22073"
or newfips="24510"
or newfips="25009"
or newfips="25013"
or newfips="25017"
or newfips="25025"
or newfips="26021"
or newfips="26049"
or newfips="26121"
or newfips="26163"
or newfips="27053"
or newfips="27123"
or newfips="28049"
or newfips="29047"
or newfips="29095"
or newfips="29165"
or newfips="29189"
or newfips="29510"
or newfips="31055"
or newfips="32003"
or newfips="33011"
or newfips="34007"
or newfips="34011"
or newfips="34013"
or newfips="34017"
or newfips="34039"
or newfips="35001"
or newfips="35013"
or newfips="36005"
or newfips="36029"
or newfips="36047"
or newfips="36055"
or newfips="36061"
or newfips="36063"
or newfips="36067"
or newfips="36071"
or newfips="36081"
or newfips="36085"
or newfips="36093"
or newfips="36119"
or newfips="37119"
or newfips="39017"
or newfips="39035"
or newfips="39045"
or newfips="39049"
or newfips="39061"
or newfips="39081"
or newfips="39087"
or newfips="39099"
or newfips="39153"
or newfips="40017"
or newfips="40027"
or newfips="40109"
or newfips="41051"
or newfips="42003"
or newfips="42043"
or newfips="42045"
or newfips="42101"
or newfips="44007"
or newfips="45019"
or newfips="45079"
or newfips="45085"
or newfips="47037"
or newfips="47065"
or newfips="47093"
or newfips="47157"
or newfips="48029"
or newfips="48085"
or newfips="48113"
or newfips="48121"
or newfips="48141"
or newfips="48157"
or newfips="48201"
or newfips="48245"
or newfips="48309"
or newfips="48355"
or newfips="48361"
or newfips="48439"
or newfips="48453"
or newfips="48491"
or newfips="49057"
or newfips="51710"
or newfips="51740"
or newfips="51760"
or newfips="53033"
or newfips="53053"
or newfips="53077"
or newfips="54009"
or newfips="54011"
or newfips="54039"
or newfips="54099"
or newfips="55079"

or newfips="01117"
or newfips="04027"
or newfips="08005"
or newfips="08059"
or newfips="08035"
or newfips="11031"
or newfips="12025"
or newfips="13063"
or newfips="13135"
or newfips="13177"
or newfips="17005"
or newfips="17043"
or newfips="17097"
or newfips="18057"
or newfips="24005"
or newfips="26125"
or newfips="27003"
or newfips="27163"
or newfips="28121"
or newfips="31153"
or newfips="32009"
or newfips="35043"
or newfips="36105"
or newfips="36001"
or newfips="36079"
or newfips="37179"
or newfips="39085"
or newfips="39041"
or newfips="39025"
or newfips="39155"
or newfips="41005"
or newfips="44003"
or newfips="45063"
or newfips="47187"
or newfips="48251"
or newfips="48367"
or newfips="51810"
or newfips="51041"
or newfips="51087"
or newfips="55133";
run;



**************3-B)Eliminating EINs that appear in both the SU(not submaster)
and MU files,keeping MU information suggested by Miranda(2002);
%let yr=1999;
proc sort data=work.ssllbd&yr OUT=work.ssllbd&yr;by EIN;
proc means data=work.ssllbd&yr noprint;
by EIN;
output out=work.dups(drop=_TYPE_ _FREQ_)
n(EMPLOYMENT)=EIN_COUNT;
run;

data ssllbd&yr;
merge work.ssllbd&yr (in=a) work.dups(in=b);
by EIN;
*We are concerned about EINs that are in the SU(not submaster) and MU;
if EIN_COUNT>1 & SU2=1 & PDIV^='M' then delete;
run;


*save the merged ssllbd data;
data "/rdcprojects/mc00535/data/ssllbd/ssllbd&yr "(compress=yes);
set ssllbd&yr;
drop fromlbd99_s fromlbd99_m frommussl99nt fromsussl99nt  SU2 MU2 srecnum mrecnum EIN_COUNT;
run;

proc datasets lib=work;
delete
dups lbd1999c lbd1999c_rec lbd99_m lbd99_s
mussl99nt sussl99nt mu_ssllbd1999 su_ssllbd1999
ssl1999mu ssl1999su ssllbd1999;
run;




 ******************************************YEAR:2000 ************************************************;
 *MACROS;
%let yr=2000;
libname BR '/economic/ssl/microdata/';
data ssl&yr.su;
set BR.ssl&yr.su;
run;

************************************************************;
************************************************************;
*(1) Single-Unit File;
************************************************************;
************************************************************;
%let yr=2000;
data ssl&yr.su(keep=  employment employmentsu payrollsu srecnum   pst salereceiptsu newtract mstreet
mplce mst mzip same_as
newtractsu actsu cfnsu lfosu sicsu zipsu blkgeosu blksfxsu cdgeosu ctygeosu indsu indsubsu lfo1su npisu pdivsu plcesu plgeosu ppnsu
sic56su stgeosu streetsu tocsu tractsu acfsu einsu 
AC943E AC943P acap ACEMP ACEMPF ACF ACSR1 ACSR1F ACSR2 ACSR2F ACSR3 ACSR3F
ACSR4 ACSR4F ACT ANNPR BLKGEO BLKSFX CDGEO CFN CTYGEO EIN EMPCD IND INDSUB
LFO LFO1   NPI PDIV PLCE PLGEO PPLCE PPN PSTREET PZIP
RECNUM SIC SIC56 SSABR
SSACL SSAEMP STGEO STREET TOC TRACT ZIP );	
 set BR.ssl&yr.su;
 *************Creating new tract variable;

length NEWTRACT $ 11;
If tract^=' ' & STGEO^=' ' & CTYGEO^=' ' then NEWTRACT=STGEO||CTYGEO||TRACT;
else newtract=" ";



Employment=ACEMP;
Employmentsu=ACEMP;
**************Exclude submasters;
if PDIV^='M';
*Exclude inactive units;
acap = ACQP1+ACQP2+ACQP3+ACQP4;
if acap>0| AC943P>0;

payrollsu =acap;
 srecnum=recnum;
salereceiptsu=acsr1;
*Identify the source of the common variables;
newtractsu=newtract;
actsu=act; cfnsu=cfn; lfosu=lfo ; sicsu=sic ;zipsu=zip; blkgeosu=blkgeo; blksfxsu=blksfx;
cdgeosu=cdgeo; ctygeosu=ctygeo; indsu=ind; indsubsu=indsub; lfo1su=lfo1;
 npisu=npi; pdivsu=pdiv; plcesu=plce; plgeosu=plgeo; ppnsu=ppn;
sic56su=sic56; stgeosu=stgeo; streetsu=street; tocsu=toc; tractsu=tract; acfsu=acf;
einsu=ein;

run;


*******
%let yr=2000;
libname BR '/economic/ssl/microdata/';
data ssl&yr.mu;
set BR.ssl&yr.mu;
run;


 *(2) Multi-Unit File;
************************************************************;
************************************************************;
%let yr=2000;
data ssl&yr.mu(keep=employment employmentmu payrollmu mrecnum  newtract  salereceiptmu  
 newtractmu actmu cfnmu lfomu sicmu zipmu blkgeomu blksfxmu cdgeomu ctygeomu indmu indsubmu lfo1mu npimu 
pdivmu plcemu plgeomu ppnmu
sic56mu stgeomu streetmu tocmu tractmu acfmu einmu 
ACF ACT
BLKGEO BLKSFX CDGEO
CFN CTYGEO CYTE EIN GAT IND INDSUB LFO LFO1 NPI PDIV
PLCE PLGEO PPN RAP RAPF RECNUM REMP REMPF RSR RSRF
SIC	SIC56	STGEO	STREET	TOC TRACT ZIP);	
 set BR.ssl&yr.mu;
 *************Creating new tract variable;

length NEWTRACT $ 11;
If tract^=' ' & STGEO^=' ' & CTYGEO^=' ' then NEWTRACT=STGEO||CTYGEO||TRACT;
else newtract=" ";

**************Exclude ghosts;
if ACT^='G';
**************Exclude inactive units;
if rap>0| (rap=0 & (RAPF^='Z' & ACT^='D'));

EMPLOYMENT=REMP;
EMPLOYMENTmu=REMP;
PAYROLLmu=RAP;
salereceiptmu=RSR;	
mrecnum=recnum;
*Identify the source of the common variables;
newtractmu=newtract;
actmu=act; cfnmu=cfn; lfomu=lfo ; sicmu=sic ;zipmu=zip; blkgeomu=blkgeo; blksfxmu=blksfx;
cdgeomu=cdgeo; ctygeomu=ctygeo; indmu=ind; indsubmu=indsub; lfo1mu=lfo1;
 npimu=npi; pdivmu=pdiv; plcemu=plce; plgeomu=plgeo; ppnmu=ppn;
sic56mu=sic56; stgeomu=stgeo; streetmu=street; tocmu=toc; tractmu=tract; acfmu=acf;
einmu=ein;
run;
************************************************************;
************************************************************ ;



*LBD File;
************************************************************;
************************************************************;
%let yr=2000;
libname lbd '/economic/lbd/microdata';
data lbd&yr.c;
set lbd.lbd&yr.c;
*Drop missing recnum and MU observations;
recnumx=put(recnum,8.);
mux=put(mu,1.);
if recnumx^=' ';
if MUx^=' ';
*Exclude submasters in LBD coming from SU file;
if MU=0 & PDIV='M' then delete;

/*
*Exclude inactive units;
if PAY>0;
*/

*Exclude ghosts in LBD coming from MU file;
if ACT='G' & MU=1 then delete;
run;

**************Creating srecnum mrecnum variables in lbd file and keeping the selected variables;
%let yr=2000;
data work.lbd&yr.c_rec(keep= mrecnum srecnum  payrolllbd employmentlbd
actlbd cfnlbd lfolbd siclbd ziplbd 
ACT	BESTNAICs	BESTSIC	CFN	COUNTY	EMP	FIRMID	FIRSTYEAr	
FLAGA	FLAGB	
LASTYEAR LBDNUM	LFO	MU	PAY	RECNUM	SIC STATE YR ZIP);
set work.lbd&yr.c;

if MU=1 then MRECNUM=RECNUM;
if MU=0 then SRECNUM=RECNUM;

payrolllbd=pay;	
employmentlbd=emp;
actlbd=act;
 cfnlbd=cfn;
 lfolbd=lfo;
 siclbd=sic ;
ziplbd=zip; 
run;

**************Checking mu  in LBD;
%let yr=2000;
proc means data=lbd&yr.c_rec;
var mu;
where mu=1;
run;

%let yr=2000;
proc means data=lbd&yr.c_rec;
var mu;
where mu=0;
run;


**************Checking mrecnum and srecnum variables in SU-SSL and MU-SSL ;
%let yr=2000;
Proc means data=ssl&yr.mu;
var mrecnum;
run;
%let yr=2000;
Proc means data=ssl&yr.su;
var srecnum;
run;

************************************************************;
************************************************************;
*Merging SSL and LBD;
************************************************************;
************************************************************;
*************1)Combine SU SSL and LBD by srecnum;
%let yr=2000;
proc sort data=work.lbd&yr.c_rec out=lbd00_s;
by SRECNUM;
run;

proc sort data=work.ssl&yr.su out=sussl00nt;
by SRECNUM;
run;

data work.su_ssllbd2000;
merge lbd00_s(in=one) sussl00nt(in=two);
fromlbd00_s=one;
fromsussl00nt=two;
by SRECNUM;
run;

data work.su_ssllbd2000;
set work.su_ssllbd2000;
srecnumx=put(srecnum,8.);
recnumx=put(recnum,8.);
mux=put(mu,1.);
if recnumx^=' ';
if mux^=' ';
if srecnumx^=' ';
RUN;

*************2)Combine MU SSL and LBD by Mrecnum;
%let yr=2000;
proc sort data=work.lbd&yr.c_rec out=lbd00_M;
by MRECNUM;
run;

proc sort data=work.ssl&yr.mu out=mussl00nt;
by MRECNUM;
run;

data work.mu_ssllbd2000;
merge lbd00_M(in=one) mussl00nt(in=two);
fromlbd00_m=one;
frommussl00nt =two;
by MRECNUM;
run;

data work.mu_ssllbd2000;
set work.mu_ssllbd2000;
mrecnumx=put(mrecnum,8.);
recnumx=put(recnum,8.);
mux=put(mu,1.);
if recnumx^=' ';
if MUx^=' ';
if mrecnumx^=' ';
RUN;


**************3-A)Combine SU-SSLLBD &MUSSL-LBD FILES;
%let yr=2000;
data ssllbd&yr.;
set work.su_ssllbd2000(in=a)
work.mu_ssllbd2000 (in=b);
if a then SU2=1;else SU2=0;
if b then MU2=1;else MU2=0;
year=&yr.;
run;


**Create a newfips variable;
%let yr=2000;
data ssllbd&yr;
length newfips $5;
set work.ssllbd&yr;
ctygeox=put(ctygeo,3.);
stgeox=put(stgeo,2.);
If ctygeox^=' ' & stgeox^=' ' then newfips=stgeox||ctygeox;
else newfips=" ";
run;


data ssllbd&yr;
set work.ssllbd&yr;
**Keeping the counties listed;
where newfips="01015"
or newfips="01073"
or newfips="01097"
or newfips="02090"
or newfips="04013"
or newfips="04019"
or newfips="05069"
or newfips="05119"
or newfips="06001"
or newfips="06019"
or newfips="06037"
or newfips="06059"
or newfips="06067"
or newfips="06073"
or newfips="06075"
or newfips="08001"
or newfips="08031"
or newfips="08123"
or newfips="09001"
or newfips="09003"
or newfips="09009"
or newfips="10003"
or newfips="11001"
or newfips="12011"
or newfips="12031"
or newfips="12057"
or newfips="12086"
or newfips="13051"
or newfips="13089"
or newfips="13095"
or newfips="13121"
or newfips="17031"
or newfips="17143"
or newfips="17163"
or newfips="17167"
or newfips="18089"
or newfips="18097"
or newfips="19153"
or newfips="19193"
or newfips="20209"
or newfips="21111"
or newfips="22017"
or newfips="22019"
or newfips="22051"
or newfips="22071"
or newfips="22073"
or newfips="24510"
or newfips="25009"
or newfips="25013"
or newfips="25017"
or newfips="25025"
or newfips="26021"
or newfips="26049"
or newfips="26121"
or newfips="26163"
or newfips="27053"
or newfips="27123"
or newfips="28049"
or newfips="29047"
or newfips="29095"
or newfips="29165"
or newfips="29189"
or newfips="29510"
or newfips="31055"
or newfips="32003"
or newfips="33011"
or newfips="34007"
or newfips="34011"
or newfips="34013"
or newfips="34017"
or newfips="34039"
or newfips="35001"
or newfips="35013"
or newfips="36005"
or newfips="36029"
or newfips="36047"
or newfips="36055"
or newfips="36061"
or newfips="36063"
or newfips="36067"
or newfips="36071"
or newfips="36081"
or newfips="36085"
or newfips="36093"
or newfips="36119"
or newfips="37119"
or newfips="39017"
or newfips="39035"
or newfips="39045"
or newfips="39049"
or newfips="39061"
or newfips="39081"
or newfips="39087"
or newfips="39099"
or newfips="39153"
or newfips="40017"
or newfips="40027"
or newfips="40109"
or newfips="41051"
or newfips="42003"
or newfips="42043"
or newfips="42045"
or newfips="42101"
or newfips="44007"
or newfips="45019"
or newfips="45079"
or newfips="45085"
or newfips="47037"
or newfips="47065"
or newfips="47093"
or newfips="47157"
or newfips="48029"
or newfips="48085"
or newfips="48113"
or newfips="48121"
or newfips="48141"
or newfips="48157"
or newfips="48201"
or newfips="48245"
or newfips="48309"
or newfips="48355"
or newfips="48361"
or newfips="48439"
or newfips="48453"
or newfips="48491"
or newfips="49057"
or newfips="51710"
or newfips="51740"
or newfips="51760"
or newfips="53033"
or newfips="53053"
or newfips="53077"
or newfips="54009"
or newfips="54011"
or newfips="54039"
or newfips="54099"
or newfips="55079"


or newfips="01117"
or newfips="04027"
or newfips="08005"
or newfips="08059"
or newfips="08035"
or newfips="11031"
or newfips="12025"
or newfips="13063"
or newfips="13135"
or newfips="13177"
or newfips="17005"
or newfips="17043"
or newfips="17097"
or newfips="18057"
or newfips="24005"
or newfips="26125"
or newfips="27003"
or newfips="27163"
or newfips="28121"
or newfips="31153"
or newfips="32009"
or newfips="35043"
or newfips="36105"
or newfips="36001"
or newfips="36079"
or newfips="37179"
or newfips="39085"
or newfips="39041"
or newfips="39025"
or newfips="39155"
or newfips="41005"
or newfips="44003"
or newfips="45063"
or newfips="47187"
or newfips="48251"
or newfips="48367"
or newfips="51810"
or newfips="51041"
or newfips="51087"
or newfips="55133";
run;

**************3-B)Eliminating EINs that appear in both the SU(not submaster)
and MU files,keeping MU information suggested by Miranda(2002);
%let yr=2000;
proc sort data=work.ssllbd&yr OUT=work.ssllbd&yr;by EIN;
proc means data=work.ssllbd&yr noprint;
by EIN;
output out=work.dups(drop=_TYPE_ _FREQ_)
n(EMPLOYMENT)=EIN_COUNT;
run;

data ssllbd&yr;
merge work.ssllbd&yr (in=a) work.dups(in=b);
by EIN;
*We are concerned about EINs that are in the SU(not submaster) and MU;
if EIN_COUNT>1 & SU2=1 & PDIV^='M' then delete;
run;


*save the merged ssllbd data;
data "/rdcprojects/mc00535/data/ssllbd/ssllbd&yr "(compress=yes);
set ssllbd&yr;
drop fromlbd00_s fromlbd00_m frommussl00nt fromsussl00nt  SU2 MU2 srecnum mrecnum EIN_COUNT srecnumx mrecnumx recnumx mux ctygeox stgeox;
run;

proc datasets lib=work;
delete
dups lbd2000c lbd2000c_rec lbd00_m lbd00_s
mussl00nt sussl00nt mu_ssllbd2000 su_ssllbd2000
ssl2000mu ssl2000su ssllbd2000;
run;




 ******************************************YEAR:2001 ************************************************;
 *MACROS;
%let yr=2001;
libname BR '/economic/ssl/microdata/';
data ssl&yr.su;
set BR.ssl&yr.su;
run;

************************************************************;
************************************************************;
*(1) Single-Unit File;
************************************************************;
************************************************************;
%let yr=2001;
data ssl&yr.su(keep=  employment employmentsu payrollsu srecnum   pst salereceiptsu newtract mstreet
mplce mst mzip same_as

newtractsu actsu cfnsu lfosu sicsu zipsu blkgeosu blksfxsu cdgeosu ctygeosu indsu indsubsu lfo1su npisu pdivsu plcesu plgeosu ppnsu
sic56su stgeosu streetsu tocsu tractsu acfsu einsu 
AC943E AC943P acap ACEMP ACEMPF ACF ACSR1 ACSR1F ACSR2 ACSR2F ACSR3 ACSR3F
ACSR4 ACSR4F ACT ANNPR BLKGEO BLKSFX CDGEO CFN CTYGEO EIN EMPCD IND INDSUB
LFO LFO1   NPI PDIV PLCE PLGEO PPLCE PPN PSTREET PZIP
RECNUM SIC SIC56 SSABR
SSACL SSAEMP STGEO STREET TOC TRACT ZIP );	
 set BR.ssl&yr.su;
 *************Creating new tract variable;

length NEWTRACT $ 11;
If tract^=' ' & STGEO^=' ' & CTYGEO^=' ' then NEWTRACT=STGEO||CTYGEO||TRACT;
else newtract=" ";



Employment=ACEMP;
Employmentsu=ACEMP;
**************Exclude submasters;
if PDIV^='M';
*Exclude inactive units;
acap = ACQP1+ACQP2+ACQP3+ACQP4;
if acap>0| AC943P>0;

payrollsu =acap;
 srecnum=recnum;
salereceiptsu=acsr1;
*Identify the source of the common variables;
newtractsu=newtract;
actsu=act; cfnsu=cfn; lfosu=lfo ; sicsu=sic ;zipsu=zip; blkgeosu=blkgeo; blksfxsu=blksfx;
cdgeosu=cdgeo; ctygeosu=ctygeo; indsu=ind; indsubsu=indsub; lfo1su=lfo1;
 npisu=npi; pdivsu=pdiv; plcesu=plce; plgeosu=plgeo; ppnsu=ppn;
sic56su=sic56; stgeosu=stgeo; streetsu=street; tocsu=toc; tractsu=tract; acfsu=acf;
einsu=ein;

run;


*******
%let yr=2001;
libname BR '/economic/ssl/microdata/';
data ssl&yr.mu;
set BR.ssl&yr.mu;
run;


 *(2) Multi-Unit File;
************************************************************;
************************************************************;
%let yr=2001;
data ssl&yr.mu(keep=employment employmentmu payrollmu mrecnum  newtract  salereceiptmu  
 newtractmu actmu cfnmu lfomu sicmu zipmu blkgeomu blksfxmu cdgeomu ctygeomu indmu indsubmu lfo1mu npimu 
pdivmu plcemu plgeomu ppnmu
sic56mu stgeomu streetmu tocmu tractmu acfmu einmu 
ACF ACT
BLKGEO BLKSFX CDGEO
CFN CTYGEO CYTE EIN GAT IND INDSUB LFO LFO1 NPI PDIV
PLCE PLGEO PPN RAP RAPF RECNUM REMP REMPF RSR RSRF
SIC	SIC56	STGEO	STREET	TOC TRACT ZIP);	
 set BR.ssl&yr.mu;
 *************Creating new tract variable;

length NEWTRACT $ 11;
If tract^=' ' & STGEO^=' ' & CTYGEO^=' ' then NEWTRACT=STGEO||CTYGEO||TRACT;
else newtract=" ";

**************Exclude ghosts;
if ACT^='G';
**************Exclude inactive units;
if rap>0| (rap=0 & (RAPF^='Z' & ACT^='D'));

EMPLOYMENT=REMP;
EMPLOYMENTmu=REMP;
PAYROLLmu=RAP;
salereceiptmu=RSR;	
mrecnum=recnum;
*Identify the source of the common variables;
newtractmu=newtract;
actmu=act; cfnmu=cfn; lfomu=lfo ; sicmu=sic ;zipmu=zip; blkgeomu=blkgeo; blksfxmu=blksfx;
cdgeomu=cdgeo; ctygeomu=ctygeo; indmu=ind; indsubmu=indsub; lfo1mu=lfo1;
 npimu=npi; pdivmu=pdiv; plcemu=plce; plgeomu=plgeo; ppnmu=ppn;
sic56mu=sic56; stgeomu=stgeo; streetmu=street; tocmu=toc; tractmu=tract; acfmu=acf;
einmu=ein;
run;
************************************************************;
************************************************************ ;



*LBD File;
************************************************************;
************************************************************;
%let yr=2001;
libname lbd '/economic/lbd/microdata';
data lbd&yr.c;
set lbd.lbd&yr.c;
*Drop missing recnum and MU observations;
recnumx=put(recnum,8.);
mux=put(mu,1.);
if recnumx^=' ';
if MUx^=' ';
*Exclude submasters in LBD coming from SU file;
if MU=0 & PDIV='M' then delete;

/*
*Exclude inactive units;
if PAY>0;
*/

*Exclude ghosts in LBD coming from MU file;
if ACT='G' & MU=1 then delete;
run;

**************Creating srecnum mrecnum variables in lbd file and keeping the selected variables;
%let yr=2001;
data work.lbd&yr.c_rec(keep= mrecnum srecnum  payrolllbd employmentlbd
actlbd cfnlbd lfolbd siclbd ziplbd 
ACT	BESTNAICs	BESTSIC	CFN	COUNTY	EMP	FIRMID	FIRSTYEAr	
FLAGA	FLAGB	
LASTYEAR LBDNUM	LFO	MU	PAY	RECNUM	SIC STATE YR ZIP);
set work.lbd&yr.c;

if MU=1 then MRECNUM=RECNUM;
if MU=0 then SRECNUM=RECNUM;

payrolllbd=pay;	
employmentlbd=emp;

actlbd=act;
 cfnlbd=cfn;
 lfolbd=lfo;
 siclbd=sic ;
ziplbd=zip; 
run;

**************Checking mu  in LBD;
%let yr=2001;
proc means data=lbd&yr.c_rec;
var mu;
where mu=1;
run;

%let yr=2001;
proc means data=lbd&yr.c_rec;
var mu;
where mu=0;
run;


**************Checking mrecnum and srecnum variables in SU-SSL and MU-SSL ;
%let yr=2001;
Proc means data=ssl&yr.mu;
var mrecnum;
run;
%let yr=2001;
Proc means data=ssl&yr.su;
var srecnum;
run;

************************************************************;
************************************************************;
*Merging SSL and LBD;
************************************************************;
************************************************************;
*************1)Combine SU SSL and LBD by srecnum;
%let yr=2001;
proc sort data=work.lbd&yr.c_rec out=lbd01_s;
by SRECNUM;
run;

proc sort data=work.ssl&yr.su out=sussl01nt;
by SRECNUM;
run;

data work.su_ssllbd2001;
merge lbd01_s(in=one) sussl01nt(in=two);
fromlbd01_s=one;
fromsussl01nt=two;
by SRECNUM;
run;

data work.su_ssllbd2001;
set work.su_ssllbd2001;
srecnumx=put(srecnum,8.);
recnumx=put(recnum,8.);
mux=put(mu,1.);
if recnumx^=' ';
if MUx^=' ';
if srecnumx^=' ';
RUN;

*************2)Combine MU SSL and LBD by Mrecnum;
%let yr=2001;
proc sort data=work.lbd&yr.c_rec out=lbd01_M;
by MRECNUM;
run;

proc sort data=work.ssl&yr.mu out=mussl01nt;
by MRECNUM;
run;

data work.mu_ssllbd2001;
merge lbd01_M(in=one) mussl01nt(in=two);
fromlbd01_m=one;
frommussl01nt =two;
by MRECNUM;
run;

data work.mu_ssllbd2001;
set work.mu_ssllbd2001;
mrecnumx=put(mrecnum,8.);
recnumx=put(recnum,8.);
mux=put(mu,1.);
if recnumx^=' ';
if MUx^=' ';
if mrecnumx^=' ';
RUN;


**************3-A)Combine SU-SSLLBD &MUSSL-LBD FILES;
%let yr=2001;
data ssllbd&yr.;
set work.su_ssllbd2001(in=a)
work.mu_ssllbd2001 (in=b);
if a then SU2=1;else SU2=0;
if b then MU2=1;else MU2=0;
year=&yr.;
run;


**Create a newfips variable;
%let yr=2001;
data ssllbd&yr;
length newfips $5;
set work.ssllbd&yr;
ctygeox=put(ctygeo,3.);
stgeox=put(stgeo,2.);
If ctygeox^=' ' & stgeox^=' ' then newfips=stgeox||ctygeox;
else newfips=" ";
run;


data ssllbd&yr;
set work.ssllbd&yr;
**Keeping the counties listed;
where newfips="01015"
or newfips="01073"
or newfips="01097"
or newfips="02090"
or newfips="04013"
or newfips="04019"
or newfips="05069"
or newfips="05119"
or newfips="06001"
or newfips="06019"
or newfips="06037"
or newfips="06059"
or newfips="06067"
or newfips="06073"
or newfips="06075"
or newfips="08001"
or newfips="08031"
or newfips="08123"
or newfips="09001"
or newfips="09003"
or newfips="09009"
or newfips="10003"
or newfips="11001"
or newfips="12011"
or newfips="12031"
or newfips="12057"
or newfips="12086"
or newfips="13051"
or newfips="13089"
or newfips="13095"
or newfips="13121"
or newfips="17031"
or newfips="17143"
or newfips="17163"
or newfips="17167"
or newfips="18089"
or newfips="18097"
or newfips="19153"
or newfips="19193"
or newfips="20209"
or newfips="21111"
or newfips="22017"
or newfips="22019"
or newfips="22051"
or newfips="22071"
or newfips="22073"
or newfips="24510"
or newfips="25009"
or newfips="25013"
or newfips="25017"
or newfips="25025"
or newfips="26021"
or newfips="26049"
or newfips="26121"
or newfips="26163"
or newfips="27053"
or newfips="27123"
or newfips="28049"
or newfips="29047"
or newfips="29095"
or newfips="29165"
or newfips="29189"
or newfips="29510"
or newfips="31055"
or newfips="32003"
or newfips="33011"
or newfips="34007"
or newfips="34011"
or newfips="34013"
or newfips="34017"
or newfips="34039"
or newfips="35001"
or newfips="35013"
or newfips="36005"
or newfips="36029"
or newfips="36047"
or newfips="36055"
or newfips="36061"
or newfips="36063"
or newfips="36067"
or newfips="36071"
or newfips="36081"
or newfips="36085"
or newfips="36093"
or newfips="36119"
or newfips="37119"
or newfips="39017"
or newfips="39035"
or newfips="39045"
or newfips="39049"
or newfips="39061"
or newfips="39081"
or newfips="39087"
or newfips="39099"
or newfips="39153"
or newfips="40017"
or newfips="40027"
or newfips="40109"
or newfips="41051"
or newfips="42003"
or newfips="42043"
or newfips="42045"
or newfips="42101"
or newfips="44007"
or newfips="45019"
or newfips="45079"
or newfips="45085"
or newfips="47037"
or newfips="47065"
or newfips="47093"
or newfips="47157"
or newfips="48029"
or newfips="48085"
or newfips="48113"
or newfips="48121"
or newfips="48141"
or newfips="48157"
or newfips="48201"
or newfips="48245"
or newfips="48309"
or newfips="48355"
or newfips="48361"
or newfips="48439"
or newfips="48453"
or newfips="48491"
or newfips="49057"
or newfips="51710"
or newfips="51740"
or newfips="51760"
or newfips="53033"
or newfips="53053"
or newfips="53077"
or newfips="54009"
or newfips="54011"
or newfips="54039"
or newfips="54099"
or newfips="55079"

or newfips="01117"
or newfips="04027"
or newfips="08005"
or newfips="08059"
or newfips="08035"
or newfips="11031"
or newfips="12025"
or newfips="13063"
or newfips="13135"
or newfips="13177"
or newfips="17005"
or newfips="17043"
or newfips="17097"
or newfips="18057"
or newfips="24005"
or newfips="26125"
or newfips="27003"
or newfips="27163"
or newfips="28121"
or newfips="31153"
or newfips="32009"
or newfips="35043"
or newfips="36105"
or newfips="36001"
or newfips="36079"
or newfips="37179"
or newfips="39085"
or newfips="39041"
or newfips="39025"
or newfips="39155"
or newfips="41005"
or newfips="44003"
or newfips="45063"
or newfips="47187"
or newfips="48251"
or newfips="48367"
or newfips="51810"
or newfips="51041"
or newfips="51087"
or newfips="55133";
run;


**************3-B)Eliminating EINs that appear in both the SU(not submaster)
and MU files,keeping MU information suggested by Miranda(2002);
%let yr=2001;
proc sort data=work.ssllbd&yr OUT=work.ssllbd&yr;by EIN;
proc means data=work.ssllbd&yr noprint;
by EIN;
output out=work.dups(drop=_TYPE_ _FREQ_)
n(EMPLOYMENT)=EIN_COUNT;
run;

data ssllbd&yr;
merge work.ssllbd&yr (in=a) work.dups(in=b);
by EIN;
*We are concerned about EINs that are in the SU(not submaster) and MU;
if EIN_COUNT>1 & SU2=1 & PDIV^='M' then delete;
run;



*save the merged ssllbd data;
data "/rdcprojects/mc00535/data/ssllbd/ssllbd&yr "(compress=yes);
set ssllbd&yr;
drop fromlbd01_s fromlbd01_m frommussl01nt fromsussl01nt  SU2 MU2 srecnum mrecnum EIN_COUNT;
run;

proc datasets lib=work;
delete
dups lbd2001c lbd2001c_rec lbd01_m lbd01_s
mussl01nt sussl01nt mu_ssllbd2001 su_ssllbd2001
ssl2001mu ssl2001su ssllbd2001;
run;

