libname ntos "/rdcprojects/mc00535/data/NAICStoSIC";

proc sort data = ntos.naicstosic out=work.naicsMUtosic (rename = (naics=naicsmu6 sic=indmu)) nodupkey;
by naics;
run;

proc sort data = ntos.naicstosic out=work.naicsSUtosic (rename = (naics=naicssu6 sic=indsu)) nodupkey;
by naics;
run;

***DESCRIPTION
*This program combines MU-SSL,SU-SSL and LBD files for the years 2002-2004.Keeps the selected variables and counties in the list. Creates a newtract varible based on the information on SSEL;
 ******************************************YEAR:2003 ************************************************;
 *MACROS; 
%let yr=2003; 
*-—————————————————————————————; 
libname BR '/economic/ssl/microdata/'; 
data ssl&yr.su; 
set BR.ssl&yr.su; 
run; 
 
************************************************************;
************************************************************;
*(1) Single-Unit File; 
************************************************************;
************************************************************;
%let yr=2003;
data ssl&yr.su(keep=  
AC943E
AC943P
ACQP1 
ACQP2 
ACQP3 
ACQP4
ACEMP

ACF_mail 
ACF_phy
ACSR1_NET
ACSR1_INC
ACSR1_TOTINC
ACSR1_REV
ACSR1F_INC
ACSR1F_NETGAIN
ACSR1F_OTHERINC
ACSR2_RENT
ACSR2_DIRECT
Acsr2_tot
ACSR2F_INT
ACSR2F_RENT
ACSR2F_DIRECT
ACSR3_RENT
ACSR3_COSTGOOD
ACSR3F_RENT
ACSR3F_COSTGOOD
ACSR4_TOT
ACSR4F_TOT
ACT
BLKGEO_mail 
BLKGEO_phy                     
BLKSFX_mail 
BLKSFX_phy		
CFN
CTYGEO_mail 
CTYGEO_phy			
EIN
EMPCD
LFO
PDIV
PLCE_MAIL						
PLGEO_PHY_CEN 
PLGEO_MAIL_CEN      
PLCE_PHY						
PPN
STREET_PHY						
Zip_PHY    					
RECNUM
SIC
SSA_APPL_REASON
STGEO_mail	
STGEO_PHY					
STREET_MAIL	
SSA_entity_typ			
TOC
TRACT_mail  
TRACT_phy			    
ZIP_mail)							
;
set BR.ssl&yr.su;
run;

%let yr=2003; 
data ssl&yr.su;
set work.ssl&yr.su;
 *************Creating new tract variable;
Ptract=TRACT_PHY;
pstgeo=STGEO_PHY;
pctygeo=CTYGEO_PHY;
length PNEWTRACT $ 11; 
drop tract_phy stgeo_phy ctygeo_phy;
length PNEWTRACT$ 11; 

If ptract^=' ' & pstgeo^=' ' & pctygeo^=' ' then pnewtract=pstgeo||pctygeo||ptract; 
ELSE PNEWTRACT=' ';

TRACT=TRACT_MAIL;
STGEO=STGEO_MAIL;
CTYGEO=CTYGEO_MAIL;
drop tract_mail stgeo_mail ctygeo_mail;
length NEWTRACT$ 11; 

If tract^=' ' & STGEO^=' ' & CTYGEO^=' ' then NEWTRACT=STGEO||CTYGEO||TRACT; 
ELSE NEWTRACT=' ';

Employmentsu=ACEMP;
Employment=ACEMP;
**rename remaining geography variables(except stgeo ctygeo and tract;
BLKSFX=BLKSFX_mail;
PBLKSFX=BLKSFX_phy;
BLKGEO =BLKGEO_mail;
PBLKGEO=BLKGEO_phy ;         
PLCE=PLCE_MAIL;
PPLCE=PLCE_PHY;
PPLGEO=PLGEO_PHY_cen ;
 PLGEO=PLGEO_mail_cen;
STREET=STREET_MAIL;
 PSTREET=STREET_PHY;
 PZIP=Zip_PHY;
 ZIP=ZIP_mail;
ACF=ACF_mail;
PACF=ACF_phy ;
drop BLKSFX_mail 
BLKSFX_phy 
BLKGEO_mail 
BLKGEO_phy 
PLCE_MAIL PLCE_PHY 
PLGEO_PHY_cen
PLGEO_mail_cen 
STREET_MAIL 
STREET_PHY 
Zip_PHY 
ZIP_mail 
ACF_mail 
ACF_phy;
*Administrative current year annual payroll;
ACAP=sum(ACQP1,ACQP2,ACQP3,ACQP4);
**************Exclude submasters; 
if PDIV^='M'; 
*Exclude inactive units; 
if ACAP>0| AC943P>0; 
drop n;

payrollsu =ACAP;
srecnum=recnum;
salereceiptsu=acsr1_net;
*<2002 this is equal to ACSR1. ACSR1 has different categories: ACSR1_NET,ACSR1_INC,ACSR1_TOTINC,ACSR1_REV. I took ACSR1_NET instead of ASCR1;

***Recode SSA_entity_typ;
If SSA_entity_typ="01"  then ssacl=01;     *Sole proprietor;
If SSA_entity_typ="02"  then ssacl=03;     *Partnership;
If SSA_entity_typ="03" then ssacl=02;           *Corporation; 
If SSA_entity_typ="04" then ssacl=100 ;         *Personal service corporation; 
If SSA_entity_typ="05" then ssacl=101 ;                 *Church or church-controller organization ;
If SSA_entity_typ="06" then ssacl=102 ;  *Other nonprofit organization;
If SSA_entity_typ="07" then ssacl=07 ;  *Other ;
If SSA_entity_typ="08" then ssacl=04 ;   *Estate ;
If SSA_entity_typ="09" then ssacl=09 ; *Plan administrator;
If SSA_entity_typ="10" then ssacl=04 ; *trust;;
If SSA_entity_typ="11" then ssacl=97 ;  *National Guard;
If SSA_entity_typ="12" then ssacl=12;  *Farmer's cooperative;
If SSA_entity_typ="13" then ssacl=13 ;  *REMIC(Real Estate MOrtgage Investment Conduit);
If SSA_entity_typ="14" then ssacl=92 ; * State, county or local government entities;
If SSA_entity_typ="15" then ssacl=96 ; *Federal government/ military;
If SSA_entity_typ="16" then ssacl=16 ; *Indian Tribal Governments / enterprises;
drop SSA_entity_typ;

***Recode SSA_Appl_Reason;
 If SSA_APPL_REASON="1" then ssabr=1;  *Started new business;
 If SSA_APPL_REASON="2" then ssabr=5;  *Hired employees;
 If SSA_APPL_REASON="3" then ssabr=6 ; *Created a pension plan=other;
 If SSA_APPL_REASON="4" then ssabr=6 ; *Banking Purpose=other;
If SSA_APPL_REASON="5" then ssabr=4 ; *Changed the type of organization;
If SSA_APPL_REASON="6" then ssabr=2;  *Purchased going business;
If SSA_APPL_REASON="7" then ssabr=6 ; *Created a trust=other;
If SSA_APPL_REASON="8" then ssabr=6 ;*other;
drop SSA_APPL_REASON; 
run;

data ssl&yr.su;
set work.ssl&yr.su;
**Recoding Profit/Non-profit Status(NPI);
If LFO='T' OR LFO='E'  or LFO="4" then NPI="1";
IF LFO='C' or LFO="3" THEN NPI="2";
ELSE NPI="0";
run;
data ssl&yr.su;
set work.ssl&yr.su;
npix=put(npi,1.);
run;

data ssl&yr.su;
set work.ssl&yr.su;
**Recode LFO1;
If LFO='C' OR LFO='T' THEN LFO1=0;
If LFO='S' THEN LFO1=1;
IF LFO='P' THEN LFO1=2;
IF LFO='G' THEN LFO1=5;
IF LFO='U' THEN LFO1=7;
RUN;

%let yr=2003;
data ssl&yr.su;
set work.ssl&yr.su;
IF LFO="3" OR LFO="4" THEN LFO1=8;
IF LFO="0" THEN LFO1=9;
run;

data ssl&yr.su;
set work.ssl&yr.su;
lfo1x=put(lfo1,1.);
run;

***Recoding LFO;
%let yr=2003;
data ssl&yr.su;
set work.ssl&yr.su;
drop lfo;
run;

%let yr=2003;
data ssl&yr.su;
set work.ssl&yr.su;
If lfo1x^=' ' & NPIx^=' ' then LFO=lfo1x||NPIx;
ELSE lfo=' ';
DROP lfo1x npix;
run; 

data ssl&yr.su;
set work.ssl&yr.su;
*Identify the source of the common variables;
newtractsu=newtract;
actsu=act; cfnsu=cfn; lfosu=lfo ;
naicssu=sic ;  ***Note SIC variable actually contains a NAICS code;
naicssu6=substr(naicssu,1,6);
zipsu=zip; blkgeosu=blkgeo; blksfxsu=blksfx;
ctygeosu=ctygeo;  lfo1su=lfo1;
 npisu=npi; pdivsu=pdiv; plcesu=plce; plgeosu=plgeo; ppnsu=ppn;
 stgeosu=stgeo; streetsu=street; tocsu=toc; tractsu=tract; acfsu=acf;
einsu=ein;
run;


proc sort data=ssl&yr.su;
by naicssu6;
run;

data ssl&yr.su (drop = naicssu6);
merge ssl&yr.su (in=inssl) work.naicsSUtosic;
by naicssu6;
if inssl = 1;
run;



*******
%let yr=2003; 
libname BR '/economic/ssl/microdata/'; 
data ssl&yr.mu; 
set BR.ssl&yr.mu; 
run; 

 *(2) Multi-Unit File; 
************************************************************;
************************************************************;
%let yr=2003;
data ssl&yr.mu(keep=
ACF_mail 
ACF_phy
ACT
BLKGEO_mail 
BLKGEO_phy
BLKSFX_mail 
BLKSFX_phy
CFN
CTYGEO_mail 
CTYGEO_phy
EIN
GAT_mail 
GAT_phy
LFO
PDIV
PLCE_MAIL 
PLCE_PHY
PLGEO_PHY_CEN 
PLGEO_MAIL_CEN
PPN
RAP
RAPF
RECNUM
REMP
REMPF
RSR
RSRF
SIC
STGEO_MAIL  
STGEO_PHY
STREET_PHY
STREET_MAIL
TOC 
TRACT_PHY 
TRACT_MAIL
Zip_phy 
ZIP_MAIL)
;
set BR.ssl&yr.mu; 
run;

%let yr=2003; 
data ssl&yr.mu;
set work.ssl&yr.mu;

**************Creating new tract variable;

tract=TRACT_PHY;
stgeo=STGEO_PHY;
ctygeo=CTYGEO_PHY;
length NEWTRACT $ 11; 
drop tract_phy stgeo_phy ctygeo_phy;

If TRACT^=' ' & STGEO^=' ' & CTYGEO^=' ' then NEWTRACT=STGEO||CTYGEO||TRACT; 
ELSE NEWTRACT=' ';

mtract=TRACT_MAIL;
MSTGEO=STGEO_MAIL;
MCTYGEO=CTYGEO_MAIL;
drop tract_mail stgeo_mail ctygeo_mail;
length NEWTRACT $ 11; 


If mtract^=' ' & MSTGEO^=' ' & MCTYGEO^=' ' then MNEWTRACT=MSTGEO||MCTYGEO||MTRACT; 
ELSE MNEWTRACT=' ';
run;

data ssl&yr.mu; 
set ssl&yr.mu; 

**rename remaining geography variables(except stgeo ctygeo and tract);
BLKSFX=BLKSFX_mail;
PBLKSFX=BLKSFX_phy;
BLKGEO =BLKGEO_mail;
PBLKGEO=BLKGEO_phy ;         
PLCE=PLCE_MAIL;
PPLCE=PLCE_PHY;
PPLGEO=PLGEO_PHY_cen ;
PLGEO=PLGEO_mail_cen;
STREET=STREET_MAIL;
PSTREET=STREET_PHY;
PZIP=Zip_PHY;
ZIP=ZIP_mail;
ACF=ACF_mail;
pACF=ACF_phy ;
drop BLKSFX_mail BLKSFX_phy BLKGEO_mail BLKGEO_phy PLCE_MAIL PLCE_PHY PLGEO_PHY_cen
PLGEO_mail_cen STREET_MAIL STREET_PHY Zip_PHY ZIP_mail ACF_mail ACF_phy;
run;

data ssl&yr.mu; 
set ssl&yr.mu; 
**************Exclude ghosts; 
**if ACT^='G';  ***ACT code changes. I need to recode it;
**************Exclude inactive units; 
if rap>0| (rap=0 & (RAPF^='Z' & ACT^='N')); 
EMPLOYMENT=REMP; 
EMPLOYMENTmu=REMP; 
PAYROLLmu=RAP; 
salereceiptmu=RSR;	                                
mrecnum=recnum;
run;

data ssl&yr.mu;
set work.ssl&yr.mu;
**Recoding Profit/Non-profit Status(NPI);
If LFO='T' OR LFO='E'  or LFO="4" then NPI="1";
IF LFO='C' or LFO="3" THEN NPI="2";
ELSE NPI="0";
run;
data ssl&yr.mu;
set work.ssl&yr.mu;
npix=put(npi,1.);
run;

data ssl&yr.mu;
set work.ssl&yr.mu;
**Recode LFO1;
If LFO='C' OR LFO='T' THEN LFO1=0;
If LFO='S' THEN LFO1=1;
IF LFO='P' THEN LFO1=2;
IF LFO='G' THEN LFO1=5;
IF LFO='U' THEN LFO1=7;
RUN;

%let yr=2003;
data ssl&yr.mu;
set work.ssl&yr.mu;
IF LFO="3" OR LFO="4" THEN LFO1=8;
IF LFO="0" THEN LFO1=9;
run;
data ssl&yr.mu;
set work.ssl&yr.mu;
lfo1x=put(lfo1,1.);
run;

***Recoding LFO;
%let yr=2003;
data ssl&yr.mu;
set work.ssl&yr.mu;
drop lfo;
run;

%let yr=2003;
data ssl&yr.mu;
set work.ssl&yr.mu;
If lfo1x^=' ' & NPIx^=' ' then LFO=lfo1x||NPIx;
ELSE lfo=' ';
DROP lfo1x npix;
run; 

data ssl&yr.mu;
set work.ssl&yr.mu;
*Identify the source of the common variables;
newtractmu=newtract;
actmu=act; cfnmu=cfn; lfomu=lfo ; 
naicsmu=sic ;  ***Note SIC variable actually contains a NAICS code;
naicsmu6=substr(naicsmu,1,6);
zipmu=zip; blkgeomu=blkgeo; blksfxmu=blksfx;
 ctygeomu=ctygeo;   lfo1mu=lfo1;
 npimu=npi; pdivmu=pdiv; plcemu=plce; plgeomu=plgeo; ppnmu=ppn;
 stgeomu=stgeo; streetmu=street; tocmu=toc; tractmu=tract; acfmu=acf;
einmu=ein;
run; 

proc sort data=ssl&yr.mu;
by naicsmu6;
run;

data ssl&yr.mu  (drop = naicsmu6);
merge ssl&yr.mu (in=inssl) work.naicsMUtosic;
by naicsmu6;
if inssl = 1;
run;

************************************************************;
************************************************************ ;
*LBD File;
************************************************************;
************************************************************;
%let yr=2003; 
libname lbd '/economic/lbd/microdata'; 
data lbd&yr.c; 
set lbd.lbd&yr.c; 
*Drop missing recnum and MU observations;
recnumx=put(recnum,8.);
MUx=put(MU,1.);
if recnumx^=' '; 
if MUx^=' ';
*Exclude submasters in LBD coming from SU file; 
if MU=0 & PDIV='M' then delete; 

/*
*Exclude inactive units;
if PAY>0;
*/

*Exclude ghosts in LBD coming from MU file; 
if ACT='G' & MU=1 then delete; 
run; 
**************Creating ind/indsub/sic56;
data lbd&yr.c; 
set work.lbd&yr.c; 
IND=substr(bestSIC,1,4);
INDSUB=substr(bestSIC,1,2);
SIC56=substr(bestSIC,5,2);
run;

**************Creating srecnum mrecnum variables in lbd file and keeping the selected variables;

%let yr=2003;
data lbd&yr.c; 
set work.lbd&yr.c; 
if MU=1 then MRECNUM=RECNUM;
if MU=0 then SRECNUM=RECNUM;
payrolllbd=pay;	
employmentlbd=emp;
 actlbd=act;
cfnlbd=cfn;
lfolbd=lfo;
siclbd=sic;
ziplbd=zip;
run;
%let yr=2003;
data work.lbd&yr.c_rec(keep= recnum srecnum mrecnum payrolllbd
employmentlbd actlbd cfnlbd lfolbd siclbd ziplbd ACT	BESTNAICs BESTSIC CFN COUNTY  EMP  FIRMID  FIRSTYEAR
FLAGA  FLAGB	LASTYEAR  LBDNUM LFO MU	PAY	RECNUM	SIC STATE YR ZIP INd indsub sic56);
set work.lbd&yr.c;
run;
**************Checking mu  in LBD;
%let yr=2003;  
proc means data=lbd&yr.c_rec;
var mu;
where mu=1;
run;

%let yr=2003;  
proc means data=lbd&yr.c_rec;
var mu;
where mu=0;
run;


**************Checking mrecnum and srecnum variables in SU-SSL and MU-SSL ;
%let yr=2003;
Proc means data=ssl&yr.mu;
var mrecnum;
run;
%let yr=2003;
Proc means data=ssl&yr.su;
var srecnum;
run;
************************************************************;
************************************************************;
*Merging SSL and LBD;
************************************************************;
************************************************************;
*************1)Combine SU SSL and LBD by srecnum;
%let yr=2003; 
proc sort data=work.lbd&yr.c_rec out=lbd03_s;
by SRECNUM;
run;

proc sort data=work.ssl&yr.su out=sussl03nt;
by SRECNUM;
run;

data work.su_ssllbd2003;
merge lbd03_s(in=one) sussl03nt(in=two);
fromlbd03_s=one;
fromsussl03nt=two;
by SRECNUM;
run;

data work.su_ssllbd2003;
set work.su_ssllbd2003;
srecnumx=put(srecnum,8.);
recnumx=put(recnum,8.);
mux=put(mu,1.);
if recnumx^=' ';
if MUx^=' ';
if srecnumx^=' ';
RUN;

data work.su_ssllbd2003;
set work.su_ssllbd2003;
ppnx=input(ppn,10.);
drop ppn;
rename ppnx=ppn;
run;

*************2)Combine MU SSL and LBD by Mrecnum;
%let yr=2003; 
proc sort data=work.lbd&yr.c_rec out=lbd03_M;
by MRECNUM;
run;

proc sort data=work.ssl&yr.mu out=mussl03nt;
by MRECNUM;
run;

data work.mu_ssllbd2003;
merge lbd03_M(in=one) mussl03nt(in=two);
fromlbd03_m=one;
frommussl03nt =two;
by MRECNUM;
run;

data work.mu_ssllbd2003;
set work.mu_ssllbd2003;
mrecnumx=put(mrecnum,8.);
recnumx=put(recnum,8.);
mux=put(mu,1.);
if recnumx^=' ';
if MUx^=' ';
if mrecnumx^=' ';
RUN;


**************3-A)Combine SU-SSLLBD &MUSSL-LBD FILES; 
%let yr=2003; 
data ssllbd&yr.;
set work.su_ssllbd2003(in=a) 
work.mu_ssllbd2003 (in=b); 

if a then SU2=1;else SU2=0; 
if b then MU2=1;else MU2=0; 
year=&yr.;
run; 
 
**Create a newfips variable;
%let yr=2003;
data ssllbd&yr;
length newfips $5;
set work.ssllbd&yr;
If ctygeo^=' ' & stgeo^= ' ' then newfips=stgeo||ctygeo;
else newfips=" ";
run;

data ssllbd&yr; 
set work.ssllbd&yr;
**Keeping the counties listed;
If newfips="01015" 
or newfips="01073"
or newfips="01097" 
or newfips="02090" 
or newfips="04013" 
or newfips="04019" 
or newfips="05069" 
or newfips="05119"
or newfips="06001" 
or newfips="06019" 
or newfips="06037"
or newfips="06059" 
or newfips="06067" 
or newfips="06073" 
or newfips="06075" 
or newfips="08001"
or newfips="08031" 
or newfips="08123"
or newfips="09001" 
or newfips="09003" 
or newfips="09009"
or newfips="10003" 
or newfips="11001" 
or newfips="12011" 
or newfips="12031" 
or newfips="12057" 
or newfips="12086"
or newfips="13051" 
or newfips="13089" 
or newfips="13095" 
or newfips="13121"
or newfips="17031"
or newfips="17143"
or newfips="17163"
or newfips="17167"
or newfips="18089"
or newfips="18097"
or newfips="19153"
or newfips="19193"
or newfips="20209"
or newfips="21111"
or newfips="22017"
or newfips="22019"
or newfips="22051"
or newfips="22071"
or newfips="22073"
or newfips="24510"
or newfips="25009"
or newfips="25013"
or newfips="25017"
or newfips="25025"
or newfips="26021"
or newfips="26049"
or newfips="26121"
or newfips="26163"
or newfips="27053"
or newfips="27123"
or newfips="28049"
or newfips="29047"
or newfips="29095"
or newfips="29165"
or newfips="29189"
or newfips="29510"
or newfips="31055"
or newfips="32003"
or newfips="33011"
or newfips="34007"
or newfips="34011"
or newfips="34013"
or newfips="34017"
or newfips="34039"
or newfips="35001"
or newfips="35013"
or newfips="36005"
or newfips="36029"
or newfips="36047"
or newfips="36055"
or newfips="36061"
or newfips="36063"
or newfips="36067"
or newfips="36071"
or newfips="36081"
or newfips="36085"
or newfips="36093"
or newfips="36119"
or newfips="37119"
or newfips="39017"
or newfips="39035"
or newfips="39045"
or newfips="39049"
or newfips="39061"
or newfips="39081"
or newfips="39087"
or newfips="39099"
or newfips="39153"
or newfips="40017"
or newfips="40027"
or newfips="40109"
or newfips="41051"
or newfips="42003"
or newfips="42043"
or newfips="42045"
or newfips="42101"
or newfips="44007"
or newfips="45019"
or newfips="45079"
or newfips="45085"
or newfips="47037"
or newfips="47065"
or newfips="47093"
or newfips="47157"
or newfips="48029"
or newfips="48085"
or newfips="48113"
or newfips="48121"
or newfips="48141"
or newfips="48157"
or newfips="48201"
or newfips="48245"
or newfips="48309"
or newfips="48355"
or newfips="48361"
or newfips="48439"
or newfips="48453"
or newfips="48491"
or newfips="49057"
or newfips="51710"
or newfips="51740"
or newfips="51760"
or newfips="53033"
or newfips="53053"
or newfips="53077"
or newfips="54009"
or newfips="54011"
or newfips="54039"
or newfips="54099"
or newfips="55079"

or newfips="01117"
or newfips="04027"
or newfips="08005"
or newfips="08059"
or newfips="08035"
or newfips="11031"
or newfips="13063"
or newfips="13135"
or newfips="13177"
or newfips="17005"
or newfips="17043"
or newfips="17097"
or newfips="18057"
or newfips="24005"
or newfips="26125"
or newfips="27003"
or newfips="27163"
or newfips="28121"
or newfips="31153"
or newfips="32009"
or newfips="35043"
or newfips="36105"
or newfips="36001"
or newfips="36079"
or newfips="37179"
or newfips="39085"
or newfips="39041"
or newfips="39025"
or newfips="39155"
or newfips="41005"
or newfips="44003"
or newfips="45063"
or newfips="47187"
or newfips="48251"
or newfips="48367"
or newfips="51810"
or newfips="51041"
or newfips="51087"
or newfips="55133";
run;


**************3-B)Eliminating EINs that appear in both the SU(not submaster)
and MU files,keeping MU information suggested by Miranda(2002);
%let yr=2003;
proc sort data=work.ssllbd&yr OUT=work.ssllbd&yr;by EIN;
proc means data=work.ssllbd&yr noprint;
by EIN;
output out=work.dups(drop=_TYPE_ _FREQ_)
n(EMPLOYMENT)=EIN_COUNT;
run;

data ssllbd&yr;
merge work.ssllbd&yr (in=a) work.dups(in=b);
by EIN;
*We are concerned about EINs that are in the SU(not submaster) and MU;
if EIN_COUNT>1 & SU2=1 & PDIV^='M' then delete;
run;

*save the merged ssllbd data;
data "/rdcprojects/mc00535/data/ssllbd/ssllbd&yr "(compress=yes);
set ssllbd&yr;
drop fromlbd03_s fromlbd03_m frommussl03nt fromsussl03nt  SU2 MU2 srecnum mrecnum EIN_COUNT ;
run;

proc datasets lib=work;
delete
dups lbd2003c lbd2003c_rec lbd03_m lbd03_s
mussl03nt sussl03nt mu_ssllbd2003 su_ssllbd2003
ssl2003mu ssl2003su ssllbd2003;
run;


******************************************YEAR:2004 ************************************************;
 *MACROS; 
%let yr=2004; 
*-—————————————————————————————; 
libname BR '/economic/ssl/microdata/'; 
data ssl&yr.su; 
set BR.ssl&yr.su; 
run; 
 
************************************************************;
************************************************************;
*(1) Single-Unit File; 
************************************************************;
************************************************************;
%let yr=2004;
data ssl&yr.su(keep=  
AC943E
AC943P
ACQP1 
ACQP2 
ACQP3 
ACQP4
ACEMP

ACF_mail 
ACF_phy
ACSR1_NET
ACSR1_INC
ACSR1_TOTINC
ACSR1_REV
ACSR1F_INC
ACSR1F_NETGAIN
ACSR1F_OTHERINC
ACSR2_RENT
ACSR2_DIRECT
Acsr2_tot
ACSR2F_INT
ACSR2F_RENT
ACSR2F_DIRECT
ACSR3_RENT
ACSR3_COSTGOOD
ACSR3F_RENT
ACSR3F_COSTGOOD
ACSR4_TOT
ACSR4F_TOT
ACT
BLKGEO_mail 
BLKGEO_phy                     
BLKSFX_mail 
BLKSFX_phy		
CFN
CTYGEO_mail 
CTYGEO_phy			
EIN
EMPCD
LFO
PDIV
PLCE_MAIL						
PLGEO_PHY_CEN 
PLGEO_MAIL_CEN      
PLCE_PHY						
PPN
STREET_PHY						
Zip_PHY    					
RECNUM
SIC
SSA_APPL_REASON
SSA_entity_typ
STGEO_mail	
STGEO_PHY					
STREET_MAIL			
TOC
TRACT_mail  
TRACT_phy			    
ZIP_mail)							
;
set BR.ssl&yr.su;
run;

%let yr=2004; 
data ssl&yr.su;
set work.ssl&yr.su;
 *************Creating new tract variable;
Ptract=TRACT_PHY;
pstgeo=STGEO_PHY;
pctygeo=CTYGEO_PHY;
length PNEWTRACT $ 11; 
drop tract_phy stgeo_phy ctygeo_phy;
length PNEWTRACT$ 11; 

If ptract^=' ' & pstgeo^=' ' & pctygeo^=' ' then pnewtract=pstgeo||pctygeo||ptract; 
ELSE PNEWTRACT=' ';

TRACT=TRACT_MAIL;
STGEO=STGEO_MAIL;
CTYGEO=CTYGEO_MAIL;
drop tract_mail stgeo_mail ctygeo_mail;
length NEWTRACT$ 11; 

If tract^=' ' & STGEO^=' ' & CTYGEO^=' ' then NEWTRACT=STGEO||CTYGEO||TRACT; 
ELSE NEWTRACT=' ';

Employmentsu=ACEMP;
Employment=ACEMP;
**rename remaining geography variables(except stgeo ctygeo and tract;
BLKSFX=BLKSFX_mail;
PBLKSFX=BLKSFX_phy;
BLKGEO =BLKGEO_mail;
PBLKGEO=BLKGEO_phy ;         
PLCE=PLCE_MAIL;
PPLCE=PLCE_PHY;
PPLGEO=PLGEO_PHY_cen ;
 PLGEO=PLGEO_mail_cen;
STREET=STREET_MAIL;
 PSTREET=STREET_PHY;
 PZIP=Zip_PHY;
 ZIP=ZIP_mail;
ACF=ACF_mail;
PACF=ACF_phy ;
drop BLKSFX_mail 
BLKSFX_phy 
BLKGEO_mail 
BLKGEO_phy 
PLCE_MAIL PLCE_PHY 
PLGEO_PHY_cen
PLGEO_mail_cen 
STREET_MAIL 
STREET_PHY 
Zip_PHY 
ZIP_mail 
ACF_mail 
ACF_phy;
*Administrative current year annual payroll;
ACAP=sum(ACQP1,ACQP2,ACQP3,ACQP4);
**************Exclude submasters; 
if PDIV^='M'; 
*Exclude inactive units; 
if ACAP>0| AC943P>0; 

payrollsu =ACAP;
srecnum=recnum;
salereceiptsu=acsr1_net;
drop n;
*<2002 this is equal to ACSR1. ACSR1 has different categories: ACSR1_NET,ACSR1_INC,ACSR1_TOTINC,ACSR1_REV. I took ACSR1_NET instead of ASCR1;

***Recode SSA_entity_typ;
If SSA_entity_typ="01"  then ssacl=01;     *Sole proprietor;
If SSA_entity_typ="02"  then ssacl=03;     *Partnership;
If SSA_entity_typ="03" then ssacl=02;           *Corporation; 
If SSA_entity_typ="04" then ssacl=100 ;         *Personal service corporation; 
If SSA_entity_typ="05" then ssacl=101 ;                 *Church or church-controller organization ;
If SSA_entity_typ="06" then ssacl=102 ;  *Other nonprofit organization;
If SSA_entity_typ="07" then ssacl=07 ;  *Other ;
If SSA_entity_typ="08" then ssacl=04 ;   *Estate ;
If SSA_entity_typ="09" then ssacl=09 ; *Plan administrator;
If SSA_entity_typ="10" then ssacl=04 ; *trust;;
If SSA_entity_typ="11" then ssacl=97 ;  *National Guard;
If SSA_entity_typ="12" then ssacl=12;  *Farmer's cooperative;
If SSA_entity_typ="13" then ssacl=13 ;  *REMIC(Real Estate MOrtgage Investment Conduit);
If SSA_entity_typ="14" then ssacl=92 ; * State, county or local government entities;
If SSA_entity_typ="15" then ssacl=96 ; *Federal government/ military;
If SSA_entity_typ="16" then ssacl=16 ; *Indian Tribal Governments / enterprises;
drop SSA_entity_typ;

***Recode SSA_Appl_Reason;
 If SSA_APPL_REASON="1" then ssabr=1;  *Started new business;
 If SSA_APPL_REASON="2" then ssabr=5;  *Hired employees;
 If SSA_APPL_REASON="3" then ssabr=6 ; *Created a pension plan=other;
 If SSA_APPL_REASON="4" then ssabr=6 ; *Banking Purpose=other;
If SSA_APPL_REASON="5" then ssabr=4 ; *Changed the type of organization;
If SSA_APPL_REASON="6" then ssabr=2;  *Purchased going business;
If SSA_APPL_REASON="7" then ssabr=6 ; *Created a trust=other;
If SSA_APPL_REASON="8" then ssabr=6 ;*other;
drop SSA_APPL_REASON; 
run;

data ssl&yr.su;
set work.ssl&yr.su;
**Recoding Profit/Non-profit Status(NPI);
If LFO='T' OR LFO='E'  or LFO="4" then NPI="1";
IF LFO='C' or LFO="3" THEN NPI="2";
ELSE NPI="0";
run;
data ssl&yr.su;
set work.ssl&yr.su;
npix=put(npi,1.);
run;

data ssl&yr.su;
set work.ssl&yr.su;
**Recode LFO1;
If LFO='C' OR LFO='T' THEN LFO1=0;
If LFO='S' THEN LFO1=1;
IF LFO='P' THEN LFO1=2;
IF LFO='G' THEN LFO1=5;
IF LFO='U' THEN LFO1=7;
RUN;

%let yr=2004;
data ssl&yr.su;
set work.ssl&yr.su;
IF LFO="3" OR LFO="4" THEN LFO1=8;
IF LFO="0" THEN LFO1=9;
run;

data ssl&yr.su;
set work.ssl&yr.su;
lfo1x=put(lfo1,1.);
run;

***Recoding LFO;
%let yr=2004;
data ssl&yr.su;
set work.ssl&yr.su;
drop lfo;
run;

%let yr=2004;
data ssl&yr.su;
set work.ssl&yr.su;
If lfo1x^=' ' & NPIx^=' ' then LFO=lfo1x||NPIx;
ELSE lfo=' ';
DROP lfo1x npix;
run; 

data ssl&yr.su;
set work.ssl&yr.su;
*Identify the source of the common variables;
newtractsu=newtract;
actsu=act; cfnsu=cfn; lfosu=lfo ;
naicssu=sic ; ***Note SIC variable actually contains a NAICS code;
naicssu6=substr(naicssu,1,6);
zipsu=zip; blkgeosu=blkgeo; blksfxsu=blksfx;
ctygeosu=ctygeo;  lfo1su=lfo1;
 npisu=npi; pdivsu=pdiv; plcesu=plce; plgeosu=plgeo; ppnsu=ppn;
 stgeosu=stgeo; streetsu=street; tocsu=toc; tractsu=tract; acfsu=acf;
einsu=ein;

run;


proc sort data=ssl&yr.su;
by naicssu6;
run;

data ssl&yr.su (drop = naicssu6);
merge ssl&yr.su (in=inssl) work.naicsSUtosic;
by naicssu6;
if inssl = 1;
run;


*******
%let yr=2004; 
libname BR '/economic/ssl/microdata/'; 
data ssl&yr.mu; 
set BR.ssl&yr.mu; 
run; 

 *(2) Multi-Unit File; 
************************************************************;
************************************************************;
%let yr=2004;
data ssl&yr.mu(keep=
ACF_mail 
ACF_phy
ACT
BLKGEO_mail 
BLKGEO_phy
BLKSFX_mail 
BLKSFX_phy
CFN
CTYGEO_mail 
CTYGEO_phy
EIN
GAT_mail 
GAT_phy
LFO
PDIV
PLCE_MAIL 
PLCE_PHY
PLGEO_PHY_CEN 
PLGEO_MAIL_CEN
PPN
RAP
RAPF
RECNUM
REMP
REMPF
RSR
RSRF
SIC
STGEO_MAIL  
STGEO_PHY
STREET_PHY
STREET_MAIL
TOC 
TRACT_PHY 
TRACT_MAIL
Zip_phy 
ZIP_MAIL)
;
set BR.ssl&yr.mu; 
run;

%let yr=2004; 
data ssl&yr.mu;
set work.ssl&yr.mu;

**************Creating new tract variable;

tract=TRACT_PHY;
stgeo=STGEO_PHY;
ctygeo=CTYGEO_PHY;
length NEWTRACT $ 11; 
drop tract_phy stgeo_phy ctygeo_phy;

If TRACT^=' ' & STGEO^=' ' & CTYGEO^=' ' then NEWTRACT=STGEO||CTYGEO||TRACT; 
ELSE NEWTRACT=' ';

mtract=TRACT_MAIL;
MSTGEO=STGEO_MAIL;
MCTYGEO=CTYGEO_MAIL;
drop tract_mail stgeo_mail ctygeo_mail;
length NEWTRACT $ 11; 


If mtract^=' ' & MSTGEO^=' ' & MCTYGEO^=' ' then MNEWTRACT=MSTGEO||MCTYGEO||MTRACT; 
ELSE MNEWTRACT=' ';
run;

data ssl&yr.mu; 
set ssl&yr.mu; 

**rename remaining geography variables(except stgeo ctygeo and tract);
BLKSFX=BLKSFX_mail;
PBLKSFX=BLKSFX_phy;
BLKGEO =BLKGEO_mail;
PBLKGEO=BLKGEO_phy ;         
PLCE=PLCE_MAIL;
PPLCE=PLCE_PHY;
PPLGEO=PLGEO_PHY_cen ;
PLGEO=PLGEO_mail_cen;
STREET=STREET_MAIL;
PSTREET=STREET_PHY;
PZIP=Zip_PHY;
ZIP=ZIP_mail;
ACF=ACF_mail;
pACF=ACF_phy ;
drop BLKSFX_mail BLKSFX_phy BLKGEO_mail BLKGEO_phy PLCE_MAIL PLCE_PHY PLGEO_PHY_cen
PLGEO_mail_cen STREET_MAIL STREET_PHY Zip_PHY ZIP_mail ACF_mail ACF_phy;
run;

data ssl&yr.mu; 
set ssl&yr.mu; 
**************Exclude ghosts; 
**if ACT^='G';  ***ACT code changes. I need to recode it;
**************Exclude inactive units; 
if rap>0| (rap=0 & (RAPF^='Z' & ACT^='N')); 
EMPLOYMENT=REMP; 
EMPLOYMENTmu=REMP; 
PAYROLLmu=RAP; 
salereceiptmu=RSR;	                                
mrecnum=recnum;
run;

data ssl&yr.mu;
set work.ssl&yr.mu;
**Recoding Profit/Non-profit Status(NPI);
If LFO='T' OR LFO='E'  or LFO="4" then NPI="1";
IF LFO='C' or LFO="3" THEN NPI="2";
ELSE NPI="0";
run;
data ssl&yr.mu;
set work.ssl&yr.mu;
npix=put(npi,1.);
run;

data ssl&yr.mu;
set work.ssl&yr.mu;
**Recode LFO1;
If LFO='C' OR LFO='T' THEN LFO1=0;
If LFO='S' THEN LFO1=1;
IF LFO='P' THEN LFO1=2;
IF LFO='G' THEN LFO1=5;
IF LFO='U' THEN LFO1=7;
RUN;

%let yr=2004;
data ssl&yr.mu;
set work.ssl&yr.mu;
IF LFO="3" OR LFO="4" THEN LFO1=8;
IF LFO="0" THEN LFO1=9;
run;
data ssl&yr.mu;
set work.ssl&yr.mu;
lfo1x=put(lfo1,1.);
run;

***Recoding LFO;
%let yr=2004;
data ssl&yr.mu;
set work.ssl&yr.mu;
drop lfo;
run;

%let yr=2004;
data ssl&yr.mu;
set work.ssl&yr.mu;
If lfo1x^=' ' & NPIx^=' ' then LFO=lfo1x||NPIx;
ELSE lfo=' ';
DROP lfo1x npix;
run; 

data ssl&yr.mu;
set work.ssl&yr.mu;
*Identify the source of the common variables;
newtractmu=newtract;
actmu=act; cfnmu=cfn; lfomu=lfo ;
naicsmu=sic ;  ***Note SIC variable actually contains a NAICS code;
naicsmu6=substr(naicsmu,1,6);
zipmu=zip; blkgeomu=blkgeo; blksfxmu=blksfx;
 ctygeomu=ctygeo;   lfo1mu=lfo1;
 npimu=npi; pdivmu=pdiv; plcemu=plce; plgeomu=plgeo; ppnmu=ppn;
 stgeomu=stgeo; streetmu=street; tocmu=toc; tractmu=tract; acfmu=acf;
einmu=ein;
run; 


proc sort data=ssl&yr.mu;
by naicsmu6;
run;

data ssl&yr.mu  (drop = naicsmu6);
merge ssl&yr.mu (in=inssl) work.naicsMUtosic;
by naicsmu6;
if inssl = 1;
run;



************************************************************;
************************************************************ ;
*LBD File;
************************************************************;
************************************************************;
%let yr=2004; 
libname lbd '/economic/lbd/microdata'; 
data lbd&yr.c; 
set lbd.lbd&yr.c; 
*Drop missing recnum and MU observations;
recnumx=put(recnum,8.);
MUx=put(MU,1.);
if recnumx^=' '; 
if MUx^=' ';
*Exclude submasters in LBD coming from SU file; 
if MU=0 & PDIV='M' then delete; 

/*
*Exclude inactive units;
if PAY>0;
*/

*Exclude ghosts in LBD coming from MU file; 
if ACT='G' & MU=1 then delete; 
run; 
**************Creating ind/indsub/sic56;
data lbd&yr.c; 
set work.lbd&yr.c; 
IND=substr(bestSIC,1,4);
INDSUB=substr(bestSIC,1,2);
SIC56=substr(bestSIC,5,2);
run;

**************Creating srecnum mrecnum variables in lbd file and keeping the selected variables;

%let yr=2004;
data lbd&yr.c; 
set work.lbd&yr.c; 
if MU=1 then MRECNUM=RECNUM;
if MU=0 then SRECNUM=RECNUM;
payrolllbd=pay;	
employmentlbd=emp;
 actlbd=act;
cfnlbd=cfn;
lfolbd=lfo;
siclbd=sic;
ziplbd=zip;
run;
%let yr=2004;
data work.lbd&yr.c_rec(keep= recnum srecnum mrecnum payrolllbd
employmentlbd actlbd cfnlbd lfolbd siclbd ziplbd ACT	BESTNAICs BESTSIC CFN COUNTY  EMP  FIRMID  FIRSTYEAR
FLAGA  FLAGB	LASTYEAR  LBDNUM LFO MU	PAY	RECNUM	SIC STATE YR ZIP INd indsub sic56);
set work.lbd&yr.c;
run;
**************Checking mu  in LBD;
%let yr=2004;  
proc means data=lbd&yr.c_rec;
var mu;
where mu=1;
run;

%let yr=2004;  
proc means data=lbd&yr.c_rec;
var mu;
where mu=0;
run;


**************Checking mrecnum and srecnum variables in SU-SSL and MU-SSL ;
%let yr=2004;
Proc means data=ssl&yr.mu;
var mrecnum;
run;
%let yr=2004;
Proc means data=ssl&yr.su;
var srecnum;
run;
************************************************************;
************************************************************;
*Merging SSL and LBD;
************************************************************;
************************************************************;
*************1)Combine SU SSL and LBD by srecnum;
%let yr=2004; 
proc sort data=work.lbd&yr.c_rec out=lbd04_s;
by SRECNUM;
run;

proc sort data=work.ssl&yr.su out=sussl04nt;
by SRECNUM;
run;

data work.su_ssllbd2004;
merge lbd04_s(in=one) sussl04nt(in=two);
fromlbd04_s=one;
fromsussl04nt=two;
by SRECNUM;
run;

data work.su_ssllbd2004;
set work.su_ssllbd2004;
srecnumx=put(srecnum,8.);
recnumx=put(recnum,8.);
mux=put(mu,1.);
if recnumx^=' ';
if MUx^=' ';
if srecnumx^=' ';
RUN;

data work.su_ssllbd2004;
set work.su_ssllbd2004;
ppnx=input(ppn,10.);
drop ppn;
rename ppnx=ppn;
run;

*************2)Combine MU SSL and LBD by Mrecnum;
%let yr=2004; 
proc sort data=work.lbd&yr.c_rec out=lbd04_M;
by MRECNUM;
run;

proc sort data=work.ssl&yr.mu out=mussl04nt;
by MRECNUM;
run;

data work.mu_ssllbd2004;
merge lbd04_M(in=one) mussl04nt(in=two);
fromlbd04_m=one;
frommussl04nt =two;
by MRECNUM;
run;

data work.mu_ssllbd2004;
set work.mu_ssllbd2004;
mrecnumx=put(mrecnum,8.);
recnumx=put(recnum,8.);
mux=put(mu,1.);
if recnumx^=' ';
if MUx^=' ';
if mrecnumx^=' ';
RUN;


**************3-A)Combine SU-SSLLBD &MUSSL-LBD FILES; 
%let yr=2004; 
data ssllbd&yr.;
set work.su_ssllbd2004(in=a) 
work.mu_ssllbd2004 (in=b); 

if a then SU2=1;else SU2=0; 
if b then MU2=1;else MU2=0; 
year=&yr.;
run; 
 
**Create a newfips variable;
%let yr=2004;
data ssllbd&yr;
length newfips $5;
set work.ssllbd&yr;
If ctygeo^=' ' & stgeo^= ' ' then newfips=stgeo||ctygeo;
else newfips=" ";
run;

data ssllbd&yr; 
set work.ssllbd&yr;
**Keeping the counties listed;
If newfips="01015" 
or newfips="01073"
or newfips="01097" 
or newfips="02090" 
or newfips="04013" 
or newfips="04019" 
or newfips="05069" 
or newfips="05119"
or newfips="06001" 
or newfips="06019" 
or newfips="06037"
or newfips="06059" 
or newfips="06067" 
or newfips="06073" 
or newfips="06075" 
or newfips="08001"
or newfips="08031" 
or newfips="08123"
or newfips="09001" 
or newfips="09003" 
or newfips="09009"
or newfips="10003" 
or newfips="11001" 
or newfips="12011" 
or newfips="12031" 
or newfips="12057" 
or newfips="12086"
or newfips="13051" 
or newfips="13089" 
or newfips="13095" 
or newfips="13121"
or newfips="17031"
or newfips="17143"
or newfips="17163"
or newfips="17167"
or newfips="18089"
or newfips="18097"
or newfips="19153"
or newfips="19193"
or newfips="20209"
or newfips="21111"
or newfips="22017"
or newfips="22019"
or newfips="22051"
or newfips="22071"
or newfips="22073"
or newfips="24510"
or newfips="25009"
or newfips="25013"
or newfips="25017"
or newfips="25025"
or newfips="26021"
or newfips="26049"
or newfips="26121"
or newfips="26163"
or newfips="27053"
or newfips="27123"
or newfips="28049"
or newfips="29047"
or newfips="29095"
or newfips="29165"
or newfips="29189"
or newfips="29510"
or newfips="31055"
or newfips="32003"
or newfips="33011"
or newfips="34007"
or newfips="34011"
or newfips="34013"
or newfips="34017"
or newfips="34039"
or newfips="35001"
or newfips="35013"
or newfips="36005"
or newfips="36029"
or newfips="36047"
or newfips="36055"
or newfips="36061"
or newfips="36063"
or newfips="36067"
or newfips="36071"
or newfips="36081"
or newfips="36085"
or newfips="36093"
or newfips="36119"
or newfips="37119"
or newfips="39017"
or newfips="39035"
or newfips="39045"
or newfips="39049"
or newfips="39061"
or newfips="39081"
or newfips="39087"
or newfips="39099"
or newfips="39153"
or newfips="40017"
or newfips="40027"
or newfips="40109"
or newfips="41051"
or newfips="42003"
or newfips="42043"
or newfips="42045"
or newfips="42101"
or newfips="44007"
or newfips="45019"
or newfips="45079"
or newfips="45085"
or newfips="47037"
or newfips="47065"
or newfips="47093"
or newfips="47157"
or newfips="48029"
or newfips="48085"
or newfips="48113"
or newfips="48121"
or newfips="48141"
or newfips="48157"
or newfips="48201"
or newfips="48245"
or newfips="48309"
or newfips="48355"
or newfips="48361"
or newfips="48439"
or newfips="48453"
or newfips="48491"
or newfips="49057"
or newfips="51710"
or newfips="51740"
or newfips="51760"
or newfips="53033"
or newfips="53053"
or newfips="53077"
or newfips="54009"
or newfips="54011"
or newfips="54039"
or newfips="54099"
or newfips="55079"

or newfips="01117"
or newfips="04027"
or newfips="08005"
or newfips="08059"
or newfips="08035"
or newfips="11031"
or newfips="13063"
or newfips="13135"
or newfips="13177"
or newfips="17005"
or newfips="17043"
or newfips="17097"
or newfips="18057"
or newfips="24005"
or newfips="26125"
or newfips="27003"
or newfips="27163"
or newfips="28121"
or newfips="31153"
or newfips="32009"
or newfips="35043"
or newfips="36105"
or newfips="36001"
or newfips="36079"
or newfips="37179"
or newfips="39085"
or newfips="39041"
or newfips="39025"
or newfips="39155"
or newfips="41005"
or newfips="44003"
or newfips="45063"
or newfips="47187"
or newfips="48251"
or newfips="48367"
or newfips="51810"
or newfips="51041"
or newfips="51087"
or newfips="55133";
run;


**************3-B)Eliminating EINs that appear in both the SU(not submaster)
and MU files,keeping MU information suggested by Miranda(2002);
%let yr=2004;
proc sort data=work.ssllbd&yr OUT=work.ssllbd&yr;by EIN;
proc means data=work.ssllbd&yr noprint;
by EIN;
output out=work.dups(drop=_TYPE_ _FREQ_)
n(EMPLOYMENT)=EIN_COUNT;
run;

data ssllbd&yr;
merge work.ssllbd&yr (in=a) work.dups(in=b);
by EIN;
*We are concerned about EINs that are in the SU(not submaster) and MU;
if EIN_COUNT>1 & SU2=1 & PDIV^='M' then delete;
run;

*save the merged ssllbd data;
data "/rdcprojects/mc00535/data/ssllbd/ssllbd&yr "(compress=yes);
set ssllbd&yr;
drop fromlbd04_s fromlbd04_m frommussl04nt fromsussl04nt  SU2 MU2 srecnum mrecnum EIN_COUNT ;
run;

proc datasets lib=work;
delete
dups lbd2004c lbd2004c_rec lbd04_m lbd04_s
mussl04nt sussl04nt mu_ssllbd2004 su_ssllbd2004
ssl2004mu ssl2004su ssllbd2004;
run;



******************************************YEAR:2002 ************************************************;
 *MACROS; 
%let yr=2002; 
*-—————————————————————————————; 
libname BR '/economic/ssl/microdata/'; 
data ssl&yr.su; 
set BR.ssl&yr.su; 
run; 
 
************************************************************;
************************************************************;
*(1) Single-Unit File; 
************************************************************;
************************************************************;
%let yr=2002;
data ssl&yr.su(keep=  
AC943E
AC943P
ACQP1 
ACQP2 
ACQP3 
ACQP4
ACEMP

ACF_mail 
ACF_phy
ACSR1_NET
ACSR1_INC
ACSR1_TOTINC
ACSR1_REV
ACSR1F_INC
ACSR1F_NETGAIN
ACSR1F_OTHERINC
ACSR2_RENT
ACSR2_DIRECT
Acsr2_tot
ACSR2F_INT
ACSR2F_RENT
ACSR2F_DIRECT
ACSR3_RENT
ACSR3_COSTGOOD
ACSR3F_RENT
ACSR3F_COSTGOOD
ACSR4_TOT
ACSR4F_TOT
ACT
BLKGEO_mail 
BLKGEO_phy                     
BLKSFX_mail 
BLKSFX_phy		
CFN
CTYGEO_mail 
CTYGEO_phy			
EIN
EMPCD
LFO
PDIV
PLCE_MAIL						
PLGEO_PHY_CEN 
PLGEO_MAIL_CEN      
PLCE_PHY						
PPN
STREET_PHY						
Zip_PHY    					
RECNUM
SIC
SSA_APPL_REASON
SSA_entity_typ
STGEO_mail	
STGEO_PHY					
STREET_MAIL			
TOC
TRACT_mail  
TRACT_phy			    
ZIP_mail)							
;
set BR.ssl&yr.su;
run;

%let yr=2002; 
data ssl&yr.su;
set work.ssl&yr.su;
 *************Creating new tract variable;
Ptract=TRACT_PHY;
pstgeo=STGEO_PHY;
pctygeo=CTYGEO_PHY;
length PNEWTRACT $ 11; 
drop tract_phy stgeo_phy ctygeo_phy;
length PNEWTRACT$ 11; 

If ptract^=' ' & pstgeo^=' ' & pctygeo^=' ' then pnewtract=pstgeo||pctygeo||ptract; 
ELSE PNEWTRACT=' ';

TRACT=TRACT_MAIL;
STGEO=STGEO_MAIL;
CTYGEO=CTYGEO_MAIL;
drop tract_mail stgeo_mail ctygeo_mail;
length NEWTRACT$ 11; 

If tract^=' ' & STGEO^=' ' & CTYGEO^=' ' then NEWTRACT=STGEO||CTYGEO||TRACT; 
ELSE NEWTRACT=' ';

Employmentsu=ACEMP;
Employment=ACEMP;
**rename remaining geography variables(except stgeo ctygeo and tract;
BLKSFX=BLKSFX_mail;
PBLKSFX=BLKSFX_phy;
BLKGEO =BLKGEO_mail;
PBLKGEO=BLKGEO_phy ;         
PLCE=PLCE_MAIL;
PPLCE=PLCE_PHY;
PPLGEO=PLGEO_PHY_cen ;
 PLGEO=PLGEO_mail_cen;
STREET=STREET_MAIL;
 PSTREET=STREET_PHY;
 PZIP=Zip_PHY;
 ZIP=ZIP_mail;
ACF=ACF_mail;
PACF=ACF_phy ;
drop BLKSFX_mail 
BLKSFX_phy 
BLKGEO_mail 
BLKGEO_phy 
PLCE_MAIL PLCE_PHY 
PLGEO_PHY_cen
PLGEO_mail_cen 
STREET_MAIL 
STREET_PHY 
Zip_PHY 
ZIP_mail 
ACF_mail 
ACF_phy;
*Administrative current year annual payroll;
ACAP=sum(ACQP1,ACQP2,ACQP3,ACQP4);
**************Exclude submasters; 
if PDIV^='M'; 
*Exclude inactive units; 
if ACAP>0| AC943P>0; 

payrollsu =ACAP;  
srecnum=recnum;
salereceiptsu=acsr1_net;
drop n;
*<2002 this is equal to ACSR1. ACSR1 has different categories: ACSR1_NET,ACSR1_INC,ACSR1_TOTINC,ACSR1_REV. I took ACSR1_NET instead of ASCR1;

***Recode SSA_entity_typ;
If SSA_entity_typ="01"  then ssacl=01;     *Sole proprietor;
If SSA_entity_typ="02"  then ssacl=03;     *Partnership;
If SSA_entity_typ="03" then ssacl=02;           *Corporation; 
If SSA_entity_typ="04" then ssacl=100 ;         *Personal service corporation; 
If SSA_entity_typ="05" then ssacl=101 ;                 *Church or church-controller organization ;
If SSA_entity_typ="06" then ssacl=102 ;  *Other nonprofit organization;
If SSA_entity_typ="07" then ssacl=07 ;  *Other ;
If SSA_entity_typ="08" then ssacl=04 ;   *Estate ;
If SSA_entity_typ="09" then ssacl=09 ; *Plan administrator;
If SSA_entity_typ="10" then ssacl=04 ; *trust;;
If SSA_entity_typ="11" then ssacl=97 ;  *National Guard;
If SSA_entity_typ="12" then ssacl=12;  *Farmer's cooperative;
If SSA_entity_typ="13" then ssacl=13 ;  *REMIC(Real Estate MOrtgage Investment Conduit);
If SSA_entity_typ="14" then ssacl=92 ; * State, county or local government entities;
If SSA_entity_typ="15" then ssacl=96 ; *Federal government/ military;
If SSA_entity_typ="16" then ssacl=16 ; *Indian Tribal Governments / enterprises;
drop SSA_entity_typ;

***Recode SSA_Appl_Reason;
 If SSA_APPL_REASON="1" then ssabr=1;  *Started new business;
 If SSA_APPL_REASON="2" then ssabr=5;  *Hired employees;
 If SSA_APPL_REASON="3" then ssabr=6 ; *Created a pension plan=other;
 If SSA_APPL_REASON="4" then ssabr=6 ; *Banking Purpose=other;
If SSA_APPL_REASON="5" then ssabr=4 ; *Changed the type of organization;
If SSA_APPL_REASON="6" then ssabr=2;  *Purchased going business;
If SSA_APPL_REASON="7" then ssabr=6 ; *Created a trust=other;
If SSA_APPL_REASON="8" then ssabr=6 ;*other;
drop SSA_APPL_REASON; 
run;

data ssl&yr.su;
set work.ssl&yr.su;
**Recoding Profit/Non-profit Status(NPI);
If LFO='T' OR LFO='E'  or LFO="4" then NPI="1";
IF LFO='C' or LFO="3" THEN NPI="2";
ELSE NPI="0";
run;
data ssl&yr.su;
set work.ssl&yr.su;
npix=put(npi,1.);
run;

data ssl&yr.su;
set work.ssl&yr.su;
**Recode LFO1;
If LFO='C' OR LFO='T' THEN LFO1=0;
If LFO='S' THEN LFO1=1;
IF LFO='P' THEN LFO1=2;
IF LFO='G' THEN LFO1=5;
IF LFO='U' THEN LFO1=7;
RUN;

%let yr=2002;
data ssl&yr.su;
set work.ssl&yr.su;
IF LFO="3" OR LFO="4" THEN LFO1=8;
IF LFO="0" THEN LFO1=9;
run;

data ssl&yr.su;
set work.ssl&yr.su;
lfo1x=put(lfo1,1.);
run;

***Recoding LFO;
%let yr=2002;
data ssl&yr.su;
set work.ssl&yr.su;
drop lfo;
run;

%let yr=2002;
data ssl&yr.su;
set work.ssl&yr.su;
If lfo1x^=' ' & NPIx^=' ' then LFO=lfo1x||NPIx;
ELSE lfo=' ';
DROP lfo1x npix;
run; 

data ssl&yr.su;
set work.ssl&yr.su;
*Identify the source of the common variables;
newtractsu=newtract;
actsu=act; cfnsu=cfn; lfosu=lfo ;
naicssu=sic ; ***Note SIC variable actually contains a NAICS code;
naicssu6=substr(naicssu,1,6);
zipsu=zip; blkgeosu=blkgeo; blksfxsu=blksfx;
ctygeosu=ctygeo;  lfo1su=lfo1;
 npisu=npi; pdivsu=pdiv; plcesu=plce; plgeosu=plgeo; ppnsu=ppn;
 stgeosu=stgeo; streetsu=street; tocsu=toc; tractsu=tract; acfsu=acf;
einsu=ein;

run;



proc sort data=ssl&yr.su;
by naicssu6;
run;

data ssl&yr.su (drop = naicssu6);
merge ssl&yr.su (in=inssl) work.naicsSUtosic;
by naicssu6;
if inssl = 1;
run;


*******
%let yr=2002; 
libname BR '/economic/ssl/microdata/'; 
data ssl&yr.mu; 
set BR.ssl&yr.mu; 
run; 

 *(2) Multi-Unit File; 
************************************************************;
************************************************************;
%let yr=2002;
data ssl&yr.mu(keep=
ACF_mail 
ACF_phy
ACT
BLKGEO_mail 
BLKGEO_phy
BLKSFX_mail 
BLKSFX_phy
CFN
CTYGEO_mail 
CTYGEO_phy
EIN
GAT_mail 
GAT_phy
LFO
PDIV
PLCE_MAIL 
PLCE_PHY
PLGEO_PHY_CEN 
PLGEO_MAIL_CEN
PPN
RAP
RAPF
RECNUM
REMP
REMPF
RSR
RSRF
SIC
STGEO_MAIL  
STGEO_PHY
STREET_PHY
STREET_MAIL
TOC 
TRACT_PHY 
TRACT_MAIL
Zip_phy 
ZIP_MAIL)
;
set BR.ssl&yr.mu; 
run;

%let yr=2002; 
data ssl&yr.mu;
set work.ssl&yr.mu;

**************Creating new tract variable;

tract=TRACT_PHY;
stgeo=STGEO_PHY;
ctygeo=CTYGEO_PHY;
length NEWTRACT $ 11; 
drop tract_phy stgeo_phy ctygeo_phy;

If TRACT^=' ' & STGEO^=' ' & CTYGEO^=' ' then NEWTRACT=STGEO||CTYGEO||TRACT; 
ELSE NEWTRACT=' ';

mtract=TRACT_MAIL;
MSTGEO=STGEO_MAIL;
MCTYGEO=CTYGEO_MAIL;
drop tract_mail stgeo_mail ctygeo_mail;
length NEWTRACT $ 11; 


If mtract^=' ' & MSTGEO^=' ' & MCTYGEO^=' ' then MNEWTRACT=MSTGEO||MCTYGEO||MTRACT; 
ELSE MNEWTRACT=' ';
run;

data ssl&yr.mu; 
set ssl&yr.mu; 

**rename remaining geography variables(except stgeo ctygeo and tract);
BLKSFX=BLKSFX_mail;
PBLKSFX=BLKSFX_phy;
BLKGEO =BLKGEO_mail;
PBLKGEO=BLKGEO_phy ;         
PLCE=PLCE_MAIL;
PPLCE=PLCE_PHY;
PPLGEO=PLGEO_PHY_cen ;
PLGEO=PLGEO_mail_cen;
STREET=STREET_MAIL;
PSTREET=STREET_PHY;
PZIP=Zip_PHY;
ZIP=ZIP_mail;
ACF=ACF_mail;
pACF=ACF_phy ;
drop BLKSFX_mail BLKSFX_phy BLKGEO_mail BLKGEO_phy PLCE_MAIL PLCE_PHY PLGEO_PHY_cen
PLGEO_mail_cen STREET_MAIL STREET_PHY Zip_PHY ZIP_mail ACF_mail ACF_phy;
run;

data ssl&yr.mu; 
set ssl&yr.mu; 
**************Exclude ghosts; 
**if ACT^='G';  ***ACT code changes. I need to recode it;
**************Exclude inactive units; 
if rap>0| (rap=0 & (RAPF^='Z' & ACT^='N')); 
EMPLOYMENT=REMP; 
EMPLOYMENTmu=REMP; 
PAYROLLmu=RAP; 
salereceiptmu=RSR;	                                
mrecnum=recnum;
run;

data ssl&yr.mu;
set work.ssl&yr.mu;
**Recoding Profit/Non-profit Status(NPI);
If LFO='T' OR LFO='E'  or LFO="4" then NPI="1";
IF LFO='C' or LFO="3" THEN NPI="2";
ELSE NPI="0";
run;
data ssl&yr.mu;
set work.ssl&yr.mu;
npix=put(npi,1.);
run;

data ssl&yr.mu;
set work.ssl&yr.mu;
**Recode LFO1;
If LFO='C' OR LFO='T' THEN LFO1=0;
If LFO='S' THEN LFO1=1;
IF LFO='P' THEN LFO1=2;
IF LFO='G' THEN LFO1=5;
IF LFO='U' THEN LFO1=7;
RUN;

%let yr=2002;
data ssl&yr.mu;
set work.ssl&yr.mu;
IF LFO="3" OR LFO="4" THEN LFO1=8;
IF LFO="0" THEN LFO1=9;
run;
data ssl&yr.mu;
set work.ssl&yr.mu;
lfo1x=put(lfo1,1.);
run;

***Recoding LFO;
%let yr=2002;
data ssl&yr.mu;
set work.ssl&yr.mu;
drop lfo;
run;

%let yr=2002;
data ssl&yr.mu;
set work.ssl&yr.mu;
If lfo1x^=' ' & NPIx^=' ' then LFO=lfo1x||NPIx;
ELSE lfo=' ';
DROP lfo1x npix;
run; 

data ssl&yr.mu;
set work.ssl&yr.mu;
*Identify the source of the common variables;
newtractmu=newtract;
actmu=act; cfnmu=cfn; lfomu=lfo ;
naicsmu=sic ; ***Note SIC variable actually contains a NAICS code;
naicsmu6=substr(naicsmu,1,6);
zipmu=zip; blkgeomu=blkgeo; blksfxmu=blksfx;
 ctygeomu=ctygeo;   lfo1mu=lfo1;
 npimu=npi; pdivmu=pdiv; plcemu=plce; plgeomu=plgeo; ppnmu=ppn;
 stgeomu=stgeo; streetmu=street; tocmu=toc; tractmu=tract; acfmu=acf;
einmu=ein;
run; 


proc sort data=ssl&yr.mu;
by naicsmu6;
run;

data ssl&yr.mu  (drop = naicsmu6);
merge ssl&yr.mu (in=inssl) work.naicsMUtosic;
by naicsmu6;
if inssl = 1;
run;


************************************************************;
************************************************************ ;
*LBD File;
************************************************************;
************************************************************;
%let yr=2002; 
libname lbd '/economic/lbd/microdata'; 
data lbd&yr.c; 
set lbd.lbd&yr.c; 
*Drop missing recnum and MU observations;
recnumx=put(recnum,8.);
MUx=put(MU,1.);
if recnumx^=' '; 
if MUx^=' ';
*Exclude submasters in LBD coming from SU file; 
if MU=0 & PDIV='M' then delete; 

/*
*Exclude inactive units;
if PAY>0;
*/

*Exclude ghosts in LBD coming from MU file; 
if ACT='G' & MU=1 then delete; 
run; 
**************Creating ind/indsub/sic56;
data lbd&yr.c; 
set work.lbd&yr.c; 
IND=substr(bestSIC,1,4);
INDSUB=substr(bestSIC,1,2);
SIC56=substr(bestSIC,5,2);
run;

**************Creating srecnum mrecnum variables in lbd file and keeping the selected variables;

%let yr=2002;
data lbd&yr.c; 
set work.lbd&yr.c; 
if MU=1 then MRECNUM=RECNUM;
if MU=0 then SRECNUM=RECNUM;
payrolllbd=pay;	
employmentlbd=emp;
 actlbd=act;
cfnlbd=cfn;
lfolbd=lfo;
siclbd=sic;
ziplbd=zip;
run;
%let yr=2002;
data work.lbd&yr.c_rec(keep= recnum srecnum mrecnum payrolllbd
employmentlbd actlbd cfnlbd lfolbd siclbd ziplbd ACT	BESTNAICs BESTSIC CFN COUNTY  EMP  FIRMID  FIRSTYEAR
FLAGA  FLAGB	LASTYEAR  LBDNUM LFO MU	PAY	RECNUM	SIC STATE YR ZIP INd indsub sic56);
set work.lbd&yr.c;
run;
**************Checking mu  in LBD;
%let yr=2002;  
proc means data=lbd&yr.c_rec;
var mu;
where mu=1;
run;

%let yr=2002;  
proc means data=lbd&yr.c_rec;
var mu;
where mu=0;
run;


**************Checking mrecnum and srecnum variables in SU-SSL and MU-SSL ;
%let yr=2002;
Proc means data=ssl&yr.mu;
var mrecnum;
run;
%let yr=2002;
Proc means data=ssl&yr.su;
var srecnum;
run;
************************************************************;
************************************************************;
*Merging SSL and LBD;
************************************************************;
************************************************************;
*************1)Combine SU SSL and LBD by srecnum;
%let yr=2002; 
proc sort data=work.lbd&yr.c_rec out=lbd02_s;
by SRECNUM;
run;

proc sort data=work.ssl&yr.su out=sussl02nt;
by SRECNUM;
run;

data work.su_ssllbd2002;
merge lbd02_s(in=one) sussl02nt(in=two);
fromlbd02_s=one;
fromsussl02nt=two;
by SRECNUM;
run;

data work.su_ssllbd2002;
set work.su_ssllbd2002;
srecnumx=put(srecnum,8.);
recnumx=put(recnum,8.);
mux=put(mu,1.);
if recnumx^=' ';
if MUx^=' ';
if srecnumx^=' ';
RUN;

data work.su_ssllbd2002;
set work.su_ssllbd2002;
ppnx=input(ppn,10.);
drop ppn;
rename ppnx=ppn;
run;

*************2)Combine MU SSL and LBD by Mrecnum;
%let yr=2002; 
proc sort data=work.lbd&yr.c_rec out=lbd02_M;
by MRECNUM;
run;

proc sort data=work.ssl&yr.mu out=mussl02nt;
by MRECNUM;
run;

data work.mu_ssllbd2002;
merge lbd02_M(in=one) mussl02nt(in=two);
fromlbd02_m=one;
frommussl02nt =two;
by MRECNUM;
run;

data work.mu_ssllbd2002;
set work.mu_ssllbd2002;
mrecnumx=put(mrecnum,8.);
recnumx=put(recnum,8.);
mux=put(mu,1.);
if recnumx^=' ';
if MUx^=' ';
if mrecnumx^=' ';
RUN;


**************3-A)Combine SU-SSLLBD &MUSSL-LBD FILES; 
%let yr=2002; 
data ssllbd&yr.;
set work.su_ssllbd2002(in=a) 
work.mu_ssllbd2002 (in=b); 

if a then SU2=1;else SU2=0; 
if b then MU2=1;else MU2=0; 
year=&yr.;
run; 
 
**Create a newfips variable;
%let yr=2002;
data ssllbd&yr;
length newfips $5;
set work.ssllbd&yr;
If ctygeo^=' ' & stgeo^= ' ' then newfips=stgeo||ctygeo;
else newfips=" ";
run;

data ssllbd&yr; 
set work.ssllbd&yr;
**Keeping the counties listed;
If newfips="01015" 
or newfips="01073"
or newfips="01097" 
or newfips="02090" 
or newfips="04013" 
or newfips="04019" 
or newfips="05069" 
or newfips="05119"
or newfips="06001" 
or newfips="06019" 
or newfips="06037"
or newfips="06059" 
or newfips="06067" 
or newfips="06073" 
or newfips="06075" 
or newfips="08001"
or newfips="08031" 
or newfips="08123"
or newfips="09001" 
or newfips="09003" 
or newfips="09009"
or newfips="10003" 
or newfips="11001" 
or newfips="12011" 
or newfips="12031" 
or newfips="12057" 
or newfips="12086"
or newfips="13051" 
or newfips="13089" 
or newfips="13095" 
or newfips="13121"
or newfips="17031"
or newfips="17143"
or newfips="17163"
or newfips="17167"
or newfips="18089"
or newfips="18097"
or newfips="19153"
or newfips="19193"
or newfips="20209"
or newfips="21111"
or newfips="22017"
or newfips="22019"
or newfips="22051"
or newfips="22071"
or newfips="22073"
or newfips="24510"
or newfips="25009"
or newfips="25013"
or newfips="25017"
or newfips="25025"
or newfips="26021"
or newfips="26049"
or newfips="26121"
or newfips="26163"
or newfips="27053"
or newfips="27123"
or newfips="28049"
or newfips="29047"
or newfips="29095"
or newfips="29165"
or newfips="29189"
or newfips="29510"
or newfips="31055"
or newfips="32003"
or newfips="33011"
or newfips="34007"
or newfips="34011"
or newfips="34013"
or newfips="34017"
or newfips="34039"
or newfips="35001"
or newfips="35013"
or newfips="36005"
or newfips="36029"
or newfips="36047"
or newfips="36055"
or newfips="36061"
or newfips="36063"
or newfips="36067"
or newfips="36071"
or newfips="36081"
or newfips="36085"
or newfips="36093"
or newfips="36119"
or newfips="37119"
or newfips="39017"
or newfips="39035"
or newfips="39045"
or newfips="39049"
or newfips="39061"
or newfips="39081"
or newfips="39087"
or newfips="39099"
or newfips="39153"
or newfips="40017"
or newfips="40027"
or newfips="40109"
or newfips="41051"
or newfips="42003"
or newfips="42043"
or newfips="42045"
or newfips="42101"
or newfips="44007"
or newfips="45019"
or newfips="45079"
or newfips="45085"
or newfips="47037"
or newfips="47065"
or newfips="47093"
or newfips="47157"
or newfips="48029"
or newfips="48085"
or newfips="48113"
or newfips="48121"
or newfips="48141"
or newfips="48157"
or newfips="48201"
or newfips="48245"
or newfips="48309"
or newfips="48355"
or newfips="48361"
or newfips="48439"
or newfips="48453"
or newfips="48491"
or newfips="49057"
or newfips="51710"
or newfips="51740"
or newfips="51760"
or newfips="53033"
or newfips="53053"
or newfips="53077"
or newfips="54009"
or newfips="54011"
or newfips="54039"
or newfips="54099"
or newfips="55079"

or newfips="01117"
or newfips="04027"
or newfips="08005"
or newfips="08059"
or newfips="08035"
or newfips="11031"
or newfips="13063"
or newfips="13135"
or newfips="13177"
or newfips="17005"
or newfips="17043"
or newfips="17097"
or newfips="18057"
or newfips="24005"
or newfips="26125"
or newfips="27003"
or newfips="27163"
or newfips="28121"
or newfips="31153"
or newfips="32009"
or newfips="35043"
or newfips="36105"
or newfips="36001"
or newfips="36079"
or newfips="37179"
or newfips="39085"
or newfips="39041"
or newfips="39025"
or newfips="39155"
or newfips="41005"
or newfips="44003"
or newfips="45063"
or newfips="47187"
or newfips="48251"
or newfips="48367"
or newfips="51810"
or newfips="51041"
or newfips="51087"
or newfips="55133";
run;


**************3-B)Eliminating EINs that appear in both the SU(not submaster)
and MU files,keeping MU information suggested by Miranda(2002);
%let yr=2002;
proc sort data=work.ssllbd&yr OUT=work.ssllbd&yr;by EIN;
proc means data=work.ssllbd&yr noprint;
by EIN;
output out=work.dups(drop=_TYPE_ _FREQ_)
n(EMPLOYMENT)=EIN_COUNT;
run;

data ssllbd&yr;
merge work.ssllbd&yr (in=a) work.dups(in=b);
by EIN;
*We are concerned about EINs that are in the SU(not submaster) and MU;
if EIN_COUNT>1 & SU2=1 & PDIV^='M' then delete;
run;

*save the merged ssllbd data;
data "/rdcprojects/mc00535/data/ssllbd/ssllbd&yr "(compress=yes);
set ssllbd&yr;
drop fromlbd02_s fromlbd02_m frommussl02nt fromsussl02nt  SU2 MU2 srecnum mrecnum EIN_COUNT ;
run;

proc datasets lib=work;
delete
dups lbd2002c lbd2002c_rec lbd02_m lbd02_s
mussl02nt sussl02nt mu_ssllbd2002 su_ssllbd2002
ssl2002mu ssl2002su ssllbd2002;
run;
