%let homedir = /rdcprojects/mc00535;
libname DATADIR "&homedir/data/ssllbd";
libname GEODIR "&homedir/data/geocoding/Address Data";

%macro loops;

%do year = 1987 %to 2001;
%if (1987<=&year & &year<=1988) %then %let keepvars = yr lbdnum street plce stgeo zip       newfips mu
                                           pstreet pplce pst pzip flagb payrolllbd;
%if (1989<=&year & &year<=1991) %then %let keepvars = yr lbdnum street plce stgeo zip       newfips mu
                                           pstreet pplce pst pzip
                                           mstreet mplce mst mzip flagb payrolllbd;
%if (1992<=&year & &year<=2001) %then %let keepvars = yr lbdnum street plce stgeo zip tract newfips mu
                                           pstreet pplce pst pzip
                                           mstreet mplce mst mzip flagb payrolllbd;
%if (2002<=&year & &year<=2004) %then %let keepvars = yr lbdnum street plce stgeo zip tract newfips mu
                                           pstreet pplce     pzip flagb payrolllbd;
%if &year <=1991 %then %let dropvars = stgeo samplecounty payrolllbd ;
%if &year >=1992 %then %let dropvars = stgeo samplecounty tract payrolllbd ;


/*--- Create a customer address data set. --------------------------*/
data GEODIR.addresses&year (drop = &dropvars rename = (street=bstreet plce=bplce stgeo_abbr=bst zip=bzip zip5=bzip5));
set DATADIR.ssllbd&year (keep = &keepvars );

 tract_ssl = "           ";
%if &year>=1992 %then %do;
 tract_ssl = tract;
%end;

 zip5 = substr(zip,1,5);
 pzip5 = substr(pzip,1,5);
%if &year>=1989 & &year<=2001 %then %do;
 mzip5 = substr(mzip,1,5);
%end;

 if stgeo = "01" then stgeo_abbr = "AL";
 if stgeo = "02" then stgeo_abbr = "AK";
 if stgeo = "04" then stgeo_abbr = "AZ";
 if stgeo = "05" then stgeo_abbr = "AR";
 if stgeo = "06" then stgeo_abbr = "CA";
 if stgeo = "08" then stgeo_abbr = "CO";
 if stgeo = "09" then stgeo_abbr = "CT";
 if stgeo = "10" then stgeo_abbr = "DE";
 if stgeo = "11" then stgeo_abbr = "DC";
 if stgeo = "12" then stgeo_abbr = "FL";
 if stgeo = "13" then stgeo_abbr = "GA";
 if stgeo = "17" then stgeo_abbr = "IL";
 if stgeo = "18" then stgeo_abbr = "IN";
 if stgeo = "19" then stgeo_abbr = "IA";
 if stgeo = "20" then stgeo_abbr = "KS";
 if stgeo = "21" then stgeo_abbr = "KT";
 if stgeo = "22" then stgeo_abbr = "LA";
 if stgeo = "24" then stgeo_abbr = "MD";
 if stgeo = "25" then stgeo_abbr = "MA";
 if stgeo = "26" then stgeo_abbr = "MI";
 if stgeo = "27" then stgeo_abbr = "MN";
 if stgeo = "28" then stgeo_abbr = "MS";
 if stgeo = "29" then stgeo_abbr = "MO";
 if stgeo = "31" then stgeo_abbr = "NE";
 if stgeo = "32" then stgeo_abbr = "NV";
 if stgeo = "33" then stgeo_abbr = "NH";
 if stgeo = "34" then stgeo_abbr = "NJ";
 if stgeo = "35" then stgeo_abbr = "NM";
 if stgeo = "36" then stgeo_abbr = "NY";
 if stgeo = "37" then stgeo_abbr = "NC";
 if stgeo = "39" then stgeo_abbr = "OH";
 if stgeo = "40" then stgeo_abbr = "OK";
 if stgeo = "41" then stgeo_abbr = "OR";
 if stgeo = "42" then stgeo_abbr = "PA";
 if stgeo = "44" then stgeo_abbr = "RI";
 if stgeo = "45" then stgeo_abbr = "SC";
 if stgeo = "47" then stgeo_abbr = "TN";
 if stgeo = "48" then stgeo_abbr = "TX";
 if stgeo = "49" then stgeo_abbr = "UT";
 if stgeo = "51" then stgeo_abbr = "VA";
 if stgeo = "53" then stgeo_abbr = "WA";
 if stgeo = "54" then stgeo_abbr = "WV";
 if stgeo = "55" then stgeo_abbr = "WI";

%if &year >= 2002 %then %do;
if mu = 0 then pst = stgeo_abbr;
%end;

samplecounty = 0;
if newfips = "01015" then samplecounty = 1;
if newfips = "01073" then samplecounty = 1;
if newfips = "01097" then samplecounty = 1;
if newfips = "04013" then samplecounty = 1;
if newfips = "04019" then samplecounty = 1;
if newfips = "05069" then samplecounty = 1;
if newfips = "05119" then samplecounty = 1;
if newfips = "06001" then samplecounty = 1;
if newfips = "06019" then samplecounty = 1;
if newfips = "06037" then samplecounty = 1;
if newfips = "06059" then samplecounty = 1;
if newfips = "06067" then samplecounty = 1;
if newfips = "06073" then samplecounty = 1;
if newfips = "06075" then samplecounty = 1;
if newfips = "08001" then samplecounty = 1;
if newfips = "08031" then samplecounty = 1;
if newfips = "08123" then samplecounty = 1;
if newfips = "09001" then samplecounty = 1;
if newfips = "09003" then samplecounty = 1;
if newfips = "09009" then samplecounty = 1;
if newfips = "10003" then samplecounty = 1;
if newfips = "11001" then samplecounty = 1;
if newfips = "12011" then samplecounty = 1;
if newfips = "12025" then samplecounty = 1;

*** Handle change in Fips Code in Dade/Miami-Dade County;
if newfips = "12025" then newfips = "12086";  

if newfips = "12031" then samplecounty = 1;
if newfips = "12057" then samplecounty = 1;
if newfips = "12086" then samplecounty = 1;
if newfips = "13051" then samplecounty = 1;
if newfips = "13089" then samplecounty = 1;
if newfips = "13095" then samplecounty = 1;
if newfips = "13121" then samplecounty = 1;
if newfips = "17031" then samplecounty = 1;
if newfips = "17143" then samplecounty = 1;
if newfips = "17163" then samplecounty = 1;
if newfips = "17167" then samplecounty = 1;
if newfips = "18089" then samplecounty = 1;
if newfips = "18097" then samplecounty = 1;
if newfips = "19153" then samplecounty = 1;
if newfips = "19193" then samplecounty = 1;
if newfips = "20209" then samplecounty = 1;
if newfips = "21111" then samplecounty = 1;
if newfips = "22017" then samplecounty = 1;
if newfips = "22019" then samplecounty = 1;
if newfips = "22051" then samplecounty = 1;
if newfips = "22071" then samplecounty = 1;
if newfips = "22073" then samplecounty = 1;
if newfips = "24510" then samplecounty = 1;
if newfips = "25009" then samplecounty = 1;
if newfips = "25013" then samplecounty = 1;
if newfips = "25017" then samplecounty = 1;
if newfips = "25025" then samplecounty = 1;
if newfips = "26049" then samplecounty = 1;
if newfips = "26121" then samplecounty = 1;
if newfips = "26163" then samplecounty = 1;
if newfips = "27053" then samplecounty = 1;
if newfips = "27123" then samplecounty = 1;
if newfips = "28049" then samplecounty = 1;
if newfips = "29095" then samplecounty = 1;
if newfips = "29189" then samplecounty = 1;
if newfips = "29510" then samplecounty = 1;
if newfips = "31055" then samplecounty = 1;
if newfips = "32003" then samplecounty = 1;
if newfips = "33011" then samplecounty = 1;
if newfips = "34007" then samplecounty = 1;
if newfips = "34011" then samplecounty = 1;
if newfips = "34013" then samplecounty = 1;
if newfips = "34017" then samplecounty = 1;
if newfips = "34039" then samplecounty = 1;
if newfips = "35001" then samplecounty = 1;
if newfips = "35013" then samplecounty = 1;
if newfips = "36005" then samplecounty = 1;
if newfips = "36029" then samplecounty = 1;
if newfips = "36047" then samplecounty = 1;
if newfips = "36055" then samplecounty = 1;
if newfips = "36061" then samplecounty = 1;
if newfips = "36063" then samplecounty = 1;
if newfips = "36067" then samplecounty = 1;
if newfips = "36081" then samplecounty = 1;
if newfips = "36085" then samplecounty = 1;
if newfips = "36093" then samplecounty = 1;
if newfips = "36119" then samplecounty = 1;
if newfips = "37119" then samplecounty = 1;
if newfips = "39017" then samplecounty = 1;
if newfips = "39035" then samplecounty = 1;
if newfips = "39049" then samplecounty = 1;
if newfips = "39061" then samplecounty = 1;
if newfips = "39087" then samplecounty = 1;
if newfips = "39099" then samplecounty = 1;
if newfips = "39153" then samplecounty = 1;
if newfips = "40109" then samplecounty = 1;
if newfips = "41051" then samplecounty = 1;
if newfips = "42003" then samplecounty = 1;
if newfips = "42043" then samplecounty = 1;
if newfips = "42045" then samplecounty = 1;
if newfips = "42101" then samplecounty = 1;
if newfips = "44007" then samplecounty = 1;
if newfips = "45019" then samplecounty = 1;
if newfips = "45079" then samplecounty = 1;
if newfips = "45085" then samplecounty = 1;
if newfips = "47037" then samplecounty = 1;
if newfips = "47065" then samplecounty = 1;
if newfips = "47093" then samplecounty = 1;
if newfips = "47157" then samplecounty = 1;
if newfips = "48029" then samplecounty = 1;
if newfips = "48113" then samplecounty = 1;
if newfips = "48141" then samplecounty = 1;
if newfips = "48201" then samplecounty = 1;
if newfips = "48245" then samplecounty = 1;
if newfips = "48355" then samplecounty = 1;
if newfips = "48439" then samplecounty = 1;
if newfips = "48453" then samplecounty = 1;
if newfips = "49057" then samplecounty = 1;
if newfips = "51710" then samplecounty = 1;
if newfips = "51740" then samplecounty = 1;
if newfips = "51760" then samplecounty = 1;
if newfips = "53033" then samplecounty = 1;
if newfips = "53053" then samplecounty = 1;
if newfips = "53077" then samplecounty = 1;
if newfips = "54011" then samplecounty = 1;
if newfips = "54039" then samplecounty = 1;
if newfips = "55079" then samplecounty = 1;
if samplecounty = 1;

run;

%end;
%mend;

%loops;



