**** Include savastata macro for exporting to stata;
%include "/public/programs/sas/savastata.mac";

%let InDat01 = "/rdcprojects/mc1/mc00535/data/geocoding/Address Data/02-LongitudinalImp/blocks_lbdnums_01.sas7bdat";
%let InDat23 = "/rdcprojects/mc1/mc00535/data/geocoding/Address Data/02-LongitudinalImp/blocks_lbdnums_23.sas7bdat";
%let InDat456 = "/rdcprojects/mc1/mc00535/data/geocoding/Address Data/02-LongitudinalImp/blocks_lbdnums_456.sas7bdat";
%let InDat789 = "/rdcprojects/mc1/mc00535/data/geocoding/Address Data/02-LongitudinalImp/blocks_lbdnums_789.sas7bdat";

%let outstata = /rdcprojects/mc1/mc00535/data/geocoding/Address Data/03-FinalGeoFiles/;

libname outgeo "/rdcprojects/mc1/mc00535/data/geocoding/Address Data/03-FinalGeoFiles/";

data outgeo.blocks_lbdnums;
set &indat01 &indat23 &indat456 &indat789 ;
run;

proc sort data = outgeo.blocks_lbdnums;
by lbdnum yr ;
run;

%macro loops;
%do yr = 1987 %to 2004;
data work.temp (keep = yr lbdnum matchtypenum blockid_imp_f blockid tractid);
set outgeo.blocks_lbdnums;
if yr = &yr;
run;
%savastata ("&outstata./blocks_lbdnums&yr..dta", -replace -quotes);
%end;
%mend;


%loops;


