clear
set more off
set matsize 800
set mem 2700m

local indatadir = "/rdcprojects/mc1/mc00535/data/Basic_Extract/CountyFiles"
local outdatadir = "/rdcprojects/mc1/mc00535/data/Basic_Extract/Geocode_IPWs"

local fips1 = "01015"
local fips2 = "01073"
local fips3 = "01097"
local fips4 = "04013"
local fips5 = "04019"
local fips6 = "05069"
local fips7 = "05119"
local fips8 = "06001"
local fips9 = "06019"
local fips10 = "06037"
local fips11 = "06059"
local fips12 = "06067"
local fips13 = "06073"
local fips14 = "06075"
local fips15 = "08001"
local fips16 = "08031"
local fips17 = "08123"
local fips18 = "09001"
local fips19 = "09003"
local fips20 = "09009"
local fips21 = "10003"
local fips22 = "11001"
local fips23 = "12011"
local fips24 = "12031"
local fips25 = "12057"
local fips26 = "12086"
local fips27 = "13051"
local fips28 = "13089"
local fips29 = "13095"
local fips30 = "13121"
local fips31 = "17031"
local fips32 = "17143"
local fips33 = "17163"
local fips34 = "17167"
local fips35 = "18089"
local fips36 = "18097"
local fips37 = "19153"
local fips38 = "19193"
local fips39 = "20209"
local fips40 = "21111"
local fips41 = "22017"
local fips42 = "22019"
local fips43 = "22051"
local fips44 = "22071"
local fips45 = "22073"
local fips46 = "24510"
local fips47 = "25009"
local fips48 = "25013"
local fips49 = "25017"
local fips50 = "25025"
local fips51 = "26049"
local fips52 = "26121"
local fips53 = "26163"
local fips54 = "27053"
local fips55 = "27123"
local fips56 = "28049"
local fips57 = "29095"
local fips58 = "29189"
local fips59 = "29510"
local fips60 = "31055"
local fips61 = "32003"
local fips62 = "33011"
local fips63 = "34007"
local fips64 = "34011"
local fips65 = "34013"
local fips66 = "34017"
local fips67 = "34039"
local fips68 = "35001"
local fips69 = "35013"
local fips70 = "36005"
local fips71 = "36029"
local fips72 = "36047"
local fips73 = "36055"
local fips74 = "36061"
local fips75 = "36063"
local fips76 = "36067"
local fips77 = "36081"
local fips78 = "36085"
local fips79 = "36093"
local fips80 = "36119"
local fips81 = "37119"
local fips82 = "39017"
local fips83 = "39035"
local fips84 = "39049"
local fips85 = "39061"
local fips86 = "39087"
local fips87 = "39099"
local fips88 = "39153"
local fips89 = "40109"
local fips90 = "41051"
local fips91 = "42003"
local fips92 = "42043"
local fips93 = "42045"
local fips94 = "42101"
local fips95 = "44007"
local fips96 = "45019"
local fips97 = "45079"
local fips98 = "45085"
local fips99 = "47037"
local fips100 = "47065"
local fips101 = "47093"
local fips102 = "47157"
local fips103 = "48029"
local fips104 = "48113"
local fips105 = "48141"
local fips106 = "48201"
local fips107 = "48245"
local fips108 = "48355"
local fips109 = "48439"
local fips110 = "48453"
local fips111 = "49057"
local fips112 = "51710"
local fips113 = "51740"
local fips114 = "51760"
local fips115 = "53033"
local fips116 = "53053"
local fips117 = "53077"
local fips118 = "54011"
local fips119 = "54039"
local fips120 = "55079"

forval ii = 1/120 {

use `indatadir'/county_extract`fips`ii''.dta

keep if mu!= .
keep if bestsslzip != ""


***** Create categorical employment variable;
gen empcat = .
replace empcat = 0 if employment==.
replace empcat = 1 if inrange(employment,0,99)==1
replace empcat = 2 if inrange(employment,100,249)==1
replace empcat = 3 if inrange(employment,250,499)==1
replace empcat = 4 if inrange(employment,500,999)==1
replace empcat = 5 if employment >= 1000 & employment<.
label define empcatlab 0 "Missing Employment" 1 "1-99" 2 "100-249" 3 "250-499" 4 "500-999" 5 ">= 1000"
label values empcat empcatlab


***** Calculate establishment age
gen age = yr-firstyear


**** Create dummy variables for employment cats, age cats, industries, and most populous zips
qui tab empcat, gen(empdum)
qui tab age, gen(agedum)



**** Create Dummy Variables identifying major industries
**** Define major industries
gen indsub = (ind-mod(ind,100))/100 if ind!=.
gen majorind = 11
replace majorind =  1 if inrange(indsub,1,9)==1
replace majorind =  2 if inrange(indsub,10,14)==1
replace majorind =  3 if inrange(indsub,15,17)==1
replace majorind =  4 if inrange(indsub,20,39)==1
replace majorind =  5 if inrange(indsub,40,49)==1
replace majorind =  6 if inrange(indsub,50,51)==1
replace majorind =  7 if inrange(indsub,52,59)==1
replace majorind =  8 if inrange(indsub,60,67)==1
replace majorind =  9 if inrange(indsub,70,88)==1
replace majorind = 10 if inrange(indsub,90,99)==1

label define majindlab 1 "Aggriculture, Forrestry, Fishing" /*
*/    2 "Mining" /*
*/    3 "Construction" /*
*/    4 "Manufacturing" /*
*/    5 "Transportation, Public Utilities" /*
*/    6 "Retail Trade" /*
*/    7 "Wholesale Trade" /*
*/    8 "Finance, Insurance, R.E. Institutions" /*
*/    9 "Services" /*
*/    10 "Other/Govt" /*
*/    11 "Missing"

label values majorind majindlab
qui tab majorind, gen(inddum)




**** Create variable defining categories of year-mu combinations
egen yearmu = group(yr mu) if yr!=.


**** Flag observations with nonmissing tract identifiers
gen tractnonmiss = 0
replace tractnonmiss = 1 if length(tractid)==11&substr(tractid,6,1)!=" "


**** Construct IPWs
gen geocode_ipw = .
forval yrmu=1/36 {
qui logit tractnonmiss empdum* agedum* inddum* if yearmu==`yrmu'
predict p_hat if yearmu==`yrmu'
replace geocode_ipw = 1/p_hat if yearmu==`yrmu'
drop p_hat
}

keep newfips yr mu majorind empcat age geocode_ipw
bysort newfips yr mu majorind empcat age: keep if _n==1
tempfile temp`ii'
save `temp`ii''

**clear
}


local ii = 1
use `temp`ii''

forval ii = 2/120 {
append using `temp`ii''
}


ren newfips county90
replace county90 = "12025" if county90=="12086"

sort county90 yr mu majorind empcat age yr geocode_ipw


save `outdatadir'/County-Year_Multivariate_Geocode_IPWs.dta, replace


*** Merge vars for Matias
*** county90 yr mu empcat age majorind

