**** This code extracts a set of flags from the SSL and the LBD and saves them as a stata file.
**** Written by: Jesse.

libname BR '/economic/ssl/microdata/'; 
libname LBD '/economic/lbd/microdata/';

**** Include savastata macro for exporting to stata;
%include "/public/programs/sas/savastata.mac";
%let sslkeep_vars_su = CFL WGT GSC ASMF SCE;
%let sslkeep_vars_mu = CFL WGT GSC ASMF SCE;
%let lbdkeep_vars = FIRSTFLAG LASTFLAG FLAG_i CENFLAG;

%macro loops;
%do yr = 1987 %to 2004;

data ssl&yr.su (keep = mu recnum &sslkeep_vars_su );
set BR.ssl&yr.su;
mu = 0;
run;

data ssl&yr.mu (keep = mu recnum &sslkeep_vars_mu );
%if (&yr = 1988) or (&yr = 1988) %then %do;
set BR.ssl&yr.mu_cbp;
%end;
%else %do;
set BR.ssl&yr.mu;
%end;
mu = 0;
run;

data lbd&yr (keep = lbdnum yr mu recnum &lbdkeep_vars );
set LBD.lbd&yr.c;
run;

proc sort data = ssl&yr.su;
by mu recnum;
run;

proc sort data = ssl&yr.mu;
by mu recnum;
run;

proc sort data = lbd&yr;
by mu recnum;
run;

data work.merged&yr ( keep = lbdnum yr &lbdkeep_vars &sslkeep_vars_su &sslkeep_vars_mu );
merge lbd&yr ssl&yr.su ssl&yr.mu;
by mu recnum;
run;

data work.merged&yr;
set work.merged&yr;
run;
%savastata ("/rdcprojects/mc1/mc00535/data/ssllbd/flags_&yr..dta" , -replace -quotes);
run;
%end;
%mend;
%loops;

