**** This do file merges the LBD/SSL with the flags and the geocodes.
**** Written by: Matias.

clear
set mem 4G

global dir = "/rdcprojects/mc1/mc00535/data/ssllbd/"
global geo = "/rdcprojects/mc1/mc00535/data/geocoding/Address Data/03-FinalGeoFiles/"

forvalues year = 1987(1)2004{
	** FLAGS
	use "$dir/flags_`year'.dta", clear
	keep if lbdnum!=""
	sort lbdnum
	tempfile flag
	save `flag', replace
	
	** GEOCODES
	use "$geo/blocks_lbdnums`year'.dta", clear
	
	label var tractid "Tract 2000 (Source: Geocoding)" 
	label var blockid "Block 2000 (Source: Geocoding)"
	label var blockid_imp_f "Block 2000 Imputed (Source: Geocoding)"
	label var matchtypenum " ... (Source: Geocoding)"
	drop yr
	drop if lbdnum==""
	sort lbdnum
	tempfile geo
	save `geo', replace
	
	** SSL-LBD
	use "$dir/ssllbd`year'_proc.dta", clear
	keep if lbdnum!=""
	sort lbdnum
	joinby lbdnum using `flag', unmatched(both)
	tab _m
	drop if _merge==2
	drop _m
	
	** MERGES
	sort lbdnum
	joinby lbdnum using `geo', unmatched(both)
	tab _m
	drop if _merge==2
	
	** CLEAN
	gen     geocode_status = 0 if _merge==1
	replace geocode_status = 1 if _merge==3
	label var geocode_status "1 if successfully geocoded"
	
	drop _merge
	
	duplicates drop
	duplicates tag lbdnum, gen(tag)
	drop if tag>0
	drop tag
	sort lbdnum yr
	compress
        save "$dir/ssllbd`year'_all.dta", replace
}







