**** This do file describe the content of the LBD/SSL. It builds a codebook.
**** Written by: Matias.

clear 
set mem 4G
set more off

global dir = "/rdcprojects/mc1/mc00535/data/ssllbd/"

log using "$dir/description_ssllbd_all.log", text replace

forvalues year = 1987(1)2004{
	di " "
	di " "
	di " "

        use "$dir/ssllbd`year'_all.dta", clear
	
	**************************************************
	di " "
	di "THIS IS THE CODEBOOK FOR `year'"
	di " "
	**************************************************
	
	di " "
	di " "
	**************************************************
        *** List of Variables
	**************************************************
        de, simple
	
	di " "
	di " "
	**************************************************
	*** Codebook
	**************************************************
	codebook, tabulate(15) problems detail
	
	di " "
	di " "
	**************************************************
	*** Compare
	**************************************************
	compare cfn_ssl cfn_lbd
	compare lfo_ssl lfo_lbd
	compare act_ssl act_lbd
	compare fips_ssl fips_lbd
	compare fips_ssl newfips
	compare newfips  fips_lbd
	compare sic_lbd bestsic_lbd
	compare sic_lbd sic_ssl
	
	di " "
	di " "
	**************************************************
	*** Sum
	**************************************************
	reg payroll_ssl payroll_lbd
	sum payroll_ssl payroll_lbd
	
	reg employment_lbd employment_ssl
	sum employment_lbd employment_ssl
	
	di " "
	di " "
	**************************************************
	*** Tab flags
	**************************************************
	tab flaga
	tab flagb
	tab firstflag
	tab lastflag


	tab matchtypenum
	tab blockid_imp_f
	tab geocode_status

	cap tab flag_i
          if _rc==0 tab flag_i
	cap tab cenflag
          if _rc==0 tab cenflag
	cap tab sce
          if _rc==0 tab sce
	cap tab cfl
          if _rc==0 tab cfl
	cap tab asmf
          if _rc==0 tab asmf
	cap tab gsc
          if _rc==0 tab gsc
}

log close



