**** This do file creates variables in the LBD/SSL using its panel structure.
clear
set more off
global dir = "/rdcprojects/mc1/mc00535/data/ssllbd/"
cap log close
log using "5_LBD_vars`num'.log", replace

/*
set mem 1G
use "$dir/LBD_4programming.dta", clear
*/

forvalues num = 0(1)9{
 set mem 10G
 use "$dir/LBD.dta" if lbdnum_lastdig=="`num'", clear

 ** Drop unnecesary vars
   drop matchtypenum blockid_imp_f geocode_status

 ** Drop firms with no information
   ** drop firms with no employment
   replace employment = . if employment ==0
   drop if employment==.
   egen meanL = mean(employment), by(lbdnum)
   drop if meanL==.
   drop meanL

   replace wagebill = . if wagebill==0
   drop if wagebill==.
   egen meanW = mean(wagebill), by(lbdnum)
   drop if meanW==.
   drop meanW

   ** drop firms with wages that are too high
   gen wage=wagebill/employment
   drop if wage>10000 & wage<. 
   label var wage "Average wage"

 ** Fix Panel structure
   egen aux = max(lastyear), by(lbdnum)
   replace lastyear = aux 
   drop aux
   egen aux = min(firstyear), by(lbdnum)
   replace firstyear = aux
   drop aux

   egen first = min(year), by(lbdnum)
   replace first = firstyear if firstyear<1987
   egen last = max(year), by(lbdnum)
   replace last = lastyear if lastyear==2005

   sort lbdnum year
   egen id = group(lbdnum)
   order id year
   fillin id year

   egen aux = mean(first), by(id)
   replace firstyear = aux
   drop if year<firstyear 
   drop aux

   egen aux  = mean(last), by(id)
   replace lastyear = aux
   drop if year>lastyear
   drop aux
   drop first last _fillin

   compress
   tsset id year

   gen establishments = 1
   compress
   drop if lbdnum==""
   sort lbdnum year

 save "$dir/LBD_vars`num'.dta", replace
}



