*** This do file is the master used to build the LBD data.
*** Written by: Matias and Jesse.
*** NOTE: to run 1-3 we need to unzip the stata files in ssllbd


* Clean and label the current LBD extracts.
clear
do 01.compile_lbd.do

* Merge the LBD/SSL with the flags and the geocodes.
clear
do 02.flags_lbd.do

* Describe the content of the LBD/SSL. Build a codebook.
clear
do 03.description_all.do

* Homogenizes the LBD/SSL. Then append all years and select relevant variables.
clear
do 04.LBD.do

* Create variables in the LBD/SSL using its panel structure. We run it by last digit of the firm id.
clear
do 05.LBD_vars.do 0

clear
do 05.LBD_vars.do 1

clear
do 05.LBD_vars.do 2

clear
do 05.LBD_vars.do 3

clear
do 05.LBD_vars.do 4

clear
do 05.LBD_vars.do 5

clear
do 05.LBD_vars.do 6

clear
do 05.LBD_vars.do 7

clear
do 05.LBD_vars.do 8

clear
do 05.LBD_vars.do 9

* Take the LBD/SSL and merge it to the administrative file. Create new variables that are based on whether the firm is in an EZ or not.
clear
do 06.Create_LBD_full.do

* Make tract level birth, death, JC, JD variables. Collapse the LBD by tract.
clear
do 07.LBD_collapse.do

* Prepare the tractlevel LBD/SSL for merge with the decennial.
clear
do 08.LBD_mergeDecennial.do

* Create simpler collapsed file at annual frequency
clear
do R1.LBD_simple_annual_collapse.do
