clear mata
clear matrix
clear
version 10.1
set more off
set mem 2g
adopath ++ "/rdcprojects/mc1/mc00535/programs_organize/1.library/"

global codes  = "/rdcprojects/mc1/mc00535/programs_organize/2.data/4.BuildWork/"
run "$codes/library.ado"

cap log close
log using "$codes/logs/7.compute_dist_to_cbd.log", replace
timer clear
timer on 1

**** Create a file with just block and assigned_tract
use tractid80 mark using "$ezdata/CBD.dta", clear
joinby tractid80 using $ctrfdir/CTRF_90to80_ManyToMany.dta, unmatched(master)
collapse mark, by(tractid90)
gen cbd80=1
gen cbd90=mark==0
drop mark
tempfile cbdtracts
save `cbdtracts'



**** Merge lat and lon to powblocks ****
use "$geodir/Tract1990_XY.dta", clear
joinby tractid90 using `cbdtracts', unmatched(master)
replace cbd80=0 if cbd80==.
replace cbd90=0 if cbd90==.

ren X longitude
ren Y latitude

replace longitude = longitude/1000000
replace latitude  = latitude/1000000
replace longitude = -longitude if longitude>0

bysort cbd80: gen cbd80tractnum=_n
replace cbd80tractnum = . if cbd80 != 1
sum cbd80tractnum
local max = r(N)
gen cbd80_dist = .
forval i = 1/`max' {
    egen double cbdtract_latitude =sum( (cbd80tractnum==`i') * latitude  )
    egen double cbdtract_longitude=sum( (cbd80tractnum==`i') * longitude )
    sphdist , lat1(cbdtract_latitude) lon1(cbdtract_longitude) lat2(latitude) lon2(longitude) gen(distance)
    replace cbd80_dist =distance if distance < cbd80_dist
    drop cbdtract_latitude cbdtract_longitude distance
}
drop cbd80tractnum

bysort cbd90: gen cbd90tractnum=_n
replace cbd90tractnum = . if cbd90 != 1
sum cbd90tractnum
local max = r(N)
gen cbd90_dist = .
forval i = 1/`max' {
    egen double cbdtract_latitude =sum( (cbd90tractnum==`i') * latitude  )
    egen double cbdtract_longitude=sum( (cbd90tractnum==`i') * longitude )
    sphdist , lat1(cbdtract_latitude) lon1(cbdtract_longitude) lat2(latitude) lon2(longitude) gen(distance)
    replace cbd90_dist =distance if distance < cbd90_dist
    drop cbdtract_latitude cbdtract_longitude distance
}
drop cbd90tractnum


keep tractid90 cbd80 cbd90 cbd80_dist cbd90_dist 
save "$geodir/Tract_dist_to_Sample_County_CBDs.dta", replace



