cap program drop balance
program define balance, rclass
  syntax varlist [if], by(string) controls(string) wild(string) cluster(string) dir(string) [reps(integer 999)]
** prep
  local i=1
  global names ""
  foreach var of varlist `varlist'{
    local str = regexr("`var'","l_","")
    global names "$names `str'"
  }  
  local K: word count `varlist'
  mat A=J(`K',5,.)
  mat rownames A= $names
** non wild estimates
  foreach var of varlist `varlist'{
   if "`wild'"=="off"{
     cap drop _cluster

     qui sum `var' `if'&assigned_tract==1
     mat A[`i',1]=r(mean)
     qui sum `var' `if'&assigned_tract==0
     mat A[`i',2]=r(mean)
     qui reg `var' assigned_tract `if', cluster(`cluster')
     qui test assigned_tract
     mat A[`i',4]=r(p)
     qui bo2 `var' `controls' `if', t(`by') cluster(`cluster')
     mat A[`i',3]=e(mu0)     
     mat A[`i',5]=e(p)
   }


** wild estimates
   if "`wild'"=="on"{
     qui sum `var' `if'&assigned_tract==1
     mat A[`i',1]=r(mean)
     qui sum `var' `if'&assigned_tract==0
     mat A[`i',2]=r(mean)

     qui wild `var' `if', d(`by') reps(`reps') cluster(`cluster')
     mat A[`i',4]=e(p)

     ** Checks that the covariate on which we check balance is not among the controls
	local pos: list posof "`var'" in controls
	if `pos'==0{
	qui wild_bo `var' `controls' `if', d(`by') reps(`reps') cluster(`cluster')
	mat A[`i',3]=e(mu0)
	mat A[`i',5]=e(p)
     }
	else{
	qui bo2 `var' `controls' `if', t(`by') cluster(`cluster')
	mat A[`i',3]=e(mu0)
	mat A[`i',5]=e(p)
    }	
    }
     local ++i 
   }    
** stars
   mata{
	A = st_matrix("A")
	k = rows(A)
	S = (A[.,5]:<0.1):*J(k,1,1) + (A[.,5]:<0.05):*J(k,1,1) + (A[.,5]:<0.01):*J(k,1,1)
	S = editvalue(S,0,.)
	st_matrix("S",S)
	}
    mat A = A,S
    mat colnames A = T C Cadj praw padj starsadj
    mat list A, format(%9.3f)

** Export to a file
qui{
   preserve
   drop _all
   svmat A
   ren A1 T
   ren A2 C
   ren A3 Cadj
   ren A4 praw
   ren A5 padj
   ren A6 staradj
   gen covariate = ""
   local i = 1
   foreach c of global names{
     replace covariate = "`c'" in `i'
     local i = `i'+1
   }
   save "`dir'", replace
   restore
}
end

