*make distance to closest treated tract

cap prog drop earthdistance
prog def earthdistance
syntax varlist(min=3) [if] // arguments are: lat, long, treat
tokenize `varlist'

marksample touse

cap gen d=.

tempvar use1

gen `use1'=`3'*`touse'  // treated observations to use


mata: D=makedist("`1'", "`2'", "`use1'", "`touse'")
mata: d=rowmin(D)
mata: st_store(.,"d","`touse'",d)
end


*construct distances
*see http://www.faqs.org/faqs/geography/infosystems-faq/
*for latitude longitude craziness
*raw lat/long data is in decimal degrees
*these distances will be in miles

mata:
real matrix makedist(string scalar latvar, string scalar longvar,string scalar use1var, string scalar use2var) 
 {
	 lat_treat=st_data(.,latvar,use1var)
	 longitude_treat=st_data(.,longvar,use1var)
	 n1=rows(lat_treat)

	 lat=st_data(.,latvar,use2var)
	 longitude=st_data(.,longvar,use2var)
	 n2=rows(lat)

	 lat=lat*pi()/180
	 longitude=longitude*pi()/180
	 lat_treat=lat_treat*pi()/180
	 longitude_treat=longitude_treat*pi()/180



	 D=J(n2,n1,0)
	 R=3963 - 13*sin(lat_treat[1]) 

	for(i=1;i<=n2;i++) {
	    for(j=1;j<=n1;j++) {
		a=sin((lat[i]-lat_treat[j])/2)^2 + cos(lat[i])*cos(lat_treat[j])*sin((longitude[i]-longitude_treat[j])/2)^2
		d=(1,sqrt(a))
		c=2*asin(min(d))
		D[i,j]=R*c
	    }
	}
return(D)

}
end
