cap program drop formatvarnames
program define formatvarnames

*** Totals
replace outcome = "Total Jobs of Zone Residents Working in Zone" if outcome=="jobs_local"
replace outcome = "Total Jobs of Non-Residents Working in Zone" if outcome=="jobs_nonlocal"
replace outcome = "Total Jobs of Zone Residents Working Outside Zone" if outcome=="jobs_outside"
replace outcome = "Total Earnings of Zone Residents Working in Zone" if outcome=="earn_local"
replace outcome = "Total Earnings of Non-Residents Working in Zone" if outcome=="earn_nonlocal"
replace outcome = "Total Earnings of Zone Residents Working Outside Zone" if outcome=="earn_outside"
replace outcome = "Total Number of Households" if outcome=="hh"
replace outcome = "Total Number of Households that are Renters" if outcome=="hh_rent"
replace outcome = "Total Number of Households that are Owners" if outcome=="hh_value"
replace outcome = "Total Rents" if outcome=="Rent1"
replace outcome = "Total Value of Housing Stock" if outcome=="Value1"
replace outcome = "Number of Census Tracts in non-EZs" if outcome=="T0"
replace outcome = "Number of Census Tracts in EZs" if outcome=="T1"
replace outcome = "Number of Census Tracts" if outcome=="N"

** Index
replace outcome = "Population Index" if outcome=="popindex"
replace outcome = "Demographic Index" if outcome=="demoindex"
replace outcome = "Economic Index (Residents)" if outcome=="econindex1"
replace outcome = "Economic Index (Workers) -JTW" if outcome=="econindex2"
replace outcome = "Economic Index (Workers) -LBD" if outcome=="econindex3"
replace outcome = "Housing Index" if outcome=="housingindex"


** LBD
replace outcome = "Log (Jobs) -LBD" if outcome=="lnemplbd"
replace outcome = "Log (Establishments)" if outcome=="lnest"
replace outcome = "Log (Average Earnings per Worker) -LBD" if outcome=="lnavrgwage"
replace outcome = "Log (Jobs) -Firms present in 1992" if outcome=="lnemp_92univ"
replace outcome = "Log (Establishments) -Firms present in 1992" if outcome=="lnest_92univ"
replace outcome = "Log (Average Earnings per Worker) -Firms present in 1992" if outcome=="lnavrgwage_92univ"

replace outcome = "Log (Jobs) -Firms <5 employees" if outcome=="lnemp_less5"
replace outcome = "Log (Establishments) -Firms <5 employees" if outcome=="lnest_less5"
replace outcome = "Log (Average Earnings per Worker) -Firms <5 employees" if outcome=="lnavrgwage_less5"
replace outcome = "Log (Jobs) -Firms >5 employees" if outcome=="lnemp_more5"
replace outcome = "Log (Establishments) -Firms >5 employees" if outcome=="lnest_more5"
replace outcome = "Log (Average Earnings per Worker)-Firms >5 employees" if outcome=="lnavrgwage_more5"

replace outcome = "Log (Jobs) -Firms currently <5 employees" if outcome=="lnemp_less5now"
replace outcome = "Log (Establishments) -Firms currently <5 employees" if outcome=="lnest_less5now"
replace outcome = "Log (Average Earnings per Worker) -Firms currently <5 employees" if outcome=="lnavrgwage_less5now"
replace outcome = "Log (Jobs) -Firms currently >5 employees" if outcome=="lnemp_more5now"
replace outcome = "Log (Establishments) -Firms currently >5 employees" if outcome=="lnest_more5now"
replace outcome = "Log (Average Earnings per Worker)-Firms currently >5 employees" if outcome=="lnavrgwage_more5now"


** JTW Wages
replace outcome = "Log (Hourly Wage of Zone Residents)"  if outcome=="lnwage2"
replace outcome = "Log (Hourly Wage of Zone Workers)"     if outcome=="lnwage2_pow"
replace outcome = "Log (Hourly Wage of Zone Residents Working in Zone)" if outcome=="lnwage2_local"
replace outcome = "Log (Hourly Wage of Non-Residents Working in Zone)"  if outcome=="lnwage2_nonlocal"
replace outcome = "Log (Hourly Wage of Zone Residents Working Outside Zone)" if outcome=="lnwage2_outside"

** JTW Jobs
replace outcome = "Log (Jobs) -JTW"   if outcome=="lnjobs"
replace outcome = "Log (Zone Jobs Held by Zone Residents)" if outcome=="lnjobs_local"
replace outcome = "Log (Zone Jobs Held by Non-Residents)"  if outcome=="lnjobs_nonlocal"
replace outcome = "Log (Non-Zone Jobs Held by Zone Residents)" if outcome=="lnjobs_outside"

** Population Census
replace outcome = "Employment Rate" if outcome=="employed"
replace outcome = "Unemployment Rate" if outcome=="unemployed"
replace outcome = "Poverty Rate" if outcome=="poverty"
replace outcome = "% Households Female-headed" if outcome=="female_head"
replace outcome = "% College" if outcome=="college"
replace outcome = "% High school dropouts" if outcome=="dropout"
replace outcome = "% Black" if outcome=="black"
replace outcome = "% Hispanic" if outcome=="hisp"
replace outcome = "% Population age 65+" if outcome=="gt65"
replace outcome = "% Population age <18" if outcome=="lt18"
replace outcome = "% of Houses that are Owner Occupied" if outcome=="occshare"
replace outcome = "Log (Population)"  if outcome=="lnpop"
replace outcome = "Log (Households)" if outcome=="lnhh"

** Housing 
replace outcome = "% Houses that are Vacant" if outcome=="vacant"
replace outcome = "% Same House as Five Years Ago" if outcome=="samehouse"
replace outcome = "Log(Rent)"        if outcome=="lnrent2"
replace outcome = "Log (Rent) -unadjusted" if outcome=="lnrent2_unadjusted"
replace outcome = "Log (Rent) -adjusted" if outcome=="lnrent2_adjusted" | outcome=="lnrent2_hat"
replace outcome = "Log (Rent) -comp." if outcome=="lnrent2_comp"
replace outcome = "Log (Rent of New Residents)" if outcome=="lnrent2_new"
replace outcome = "Log (House Value)" if outcome=="lnvalue2"
replace outcome = "Log (House Value) -unadjusted" if outcome=="lnvalue2_unadjusted"
replace outcome = "Log (House Value) -adjusted" if outcome=="lnvalue2_adjusted" | outcome=="lnvalue2_hat" 
replace outcome = "Log (House Value) -comp." if outcome=="lnvalue2_comp"
replace outcome = "Log (House Value of New Residents)" if outcome=="lnvalue2_new"

** Earnings
replace outcome = "Log (Weekly Wage of Zone Residents)" if outcome=="lnwkwage2"
replace outcome = "Log (Weekly Wage of Zone Workers)" if outcome=="lnwkwage2_pow"
replace outcome = "Log (Weekly Wage of Zone Residents Working in Zone)" if outcome=="lnwkwage2_local"
replace outcome = "Log (Weekly Wage of Non-Residents Working in Zone)" if outcome=="lnwkwage2_nonlocal"
replace outcome = "Log (Weekly Wage of Zone Residents Working Outside Zone)" if outcome=="lnwkwage2_outside"
replace outcome = "Log (Annual Wage of Zone Residents)" if outcome=="lnincw2"
replace outcome = "Log (Annual Wage of Zone Workers)" if outcome=="lnincw2_pow"
replace outcome = "Log (Annual Wage of Zone Residents Working in Zone)" if outcome=="lnincw2_local"
replace outcome = "Log (Annual Wage of Non-Residents Working in Zone)" if outcome=="lnincw2_nonlocal"
replace outcome = "Log (Annual Wage of Zone Residents Working Outside Zone)" if outcome=="lnincw2_outside"
replace outcome = "Log (HH Annual Income, Wages)" if outcome=="lnhhincw2"
replace outcome = "Log (HH Annual Income, Public Assistance)" if outcome=="lnhhincp2"
replace outcome = "Log(Weekly Wage) - 0.25 Log(Rent)" if outcome=="qd"


** City
replace outcome = "Total crime / population* 100" if outcome=="crime_city"
replace outcome = "Avg. across tracts % black" if outcome=="black_city"
replace outcome = "Prop. of workers in Manufacture" if outcome=="manufacture_city"
replace outcome = "Prop. of workers in city government" if outcome=="pctgov_city"
replace outcome = "Log(City Population)" if outcome=="lnpop_city"
replace outcome = "Crime Rate" if outcome=="crimerate_city"
replace outcome = "Violent Crime" if outcome=="crime_violent"
replace outcome = "Property Crime" if outcome=="crime_property"
replace outcome = "Total Crime" if outcome=="crime_total"
replace outcome = "Pupil-Teacher Ratio" if outcome=="pupil_teacher_ratio"
replace outcome = "Log (Diploma Recipients)" if outcome=="lndiploma_recipients"
replace outcome = "% of Zone Workers Who Live in Zone" if outcome=="pct_residezone"
replace outcome = "% of Zone Workers Who Live Outside Zone" if outcome=="pct_outsidezone"

** Other
replace outcome = "Log (Hourly Wage of Zone Residents Working in Zone) -adjusted" if outcome=="lnwage2_local_hat"
replace outcome = "Log(Weekly Wage) - 0.25 Log(Rent) -adjusted" if outcome=="qd_hat"
replace outcome = "Ratio of number of 2000 households with tenure > 10 years to 1990 population" if outcome=="beta_all"
replace outcome = "Log (Weekly Wage of Zone Residents Working in Zone) -adjusted" if outcome=="lnwkwage2_local_hat"
replace outcome = "Log (Weekly Wage of Non-Residents Working in Zone) -adjusted" if outcome=="lnwkwage2_nonlocal_hat"
replace outcome = "Log (Weekly Wage of Zone Residents Working Outside Zone) -adjusted" if outcome=="lnwkwage2_outside_hat"
replace outcome = "Log (Annual Wage of Zone Residents Working in Zone) -adjusted" if outcome=="lnincw2_local_hat"

** Unimputed
replace outcome = "Log (Hourly Wage of Zone Residents Working in Zone) -No Imputation"     if outcome=="lnwage3_local"
replace outcome = "Log (Weekly Wage of Zone Residents Working in Zone) -No Imputation" if outcome=="lnwkwage3_local"
replace outcome = "Log (Annual Wage of Zone Residents Working in Zone) -No Imputation" if outcome=="lnincw3_local"
replace outcome = "Log (Weekly Wage of Zone Residents) -No Imputation" if outcome=="lnwkwage3"

** Wages
replace outcome = "Log (Hourly Wage of Zone Residents)" 			if outcome=="lnwage2_unadjusted"
replace outcome = "Log (Hourly Wage of Zone Workers)"  				if outcome=="lnwage2_pow_unadjusted"
replace outcome = "Log (Hourly Wage of Zone Residents Working in Zone)" 	if outcome=="lnwage2_local_unadjusted"
replace outcome = "Log (Hourly Wage of Non-Residents Working in Zone)"  	if outcome=="lnwage2_nonlocal_unadjusted"
replace outcome = "Log (Hourly Wage of Zone Residents Working Outside Zone)" 	if outcome=="lnwage2_outside_unadjusted"
replace outcome = "Log (Hourly Wage of Zone Residents) -adjusted" 		if outcome=="lnwage2_adjusted"
replace outcome = "Log (Hourly Wage of Zone Workers) -adjusted" 		if outcome=="lnwage2_pow_adjusted"
replace outcome = "Log (Hourly Wage of Zone Residents Working in Zone) -adjusted" if outcome=="lnwage2_local_adjusted"
replace outcome = "Log (Hourly Wage of Non-Residents Working in Zone) -adjusted" if outcome=="lnwage2_nonlocal_adjusted"
replace outcome = "Log (Hourly Wage of Zone Residents Working Outside Zone) -adjusted" if outcome=="lnwage2_outside_adjusted"

replace outcome = "Log (Weekly Wage of Zone Residents)" 			if outcome=="lnwkwage2_unadjusted"
replace outcome = "Log (Weekly Wage of Zone Workers)"  				if outcome=="lnwkwage2_pow_unadjusted"
replace outcome = "Log (Weekly Wage of Zone Residents Working in Zone)" 	if outcome=="lnwkwage2_local_unadjusted"
replace outcome = "Log (Weekly Wage of Non-Residents Working in Zone)"  	if outcome=="lnwkwage2_nonlocal_unadjusted"
replace outcome = "Log (Weekly Wage of Zone Residents Working Outside Zone)" 	if outcome=="lnwkwage2_outside_unadjusted"
replace outcome = "Log (Weekly Wage of Zone Residents) -adjusted" 		if outcome=="lnwkwage2_adjusted"
replace outcome = "Log (Weekly Wage of Zone Workers) -adjusted" 		if outcome=="lnwkwage2_pow_adjusted"
replace outcome = "Log (Weekly Wage of Zone Residents Working in Zone) -adjusted" if outcome=="lnwkwage2_local_adjusted"
replace outcome = "Log (Weekly Wage of Non-Residents Working in Zone) -adjusted" if outcome=="lnwkwage2_nonlocal_adjusted"
replace outcome = "Log (Weekly Wage of Zone Residents Working Outside Zone) -adjusted" if outcome=="lnwkwage2_outside_adjusted"

replace outcome = "Log (Annual Wage of Zone Residents)" 			if outcome=="lnincw2_unadjusted"
replace outcome = "Log (Annual Wage of Zone Workers)"  				if outcome=="lnincw2_pow_unadjusted"
replace outcome = "Log (Annual Wage of Zone Residents Working in Zone)" 	if outcome=="lnincw2_local_unadjusted"
replace outcome = "Log (Annual Wage of Non-Residents Working in Zone)"  	if outcome=="lnincw2_nonlocal_unadjusted"
replace outcome = "Log (Annual Wage of Zone Residents Working Outside Zone)" 	if outcome=="lnincw2_outside_unadjusted"
replace outcome = "Log (Annual Wage of Zone Residents) -adjusted" 		if outcome=="lnincw2_adjusted"
replace outcome = "Log (Annual Wage of Zone Workers) -adjusted" 		if outcome=="lnincw2_pow_adjusted"
replace outcome = "Log (Annual Wage of Zone Residents Working in Zone) -adjusted" if outcome=="lnincw2_local_adjusted"
replace outcome = "Log (Annual Wage of Non-Residents Working in Zone) -adjusted" if outcome=="lnincw2_nonlocal_adjusted"
replace outcome = "Log (Annual Wage of Zone Residents Working Outside Zone) -adjusted" if outcome=="lnincw2_outside_adjusted"

replace outcome = "Log(Weekly Wage) - 0.25 Log(Rent)" if outcome=="qd_unadjusted"
replace outcome = "Log(Weekly Wage) - 0.25 Log(Rent) -adjusted" if outcome=="qd_adjusted"
replace outcome = "Log (Hourly Wage of Zone Residents Working in Zone) -No Imputation" if outcome=="lnwage3_local_unadjusted"
replace outcome = "Log (Weekly Wage of Zone Residents Working in Zone) -No Imputation" if outcome=="lnwkwage3_local_unadjusted"
replace outcome = "Log (Annual Wage of Zone Residents Working in Zone) -No Imputation" if outcome=="lnincw3_local_unadjusted"
replace outcome = "Log (Hourly Wage of Zone Residents Working in Zone) -No Imputation adjusted" if outcome=="lnwage3_local_adjusted"
replace outcome = "Log (Weekly Wage of Zone Residents Working in Zone) -No Imputation adjusted" if outcome=="lnwkwage3_local_adjusted"
replace outcome = "Log (Annual Wage of Zone Residents Working in Zone) -No Imputation adjusted" if outcome=="lnincw3_local_adjusted"



end






