** This do file does all the descriptive, balance, overlap, pscores, estimation, tables 
** for all specification, for all estimation methods.
** run it in batch mode. It takes 20 minutes.
clear all
set matsize 2000
set more off
version 10.1

**SETUP***
	global REPS = 1999
	cap run "/rdcprojects/mc1/mc00535/programs_organize/3.estimation/1.setup.do"
	if _rc!=0 di in red "run 1.setup.do"
	args TYPE

/**PREP DATA***
       !mkdir "/rdcprojects/mc1/mc00535/programs_organize/3.estimation/3.workfile/"
       !cp /rdcprojects/mc1/mc00535/data/decennial/05-Output/workfile_90_fullcounties.dta     /rdcprojects/mc1/mc00535/$programs/3.estimation/$workfile/
	do "$dofiles/2.dataprep.do"
	do "$dofiles/2a.workfile_winlose.do"
	do "$dofiles/2c.workfile_percentile.do"
*/
***WINLOSE***
**OLS**
	do "$dofiles/5.estimation.do" 1 wild 0 1 winlose_gt10 wild_on
	movestuff, from(winlose) to(winlose/spec1_0_1/)
**BO**
	do "$dofiles/5.estimation.do" 1 wildbo 0 1 winlose_gt10 wild_off
	movestuffbutnotdelete, from(winlose) to(winlose/spec1_0_1/)

***PLACEBO***
	do "$dofiles/2b.workfile_placebo.do"
**OLS**
	do "$dofiles/5.estimation.do" 1 wild 0 1 placebo_gt10 wild_off
	movestuff, from(placebo) to(placebo/spec1_0_1/)

**BO**
	do "$dofiles/5.estimation.do" 1 wildbo 0 1 placebo_gt10 wild_off
	movestuffbutnotdelete, from(placebo) to(placebo/spec1_0_1/)

***noNY***
**OLS**
	do "$dofiles/5.estimation.do" 1 wild 0 1 noNY_gt10 wild_off
	movestuff, from(samplenoNY) to(samplenoNY/spec1_0_1/)

**BO**
	do "$dofiles/5.estimation.do" 1 wildbo 0 1 noNY_gt10 wild_off
	movestuffbutnotdelete, from(samplenoNY) to(samplenoNY/spec1_0_1/)

***PERCENTILE***
**OLS**
	do "$dofiles/5.estimation.do" 1 wild 0 1 percentile_gt10 wild_off
	movestuff, from(percentile) to(percentile/spec1_0_1/)

**BO**
	do "$dofiles/5.estimation.do" 1 wildbo 0 1 percentile_gt10 wild_off
	movestuffbutnotdelete, from(percentile) to(percentile/spec1_0_1/)

***REJECTED***
**OLS**
	do "$dofiles/5.estimation.do" 1 wild 0 1 rejected_gt10 wild_off
	movestuff, from(samplerejected) to(samplerejected/spec1_0_1/)
**BO**
	do "$dofiles/5.estimation.do" 1 wildbo 0 1 rejected_gt10 wild_off
	movestuffbutnotdelete, from(samplerejected) to(samplerejected/spec1_0_1/)

***SEZ***
**OLS**
	do "$dofiles/5.estimation.do" 1 wild 0 1 withSEZ_gt10 wild_off
	movestuff, from(samplewithSEZ) to(samplewithSEZ/spec1_0_1/)

**BO**
	do "$dofiles/5.estimation.do" 1 wildbo 0 1 withSEZ_gt10 wild_off
	movestuffbutnotdelete, from(samplewithSEZ) to(samplewithSEZ/spec1_0_1/)

***More Results***
	!nohup stata-se -b do 7.samplesizes.do &
	sleep 90000 //wait for pscore to finish
	!nohup stata-se -b do 8.annual_lbd_plots.do &
	sleep 60000 //wait for pscore to finish
	!nohup stata-se -b do 9.descriptive.do &
	sleep 60000 //wait for pscore to finish
	!nohup stata-se -b do 10.getCIs.do &
	sleep 60000 //wait for pscore to finish
	!nohup stata-se -b do 11.secondmoments.do &
	sleep 60000 //wait for pscore to finish

***Compile***
	!nohup stata-se -b do 12.results_to_excel.do &
	sleep 90000 //wait 1 minute for pscore to finish

**********************************************
********Clean up******************************
**********************************************
	!rm /rdcprojects/mc1/mc00535/programs_organize/3.estimation/2.results/winlose/balance*.pdf
	!rm /rdcprojects/mc1/mc00535/programs_organize/3.estimation/2.results/winlose/balance*.dta
	!rm /rdcprojects/mc1/mc00535/programs_organize/3.estimation/2.results/winlose/results*.log
	!rm /rdcprojects/mc1/mc00535/programs_organize/3.estimation/2.results/placebo/balance*.pdf
	!rm /rdcprojects/mc1/mc00535/programs_organize/3.estimation/2.results/placebo/balance*.dta
	!rm /rdcprojects/mc1/mc00535/programs_organize/3.estimation/2.results/placebo/results*.log
exit



/* Once you have the file "workfile_90_fullcounties.dta" ready, to get all the results of the paper just write this in your terminal:  "nohup stata-se -b do 0.master.do &". Then wait a day and come back */

