cap run "/rdcprojects/mc1/mc00535/programs_organize/3.estimation/1.setup.do"
if _rc!=0 di in red "run 1.setup.do"
use "$censusdir/workfile_90_fullcounties_prepped.dta" if assigned_tract!=., clear
cap drop __000000
tsset id yr
local V "commutelt25 black hisp dropout college gt65 lt18 employed poverty lnpop lnarea lnhh cbd90 cbd90_dist gdum* "
cap drop group
cap drop gdum*
egen group = group(cg)
qui tab group, gen(gdum)
set seed 12345

** Impute wages local
    foreach var in lnwage lnincw lnwkwage male_lnwage female_lnwage{
	egen `var'2_local_sma_avg=mean(`var'2_local_sma), by(tractid90)
	egen `var'2_nonlocal_sma_avg=mean(`var'2_nonlocal_sma), by(tractid90)	
	egen `var'2_outside_sma_avg=mean(`var'2_outside_sma), by(tractid90)		
	egen `var'2_pow_avg=mean(`var'2_pow), by(tractid90)
	egen `var'2_avg=mean(`var'2), by(tractid90)

	foreach year in 1980 1990 2000{
		forvalues i=0/1{   
   			cap drop imputed
   			** Unadjusted var
			qui reg `var'2_local `var'2_local_sma `var'2_nonlocal_sma `var'2_outside_sma `var'2 `var'2_pow `var'2_local_sma_avg `var'2_nonlocal_sma_avg `var'2_outside_sma_avg `var'2_avg `var'2_pow_avg `V' if year==`year' & assigned_tract==`i'
   			qui predict imputed
   			qui replace `var'2_local = imputed + e(rmse)*invnorm(uniform())  if `var'2_local==. & imputed!=. & year==`year'& assigned_tract==`i'
   			qui drop imputed
			di in ye "R2 in year `year' for `var'= " e(r2)
			if "`var'"!="male_lnwage" & "`var'"!="female_lnwage"{
				** Adjusted var
				qui reg `var'2_local_hat `var'2_local_sma `var'2_nonlocal_sma `var'2_outside_sma `var'2 `var'2_hat `var'2_pow `var'2_pow_hat `var'2_local_sma_avg `var'2_nonlocal_sma_avg `var'2_outside_sma_avg `var'2_avg `var'2_pow_avg `V' if year==`year'&assigned_tract==`i'
				qui predict imputed
				qui replace `var'2_local_hat = imputed + e(rmse)*invnorm(uniform()) if `var'2_local_hat==. & imputed!=. & year==`year'&assigned_tract==`i'
				qui drop imputed
				di in ye "R2 in year `year'  for `var'_hat= " e(r2)
			}
		}
	}
    }

** Rewinsorize and replace hourly wages
      ** Unadjusted
	replace lnwage2_local=log(.8*2.90) if lnwage2_local<log(.8*2.90)&year==1980
	replace lnwage2_local=log(40*2.90) if lnwage2_local>log(40*2.90)&lnwage2_local!=.&year==1980
	replace lnwage2_local=log(.8*3.35) if lnwage2_local<log(.8*3.35)&year==1990
	replace lnwage2_local=log(40*3.35) if lnwage2_local>log(40*3.35)&lnwage2_local!=.&year==1990
	replace lnwage2_local=log(.8*5.15) if lnwage2_local<log(.8*5.15)&year==2000
	replace lnwage2_local=log(40*5.15) if lnwage2_local>log(40*5.15)&lnwage2_local!=.&year==2000
      ** Adjusted
	replace lnwage2_local_hat=log(.8*2.90) if lnwage2_local_hat<log(.8*2.90)&year==1980
	replace lnwage2_local_hat=log(40*2.90) if lnwage2_local_hat>log(40*2.90)&lnwage2_local_hat!=.&year==1980
	replace lnwage2_local_hat=log(.8*3.35) if lnwage2_local_hat<log(.8*3.35)&year==1990
	replace lnwage2_local_hat=log(40*3.35) if lnwage2_local_hat>log(40*3.35)&lnwage2_local_hat!=.&year==1990
	replace lnwage2_local_hat=log(.8*5.15) if lnwage2_local_hat<log(.8*5.15)&year==2000
	replace lnwage2_local_hat=log(40*5.15) if lnwage2_local_hat>log(40*5.15)&lnwage2_local_hat!=.&year==2000

** Recover lags and diffs
    foreach var in lnwage lnincw lnwkwage{	
	replace d_`var'2_local  =d.`var'2_local
	replace l_`var'2_local  =l.`var'2_local
	replace l2_`var'2_local =l2.`var'2_local
	replace l_d_`var'2_local=ld.`var'2_local
	replace d_`var'2_local_hat =d.`var'2_local_hat
	replace d_`var'2_local_comp=d_`var'2_local-d_`var'2_local_hat
    }
	replace d_qd =d_lnwkwage2_local-.25*d_lnrent2
	replace d_qd_hat=d_lnwkwage2_local_hat-.25*d_lnrent2_hat

    foreach var in male_lnwage female_lnwage{	
	replace d_`var'2_local  =d.`var'2_local
	replace l_`var'2_local  =l.`var'2_local
	replace l2_`var'2_local =l2.`var'2_local
	replace l_d_`var'2_local=ld.`var'2_local
    }
drop gdum*
cap drop _merge
cap drop aux*
compress
saveold "$censusdir/workfile_90_winlose.dta", replace

