**Make Zone-wide Totals for use in Welfare Analysis**

**** setup
cap run "/rdcprojects/mc1/mc00535/programs_organize/3.estimation/1.setup.do"
if _rc!=0 di in red "run 1.setup.do"
!mkdir /rdcprojects/mc1/mc00535/programs_organize/3.estimation/2.results/winlose/descriptives/

* Total observations used in estimation
	qui run "$dofiles/3.pscore.do" 1 ols 0 1 winlose_gt10 wild_off
	tabstat assigned_tract if yr==4, statistics(N) by(assigned_tract) save
	mat N = (r(Stat1), r(Stat2), r(StatTotal))
	preserve
	drop _all
	svmat N
	ren N1 T0
	ren N2 T1
	ren N3 N
	tempfile estimation_sample
	save `estimation_sample', replace
	restore

use "/rdcprojects/mc1/mc00535/programs_organize/3.estimation/3.workfile/workfile_90_winlose.dta", clear
log using "/rdcprojects/mc1/mc00535/programs_organize/3.estimation/2.results/winlose/descriptives/totals.log", replace

* Total Jobs, Earnings and Households
	keep if assigned_tract==1
	drop if (city=="Cleveland city" | city=="Los Angeles city")
	preserve
	collapse (sum) jobs_local jobs_nonlocal jobs_outside earn_local earn_nonlocal earn_outside hh hh_rent hh_value, by(year)
	list 
	sort year
	tempfile totals
	save `totals', replace
	restore

*Total Rent
	tabstat rent2 [aw=hh_rent] if assigned_tract==1, by(year) statistic(sum) nototal format(%11.0f) save
	mat Rent = (r(Stat1), r(Stat2), r(Stat3))'
	preserve
	drop _all
	svmat Rent
	gen year = 1980 in 1
	replace year = 1990 in 2
	replace year = 2000 in 3
	sort year
	tempfile rent
	save `rent', replace
	restore

*Total Value
	tabstat value2 [aw=hh_value] if assigned_tract==1, by(year) statistic(sum) nototal format(%11.0f) save
	mat Value = (r(Stat1), r(Stat2), r(Stat3))'
	preserve
	drop _all
	svmat Value
	gen year = 1980 in 1
	replace year = 1990 in 2
	replace year = 2000 in 3
	sort year
	tempfile value
	save `value', replace
	restore

* Merge all and save
	use `totals', clear
	merge 1:1 year using `rent'
	drop _m
	sort year
	merge 1:1 year using `value'
	drop _m
	merge using `estimation_sample'
	drop _m
	sort year
	save "/rdcprojects/mc1/mc00535/programs_organize/3.estimation/2.results/winlose/descriptives/totals.dta", replace

log close


